import { InjectionToken } from '@angular/core';
import { HttpErrorResponse, HttpHeaders, HttpRequest, HttpResponse } from '@angular/common/http';
export interface IApiConfiguration {
    host?: string;
    tokenHeader?: string;
    customHeaders?: (args?: {
        url?: string;
    }) => HttpHeaders;
    beforeRemote?: (request: HttpRequest<any>) => void | Promise<void>;
    afterRemote?: (response: HttpResponse<any> | HttpErrorResponse) => void | Promise<void>;
    translate?: (value: string) => string;
}
export declare const API_CONFIG: InjectionToken<IApiConfiguration>;
export declare const TOKEN: string;
