import { EventEmitter } from '@angular/core';
export declare type SdBadgeColor = 'normal' | 'primary' | 'info' | 'success' | 'warning' | 'danger';
export declare class SdBadge {
    color: SdBadgeColor | 'unknown';
    type: 'circle' | 'round' | 'icon';
    set _color(color: SdBadgeColor);
    title: string;
    description: string;
    tooltip: string;
    icon: string;
    set _icon(val: string);
    size: 'xs' | 'sm' | 'md' | 'lg';
    sdClick: EventEmitter<any>;
    onClick: (event: Event) => void;
}
