(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('@angular/material/autocomplete'), require('@angular/material/form-field'), require('@angular/material/icon'), require('@angular/material/input'), require('@angular/material/progress-spinner'), require('@angular/material/tooltip'), require('@sd-angular/core/common'), require('@sd-angular/core/translate'), require('rxjs/operators'), require('uuid'), require('object-hash'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/autocomplete', ['exports', '@angular/common', '@angular/core', '@angular/forms', '@angular/material/autocomplete', '@angular/material/form-field', '@angular/material/icon', '@angular/material/input', '@angular/material/progress-spinner', '@angular/material/tooltip', '@sd-angular/core/common', '@sd-angular/core/translate', 'rxjs/operators', 'uuid', 'object-hash', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.autocomplete = {}), global.ng.common, global.ng.core, global.ng.forms, global.ng.material.autocomplete, global.ng.material.formField, global.ng.material.icon, global.ng.material.input, global.ng.material.progressSpinner, global.ng.material.tooltip, global['sd-angular'].core.common, global['sd-angular'].core.translate, global.rxjs.operators, global.uuid, global.hash, global.rxjs));
}(this, (function (exports, common$1, core, forms, autocomplete, formField, icon, input, progressSpinner, tooltip, common, translate, operators, uuid, hash, rxjs) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    var SdAutocompleteDisplayDefDirective = /** @class */ (function () {
        function SdAutocompleteDisplayDefDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return SdAutocompleteDisplayDefDirective;
    }());
    SdAutocompleteDisplayDefDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[sdAutocompleteDisplayDef]'
                },] }
    ];
    SdAutocompleteDisplayDefDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _model, _delay, _name, _form, _itemsChanges, _validator, _subscription, _selectedItem, _cache, _item, _updateValidator, _customValidator, _getCopyText;
    var SdAutocompleteErrotStateMatcher = /** @class */ (function () {
        function SdAutocompleteErrotStateMatcher(formControl) {
            this.formControl = formControl;
        }
        SdAutocompleteErrotStateMatcher.prototype.isErrorState = function (control, form) {
            var _a, _b, _c;
            var isSubmitted = form && form.submitted;
            return !!(((_a = this.formControl) === null || _a === void 0 ? void 0 : _a.invalid) && (((_b = this.formControl) === null || _b === void 0 ? void 0 : _b.dirty) || ((_c = this.formControl) === null || _c === void 0 ? void 0 : _c.touched) || isSubmitted));
        };
        return SdAutocompleteErrotStateMatcher;
    }());
    var SdAutocomplete = /** @class */ (function () {
        function SdAutocomplete(ref, formConfig) {
            var _this = this;
            this.ref = ref;
            this.formConfig = formConfig;
            this.id = "I" + uuid.v4();
            _model.set(this, void 0);
            _delay.set(this, 0); // Sau khoảng thời gian delay nếu không có thay đổi thì thì mới bắt đầu thực hiện gọi hàm
            _name.set(this, uuid.v4());
            this.loading = false;
            this.inputControl = new common.SdFormControl();
            this.formControl = new common.SdFormControl();
            this.matcher = new SdAutocompleteErrotStateMatcher(this.formControl);
            _form.set(this, void 0);
            _itemsChanges.set(this, new rxjs.BehaviorSubject([]));
            this.limit = 100;
            this.hiddenAdd = false;
            this.action = new core.EventEmitter();
            this.modelChange = new core.EventEmitter();
            this.sdChange = new core.EventEmitter();
            this.sdAdd = new core.EventEmitter();
            this.isRequired = false;
            _validator.set(this, void 0);
            this.disableErrorMessage = false;
            _subscription.set(this, new rxjs.Subscription());
            this.isFocused = false;
            _selectedItem.set(this, void 0);
            _cache.set(this, {});
            _item.set(this, {});
            this.isTyping = false;
            this.copyable = false;
            this.copied = false;
            this.onSelect = function (item) {
                if (item) {
                    __classPrivateFieldSet(_this, _selectedItem, item);
                    if (typeof (item) === 'string' || typeof (item) === 'number') {
                        if (_this.formControl.value !== item) {
                            _this.formControl.setValue(item);
                            _this.modelChange.emit(item);
                            _this.sdChange.emit(item);
                        }
                    }
                    else if (_this.valueField && _this.displayField) {
                        var val = (item === null || item === void 0 ? void 0 : item[_this.valueField]) || null;
                        if (_this.formControl.value !== val) {
                            _this.formControl.setValue(val);
                            _this.modelChange.emit(val);
                            _this.sdChange.emit(item);
                        }
                    }
                    _this.inputControl.setValue('', {
                        emitEvent: false
                    });
                }
            };
            this.onFocus = function () {
                _this.isFocused = true;
                _this.inputControl.setValue('');
                // this.inputControl.updateValueAndValidity();
            };
            this.onBlur = function () {
                _this.isFocused = false;
                _this.inputControl.setValue('', {
                    emitEvent: false
                });
            };
            this.onClick = function () {
                var _a;
                if ((_a = _this.sdView) === null || _a === void 0 ? void 0 : _a.templateRef) {
                    if (!_this.formControl.disabled && !_this.isFocused) {
                        _this.focus();
                    }
                }
            };
            this.blur = function () {
                var _a, _b;
                (_b = (_a = _this.input) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.blur();
            };
            this.focus = function () {
                _this.isFocused = true;
                setTimeout(function () {
                    var _a, _b, _c;
                    (_a = _this.autocompleteTrigger) === null || _a === void 0 ? void 0 : _a.openPanel();
                    (_c = (_b = _this.input) === null || _b === void 0 ? void 0 : _b.nativeElement) === null || _c === void 0 ? void 0 : _c.focus();
                }, 100);
            };
            this.clear = function ($event) {
                var _a;
                $event === null || $event === void 0 ? void 0 : $event.stopPropagation();
                (_a = _this.inputControl) === null || _a === void 0 ? void 0 : _a.setValue('');
                if (__classPrivateFieldGet(_this, _model)) {
                    _this.formControl.setValue(null);
                    _this.modelChange.emit(null);
                    _this.sdChange.emit(null);
                }
            };
            this.onAction = function ($event) {
                var _a;
                $event === null || $event === void 0 ? void 0 : $event.stopPropagation();
                (_a = _this.autocompleteTrigger) === null || _a === void 0 ? void 0 : _a.closePanel();
                _this.action.emit();
            };
            this.onAdd = function ($event) {
                $event.stopPropagation();
                $event === null || $event === void 0 ? void 0 : $event.preventDefault();
                _this.sdAdd.emit();
            };
            this.reValidate = function () {
                _this.inputControl.updateValueAndValidity({ emitEvent: true });
            };
            _updateValidator.set(this, function () {
                _this.formControl.clearValidators();
                _this.formControl.clearAsyncValidators();
                var validators = [];
                var asyncValidators = [];
                // const asyncValidators: AsyncValidatorFn[] = [];
                if (_this.isRequired) {
                    validators.push(forms.Validators.required);
                }
                if (__classPrivateFieldGet(_this, _validator)) {
                    asyncValidators.push(__classPrivateFieldGet(_this, _customValidator).call(_this, __classPrivateFieldGet(_this, _validator)));
                }
                if (_this.inlineError) {
                    validators.push(_this.customInlineErrorValidator());
                }
                _this.formControl.setValidators(validators);
                _this.formControl.setAsyncValidators(asyncValidators);
                _this.formControl.updateValueAndValidity();
            }
            // Hàm tạo Validators tùy chỉnh cho inlineError
            );
            _customValidator.set(this, function (func) {
                return function (c) { return __awaiter(_this, void 0, void 0, function () {
                    var value, result, message;
                    return __generator(this, function (_d) {
                        switch (_d.label) {
                            case 0:
                                value = c.value || null;
                                if (!(func && typeof (func) === 'function')) return [3 /*break*/, 3];
                                result = func(value, __classPrivateFieldGet(this, _selectedItem));
                                if (!(result instanceof Promise)) return [3 /*break*/, 2];
                                return [4 /*yield*/, result];
                            case 1:
                                message = _d.sent();
                                if (message) {
                                    return [2 /*return*/, {
                                            customValidator: message
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 2:
                                if (result) {
                                    return [2 /*return*/, {
                                            customValidator: result
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 3: return [2 /*return*/, null];
                        }
                    });
                }); };
            });
            this.onCopyText = function (event) {
                event === null || event === void 0 ? void 0 : event.stopPropagation();
                var text = __classPrivateFieldGet(_this, _getCopyText).call(_this);
                SdUtility.copyToClipboard(text);
                _this.copied = true;
                setTimeout(function () {
                    _this.copied = false;
                    _this.ref.markForCheck();
                }, 2000);
            };
            _getCopyText.set(this, function () {
                var _a;
                var value = _this.formControl.value;
                var text = (_a = value === null || value === void 0 ? void 0 : value.toString()) !== null && _a !== void 0 ? _a : '';
                if (typeof _this.copyText === 'function') {
                    text = _this.copyText(value, __classPrivateFieldGet(_this, _selectedItem));
                }
                else if (_this.copyText) {
                    text = _this.copyText;
                }
                return text;
            });
        }
        Object.defineProperty(SdAutocomplete.prototype, "name", {
            set: function (val) {
                if (val) {
                    __classPrivateFieldSet(this, _name, val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "form", {
            set: function (val) {
                if (val) {
                    if (val instanceof forms.NgForm) {
                        __classPrivateFieldSet(this, _form, val.form);
                    }
                    else {
                        __classPrivateFieldSet(this, _form, val);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "_label", {
            set: function (val) {
                this.label = val;
                this.qcId = hash__default['default']({
                    selector: 'sd-autocomplete',
                    label: val
                });
            },
            enumerable: false,
            configurable: true
        });
        ;
        Object.defineProperty(SdAutocomplete.prototype, "items", {
            set: function (items) {
                if (!items) {
                    __classPrivateFieldGet(this, _itemsChanges).next([]);
                }
                else if (Array.isArray(items)) {
                    __classPrivateFieldGet(this, _itemsChanges).next(items.filter(function (e) { return e !== null && e !== undefined; }));
                }
                else {
                    __classPrivateFieldGet(this, _itemsChanges).next(items);
                    __classPrivateFieldSet(this, _delay, 500);
                }
                this.formControl.updateValueAndValidity();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "model", {
            set: function (value) {
                if (__classPrivateFieldGet(this, _model) !== value) {
                    __classPrivateFieldSet(this, _model, value);
                    this.formControl.setValue(value);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "disabled", {
            // Optional
            set: function (val) {
                val = (val === '') || val;
                if (val) {
                    this.inputControl.disable();
                    this.formControl.disable();
                }
                else {
                    this.inputControl.enable();
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "required", {
            set: function (val) {
                this.isRequired = (val === '') || val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "validator", {
            set: function (validator) {
                __classPrivateFieldSet(this, _validator, validator);
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "_inlineError", {
            set: function (val) {
                this.inlineError = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = (val === '') || val;
                val = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdAutocomplete.prototype, "_copyable", {
            set: function (val) {
                this.copyable = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        SdAutocomplete.prototype.ngOnInit = function () {
            var _this = this;
            var _a;
            this.appearance = this.appearance || ((_a = this.formConfig) === null || _a === void 0 ? void 0 : _a.appearance);
            __classPrivateFieldGet(this, _subscription).add(this.inputControl.touchChanges.subscribe(function () {
                _this.formControl.markAsTouched();
                _this.ref.markForCheck();
            }));
            __classPrivateFieldGet(this, _subscription).add(this.formControl.sdChanges.subscribe(function () {
                _this.ref.markForCheck();
            }));
            __classPrivateFieldGet(this, _subscription).add(this.inputControl.sdChanges.subscribe(function () {
                _this.ref.markForCheck();
            }));
            __classPrivateFieldGet(this, _subscription).add(this.inputControl.valueChanges.subscribe(function () {
                _this.isTyping = true;
            }));
            this.filteredItems = rxjs.combineLatest([
                __classPrivateFieldGet(this, _itemsChanges).asObservable(),
                this.inputControl.valueChanges.pipe(operators.debounceTime(__classPrivateFieldGet(this, _delay)))
            ]).pipe(operators.switchMap(function (_d) {
                var _e = __read(_d, 2), items = _e[0], searchText = _e[1];
                _this.isTyping = false;
                searchText = searchText || '';
                if (typeof (items) !== 'function') {
                    return items
                        .search(searchText, [_this.valueField, _this.displayField])
                        .paging(_this.limit)
                        .asObservable();
                }
                var key = hash__default['default']({
                    checksum: _this.cacheChecksum || null,
                    searchText: searchText
                });
                if (__classPrivateFieldGet(_this, _cache)[key] !== undefined) {
                    _this.isTyping = false;
                    return __classPrivateFieldGet(_this, _cache)[key].asObservable();
                }
                var obs;
                var func = items(searchText, false);
                if (func instanceof Promise) {
                    obs = rxjs.defer(function () { return rxjs.from(func); });
                }
                else {
                    obs = func;
                }
                _this.loading = true;
                _this.ref.markForCheck();
                return obs.pipe(operators.map(function (data) {
                    __classPrivateFieldGet(_this, _cache)[key] = data || [];
                    Object.assign(__classPrivateFieldGet(_this, _item), Array.toObject(__classPrivateFieldGet(_this, _cache)[key], _this.valueField));
                    return __classPrivateFieldGet(_this, _cache)[key];
                }), operators.catchError(function () { return rxjs.of([]); }), operators.finalize(function () {
                    _this.loading = false;
                    _this.ref.markForCheck();
                }));
            }));
            this.selected = rxjs.combineLatest([
                __classPrivateFieldGet(this, _itemsChanges).asObservable(),
                this.formControl.valueChanges.pipe(operators.startWith(this.formControl.value))
            ])
                .pipe(operators.switchMap(function (_d) {
                var _e = __read(_d, 1), items = _e[0];
                // Vì một số lý do chưa xác định mà khi sử dụng sdViewDef thì khi chuyển sang dạng view sẽ trigger val = null
                // Nhưng formControl.value vẫn có giá trị đúng nên thực hiện gán val = this.formControl.value;
                var val = _this.formControl.value;
                if (!_this.valueField) {
                    return rxjs.of(val);
                }
                if (val || val === 0) {
                    if (typeof (items) === 'function') {
                        if (__classPrivateFieldGet(_this, _item)[val]) {
                            return rxjs.of(__classPrivateFieldGet(_this, _item)[val]);
                        }
                        var obs = void 0;
                        var func_1 = items(val, true);
                        if (func_1 instanceof Promise) {
                            obs = rxjs.defer(function () { return rxjs.from(func_1); });
                        }
                        else {
                            obs = func_1;
                        }
                        return obs.pipe(operators.map(function (data) {
                            var _d;
                            Object.assign(__classPrivateFieldGet(_this, _item), Array.toObject(data, _this.valueField));
                            return __classPrivateFieldGet(_this, _item)[val] || (_d = {},
                                _d[_this.valueField] = val,
                                _d[_this.displayField] = val,
                                _d);
                        }), operators.catchError(function () {
                            var _d;
                            return rxjs.of((_d = {},
                                _d[_this.valueField] = val,
                                _d[_this.displayField] = val,
                                _d));
                        }), operators.finalize(function () {
                            _this.loading = false;
                            _this.ref.markForCheck();
                        }));
                    }
                    return rxjs.of(items.find(function (e) { return e[_this.valueField] === val; }));
                }
                return rxjs.of('');
            }));
            this.controlPlaceHolder = this.selected.pipe(operators.map(function (item) {
                var _a, _b, _c;
                __classPrivateFieldSet(_this, _selectedItem, item);
                return (_c = (_b = (_a = item === null || item === void 0 ? void 0 : item[_this.displayField]) !== null && _a !== void 0 ? _a : item) !== null && _b !== void 0 ? _b : _this.placeholder) !== null && _c !== void 0 ? _c : (_this.appearance ? _this.label : '');
            }));
        };
        SdAutocomplete.prototype.ngAfterViewInit = function () {
            var _a;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.addControl(__classPrivateFieldGet(this, _name), this.formControl);
        };
        SdAutocomplete.prototype.ngOnDestroy = function () {
            var _a;
            __classPrivateFieldGet(this, _subscription).unsubscribe();
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.removeControl(__classPrivateFieldGet(this, _name));
        };
        // Hàm tạo Validators tùy chỉnh cho inlineError
        SdAutocomplete.prototype.customInlineErrorValidator = function () {
            return function (control) {
                return { inlineError: true };
            };
        };
        return SdAutocomplete;
    }());
    _model = new WeakMap(), _delay = new WeakMap(), _name = new WeakMap(), _form = new WeakMap(), _itemsChanges = new WeakMap(), _validator = new WeakMap(), _subscription = new WeakMap(), _selectedItem = new WeakMap(), _cache = new WeakMap(), _item = new WeakMap(), _updateValidator = new WeakMap(), _customValidator = new WeakMap(), _getCopyText = new WeakMap();
    SdAutocomplete.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-autocomplete',
                    template: "<ng-container *ngIf=\"!appearance && sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\"> </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"!appearance && !sdLabelDef?.templateRef && label\" class=\"d-block mb-0 T14M\"\r\n  >{{ label }} <span class=\"text-danger mb-2\" *ngIf=\"isRequired\">*</span></label\r\n>\r\n<div\r\n  class=\"d-flex align-items-center\"\r\n  [class.sd-view]=\"sdView?.templateRef\"\r\n  [class.c-focused]=\"isFocused\"\r\n  [class.c-disabled]=\"formControl.disabled\"\r\n  (click)=\"onClick()\">\r\n  <ng-container *ngIf=\"sdView?.templateRef && !autocompleteTrigger?.panelOpen && !isFocused; else default\">\r\n    <ng-container *ngTemplateOutlet=\"sdView.templateRef; context: { value: formControl.value, selectedItem: selected | async }\">\r\n    </ng-container>\r\n  </ng-container>\r\n  <ng-template #default>\r\n    <mat-form-field\r\n      class=\"sd-md\"\r\n      [ngClass]=\"{ 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage }\"\r\n      [floatLabel]=\"size === 'sm' || formControl.value ? 'always' : 'auto'\"\r\n      [appearance]=\"appearance || 'outline'\">\r\n      <mat-label *ngIf=\"appearance && label\">{{ label }}</mat-label>\r\n      <input\r\n        aria-hidden=\"true\"\r\n        [id]=\"id\"\r\n        #autocompleteTrigger\r\n        [formControl]=\"inputControl\"\r\n        [placeholder]=\"controlPlaceHolder | async\"\r\n        [ngClass]=\"{ 'c-selected': formControl?.value }\"\r\n        [matAutocomplete]=\"auto\"\r\n        (focus)=\"onFocus()\"\r\n        (blur)=\"onBlur()\"\r\n        matInput\r\n        [autocomplete]=\"id\"\r\n        autocorrect=\"off\"\r\n        [errorStateMatcher]=\"matcher\"\r\n        [required]=\"isRequired\"\r\n        [attr.data-qclabel]=\"label\"\r\n        [attr.data-qcid]=\"qcId\"\r\n        #input />\r\n      <ng-content select=\"[sdSuffixIcon]\" matSuffix></ng-content>\r\n      <mat-icon\r\n        *ngIf=\"!loading && formControl?.value && !inputControl.disabled\"\r\n        class=\"pointer sd-suffix-icon\"\r\n        (click)=\"clear($event)\"\r\n        matSuffix\r\n        >cancel\r\n      </mat-icon>\r\n      <mat-icon\r\n        *ngIf=\"actionIcon && !loading && !formControl?.value && !inputControl.disabled\"\r\n        class=\"pointer sd-suffix-icon\"\r\n        (click)=\"onAction($event)\"\r\n        matSuffix\r\n        >{{ actionIcon }}\r\n      </mat-icon>\r\n      <svg\r\n        #copyTooltip=\"matTooltip\"\r\n        *ngIf=\"!loading && formControl?.value && copyable\"\r\n        matSuffix\r\n        [matTooltip]=\"copied ? 'Copied' : 'Copy'\"\r\n        class=\"icon-copy\"\r\n        focusable=\"false\"\r\n        xmlns=\"http://www.w3.org/2000/svg\"\r\n        viewBox=\"0 0 448 512\"\r\n        (click)=\"onCopyText($event)\">\r\n        <path\r\n          d=\"M433.941 65.941l-51.882-51.882A48 48 0 0 0 348.118 0H176c-26.51 0-48 21.49-48 48v48H48c-26.51 0-48 21.49-48 48v320c0 26.51 21.49 48 48 48h224c26.51 0 48-21.49 48-48v-48h80c26.51 0 48-21.49 48-48V99.882a48 48 0 0 0-14.059-33.941zM266 464H54a6 6 0 0 1-6-6V150a6 6 0 0 1 6-6h74v224c0 26.51 21.49 48 48 48h96v42a6 6 0 0 1-6 6zm128-96H182a6 6 0 0 1-6-6V54a6 6 0 0 1 6-6h106v88c0 13.255 10.745 24 24 24h88v202a6 6 0 0 1-6 6zm6-256h-64V48h9.632c1.591 0 3.117.632 4.243 1.757l48.368 48.368a6 6 0 0 1 1.757 4.243V112z\"></path>\r\n      </svg>\r\n      <i [ngClass]=\"{ 'd-none': !loading }\" class=\"fa fa-spinner fa-pulse c-loading-icon\"></i>\r\n      <mat-autocomplete #auto=\"matAutocomplete\" (optionSelected)=\"onSelect($event.option.value)\">\r\n        <ng-container *ngIf=\"filteredItems | async as items\">\r\n          <ng-container *ngIf=\"items.length\">\r\n            <mat-option\r\n              *ngFor=\"let item of items\"\r\n              [value]=\"item\"\r\n              matTooltipPosition=\"above\"\r\n              [matTooltip]=\"displayField ? item[displayField] : item\">\r\n              <ng-container *ngIf=\"autocompleteDisplayDef?.templateRef\">\r\n                <ng-container *ngTemplateOutlet=\"autocompleteDisplayDef.templateRef; context: { item: item }\"> </ng-container>\r\n              </ng-container>\r\n              <ng-container *ngIf=\"!autocompleteDisplayDef?.templateRef\">\r\n                {{ displayField ? item[displayField] : item }}\r\n              </ng-container>\r\n            </mat-option>\r\n          </ng-container>\r\n          <mat-option *ngIf=\"!items.length && inputControl.value && !isTyping && !loading\" [value]=\"\" class=\"T14R text-grey\">\r\n            Kh\u00F4ng c\u00F3 d\u1EEF li\u1EC7u\r\n          </mat-option>\r\n          <mat-option\r\n            class=\"sd__option--add\"\r\n            *ngIf=\"!hiddenAdd && sdAdd?.observers?.length\"\r\n            (keyup.Space)=\"$event.stopPropagation()\"\r\n            disabled=\"true\">\r\n            <div (click)=\"onAdd($event)\">\r\n              <mat-icon class=\"mr-1\">add</mat-icon>\r\n              {{ 'New item' | sdTranslate }}\r\n            </div>\r\n          </mat-option>\r\n        </ng-container>\r\n      </mat-autocomplete>\r\n      <mat-error *ngIf=\"formControl?.errors?.required\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ 'This field is required' | sdTranslate }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.customValidator\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ formControl.errors?.customValidator }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.inlineError\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ inlineError }}</ng-container>\r\n      </mat-error>\r\n    </mat-form-field>\r\n  </ng-template>\r\n</div>\r\n<!-- <sd-popover #error=\"sdPopover\" type=\"danger\" width=\"300px\">\r\n  <span *ngIf=\"formControl.errors?.required\">\r\n    {{ \"This field is required\" | sdTranslate }}\r\n  </span>\r\n</sd-popover> -->\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host{display:block;padding-top:5px}:host ::ng-deep .mat-form-field.no-padding-wrapper .mat-form-field-wrapper{padding-bottom:0}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{background:#f6f6f6;color:#e9e9e9}:host ::ng-deep .mat-form-field input.c-selected::-moz-placeholder{color:#000;opacity:1}:host ::ng-deep .mat-form-field input.c-selected:-ms-input-placeholder{opacity:1}:host ::ng-deep .mat-form-field input.c-selected::placeholder{color:#000;opacity:1}:host ::ng-deep .mat-form-field input.c-selected:-ms-input-placeholder{color:#000}:host ::ng-deep .mat-form-field input.c-selected::-ms-input-placeholder{color:#000}:host ::ng-deep .mat-form-field input.mat-input-element:disabled{color:#4d4d4d}:host ::ng-deep .mat-form-field input.mat-input-element:disabled.c-selected::-moz-placeholder{color:#4d4d4d}:host ::ng-deep .mat-form-field input.mat-input-element:disabled.c-selected::placeholder{color:#4d4d4d}:host ::ng-deep .mat-form-field input.mat-input-element:disabled.c-selected:-ms-input-placeholder{color:#4d4d4d}:host ::ng-deep .mat-form-field input.mat-input-element:disabled.c-selected::-ms-input-placeholder{color:#4d4d4d}:host ::ng-deep .mat-form-field .mat-placeholder-required{color:#f82c13}:host ::ng-deep .mat-form-field:hover .icon-copy{opacity:1}:host ::ng-deep .mat-form-field .icon-copy{cursor:pointer;fill:rgba(0,0,0,.5);height:.9em;opacity:0;transition:opacity .2s linear;width:.9em}.sd-view:not(.c-focused):not(.c-disabled):hover{background-color:#ebecf0}.sd__option--add{background-color:#fff;bottom:0;color:rgba(0,0,0,.87);cursor:pointer!important;position:-webkit-sticky;position:sticky;z-index:10}.c-loading-icon{position:absolute;right:5px;top:5px}"]
                },] }
    ];
    SdAutocomplete.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.FORM_CONFIG,] }, { type: core.Optional }] }
    ]; };
    SdAutocomplete.propDecorators = {
        autocompleteTrigger: [{ type: core.ViewChild, args: [autocomplete.MatAutocompleteTrigger, { read: autocomplete.MatAutocompleteTrigger },] }],
        name: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        size: [{ type: core.Input }],
        form: [{ type: core.Input }],
        _label: [{ type: core.Input, args: ['label',] }],
        valueField: [{ type: core.Input }],
        displayField: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        items: [{ type: core.Input }],
        limit: [{ type: core.Input }],
        cacheChecksum: [{ type: core.Input }],
        model: [{ type: core.Input }],
        hiddenAdd: [{ type: core.Input }],
        autocompleteDisplayDef: [{ type: core.ContentChild, args: [SdAutocompleteDisplayDefDirective,] }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }],
        actionIcon: [{ type: core.Input }],
        action: [{ type: core.Output }],
        modelChange: [{ type: core.Output }],
        sdChange: [{ type: core.Output }],
        sdAdd: [{ type: core.Output }],
        disabled: [{ type: core.Input }],
        required: [{ type: core.Input }],
        validator: [{ type: core.Input }],
        _inlineError: [{ type: core.Input, args: ['inlineError',] }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        input: [{ type: core.ViewChild, args: ['input',] }],
        sdView: [{ type: core.ContentChild, args: [common.SdViewDefDirective,] }],
        copyTooltip: [{ type: core.ViewChild, args: ['copyTooltip',] }],
        _copyable: [{ type: core.Input, args: ['copyable',] }],
        copyText: [{ type: core.Input }]
    };

    var SdAutocompleteModule = /** @class */ (function () {
        function SdAutocompleteModule() {
        }
        return SdAutocompleteModule;
    }());
    SdAutocompleteModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        input.MatInputModule,
                        tooltip.MatTooltipModule,
                        formField.MatFormFieldModule,
                        autocomplete.MatAutocompleteModule,
                        icon.MatIconModule,
                        progressSpinner.MatProgressSpinnerModule,
                        translate.SdTranslateModule,
                        common.SdCommonModule,
                    ],
                    declarations: [
                        SdAutocomplete,
                        SdAutocompleteDisplayDefDirective
                    ],
                    exports: [
                        SdAutocomplete,
                        SdAutocompleteDisplayDefDirective,
                        common.SdCommonModule
                    ],
                    providers: []
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdAutocomplete = SdAutocomplete;
    exports.SdAutocompleteDisplayDefDirective = SdAutocompleteDisplayDefDirective;
    exports.SdAutocompleteModule = SdAutocompleteModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-autocomplete.umd.js.map
