(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/icon'), require('@angular/material/tooltip')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/header-title', ['exports', '@angular/core', '@angular/common', '@angular/material/icon', '@angular/material/tooltip'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['header-title'] = {}), global.ng.core, global.ng.common, global.ng.material.icon, global.ng.material.tooltip));
}(this, (function (exports, core, common, icon, tooltip) { 'use strict';

    var SdHeaderTitleComponent = /** @class */ (function () {
        function SdHeaderTitleComponent() {
        }
        SdHeaderTitleComponent.prototype.ngOnInit = function () {
        };
        return SdHeaderTitleComponent;
    }());
    SdHeaderTitleComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-header-title',
                    template: "<div class=\"d-flex align-items-center\" style=\"width: 100%;\">\r\n  <div *ngIf=\"icon\" class=\"flex-shrink-1 c-header-icon\">\r\n    <mat-icon class=\"material-symbols-outlined text-grey\">{{icon}}</mat-icon>\r\n  </div>\r\n  <div class=\"d-flex flex-column w-100 overflow-hidden\">\r\n    <div class=\"d-flex\">\r\n      <span class=\"T16M\">{{title}}</span>\r\n      <ng-container *ngIf=\"tooltip\">\r\n        <mat-icon\r\n          [matTooltip]=\"tooltip\"\r\n          class=\"material-icons-outlined c-header-icon-tooltip\"> info </mat-icon>\r\n      </ng-container>\r\n    </div>\r\n    <span *ngIf=\"description\" class=\"c-header-description\">{{description}}</span>\r\n  </div>\r\n  <div class=\"flex-shrink-1\">\r\n    <ng-content select=\"[sdHeaderRight]\"></ng-content>\r\n  </div>\r\n</div>\r\n",
                    styles: [":host{width:100%}:host .c-header-icon{align-items:center;display:flex;height:28px;margin-right:8px;width:28px}:host .c-header-icon-tooltip{align-items:center;color:#757575;display:flex;font-size:20px;height:28px!important;margin-left:10px}:host .c-header-description{font-size:14px;line-height:20px}"]
                },] }
    ];
    SdHeaderTitleComponent.ctorParameters = function () { return []; };
    SdHeaderTitleComponent.propDecorators = {
        title: [{ type: core.Input }],
        icon: [{ type: core.Input }],
        description: [{ type: core.Input }],
        tooltip: [{ type: core.Input }]
    };

    var SdHeaderTitleModule = /** @class */ (function () {
        function SdHeaderTitleModule() {
        }
        return SdHeaderTitleModule;
    }());
    SdHeaderTitleModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        icon.MatIconModule,
                        tooltip.MatTooltipModule
                    ],
                    declarations: [SdHeaderTitleComponent],
                    exports: [SdHeaderTitleComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdHeaderTitleModule = SdHeaderTitleModule;
    exports.ɵa = SdHeaderTitleComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-header-title.umd.js.map
