(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('uuid'), require('konva'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/konva', ['exports', '@angular/core', '@angular/common', 'uuid', 'konva', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.konva = {}), global.ng.core, global.ng.common, global.uuid, global.konva, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, common, uuid, Konva, rxjs, operators) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var Konva__default = /*#__PURE__*/_interopDefaultLegacy(Konva);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _height, _width, _images, _stage, _layer, _elementRef, _onLoad, _subscription;
    var SdMergeImages = /** @class */ (function () {
        function SdMergeImages(ref) {
            var _this = this;
            this.ref = ref;
            this.id = "I" + uuid.v4();
            this.kImages = [];
            _height.set(this, void 0);
            _width.set(this, void 0);
            _images.set(this, void 0);
            _stage.set(this, void 0);
            _layer.set(this, void 0);
            this.save = new core.EventEmitter();
            _elementRef.set(this, void 0);
            _onLoad.set(this, new rxjs.Subject());
            _subscription.set(this, new rxjs.Subscription());
            this.toImage = function () { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, new Promise(function (resolve) {
                                var _a;
                                (_a = __classPrivateFieldGet(_this, _stage)) === null || _a === void 0 ? void 0 : _a.toImage({
                                    callback: function (image) {
                                        resolve(image);
                                    }
                                });
                            })];
                        case 1: return [2 /*return*/, _b.sent()];
                    }
                });
            }); };
            this.toDataUrl = function () {
                return __classPrivateFieldGet(_this, _stage).toDataURL();
            };
        }
        Object.defineProperty(SdMergeImages.prototype, "height", {
            set: function (height) {
                __classPrivateFieldSet(this, _height, +height);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdMergeImages.prototype, "width", {
            set: function (width) {
                __classPrivateFieldSet(this, _width, +width);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdMergeImages.prototype, "images", {
            set: function (images) {
                var _this = this;
                setTimeout(function () {
                    __classPrivateFieldSet(_this, _images, images);
                    __classPrivateFieldGet(_this, _onLoad).next(__classPrivateFieldGet(_this, _images));
                }, 2000);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdMergeImages.prototype, "container", {
            set: function (elementRef) {
                if (__classPrivateFieldGet(this, _elementRef) !== elementRef) {
                    __classPrivateFieldSet(this, _elementRef, elementRef);
                    __classPrivateFieldGet(this, _onLoad).next(__classPrivateFieldGet(this, _images));
                }
            },
            enumerable: false,
            configurable: true
        });
        SdMergeImages.prototype.ngOnInit = function () {
        };
        SdMergeImages.prototype.ngAfterViewInit = function () {
            var _this = this;
            __classPrivateFieldGet(this, _subscription).add(__classPrivateFieldGet(this, _onLoad).pipe(operators.startWith([])).subscribe(function () {
                var e_1, _b;
                var _a;
                if (!document.getElementById(_this.id)) {
                    return;
                }
                document.getElementById(_this.id).innerHTML = '';
                if (!((_a = __classPrivateFieldGet(_this, _images)) === null || _a === void 0 ? void 0 : _a.length)) {
                    return;
                }
                var images = __classPrivateFieldGet(_this, _images);
                __classPrivateFieldSet(_this, _stage, new Konva__default['default'].Stage({
                    container: _this.id,
                    width: __classPrivateFieldGet(_this, _width),
                    height: __classPrivateFieldGet(_this, _height)
                }));
                __classPrivateFieldSet(_this, _layer, new Konva__default['default'].Layer());
                __classPrivateFieldGet(_this, _stage).add(__classPrivateFieldGet(_this, _layer));
                var _loop_1 = function (idx, img) {
                    var x = 0;
                    var y = 0;
                    var width = __classPrivateFieldGet(_this, _width) / 2;
                    var height = __classPrivateFieldGet(_this, _height) / 2;
                    if (images.length === 1) {
                        x = __classPrivateFieldGet(_this, _width) / 4;
                        y = __classPrivateFieldGet(_this, _height) / 4;
                    }
                    else if (images.length === 2) {
                        if (idx === 0) {
                            x = 0;
                            y = __classPrivateFieldGet(_this, _height) / 4;
                        }
                        else if (idx === 1) {
                            x = __classPrivateFieldGet(_this, _width) / 2;
                            y = __classPrivateFieldGet(_this, _height) / 4;
                        }
                    }
                    else if (images.length === 3) {
                        if (idx === 0) {
                            x = 0;
                            y = 0;
                        }
                        else if (idx === 1) {
                            x = __classPrivateFieldGet(_this, _width) / 2;
                            y = 0;
                        }
                        else if (idx === 2) {
                            x = __classPrivateFieldGet(_this, _width) / 4;
                            y = __classPrivateFieldGet(_this, _height) / 4;
                        }
                    }
                    else if (images.length === 4) {
                        if (idx === 0) {
                            x = 0;
                            y = 0;
                        }
                        else if (idx === 1) {
                            x = __classPrivateFieldGet(_this, _width) / 2;
                            y = 0;
                        }
                        else if (idx === 2) {
                            x = 0;
                            y = __classPrivateFieldGet(_this, _height) / 2;
                        }
                        else if (idx === 3) {
                            x = __classPrivateFieldGet(_this, _width) / 2;
                            y = __classPrivateFieldGet(_this, _height) / 2;
                        }
                    }
                    var image = new Image();
                    var konvaImage = new Konva__default['default'].Image({
                        image: image,
                        x: x,
                        y: y,
                        width: width,
                        height: height,
                        name: 'image',
                        draggable: true,
                    });
                    _this.kImages.push(konvaImage);
                    image.onload = function () {
                        konvaImage.image(image);
                        _this.ref.detectChanges();
                    };
                    image.crossOrigin = 'Anonymous';
                    image.src = img;
                    __classPrivateFieldGet(_this, _layer).add(konvaImage);
                };
                try {
                    for (var _c = __values(images.entries()), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var _e = __read(_d.value, 2), idx = _e[0], img = _e[1];
                        _loop_1(idx, img);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                var tr = new Konva__default['default'].Transformer();
                __classPrivateFieldGet(_this, _layer).add(tr);
                // at this point basic demo is finished!!
                // we just have several transforming nodes
                __classPrivateFieldGet(_this, _layer).draw();
                _this.ref.detectChanges();
                // clicks should select/deselect shapes
                __classPrivateFieldGet(_this, _stage).on('click tap', function (e) {
                    // if click on empty area - remove all selections
                    if (e.target === __classPrivateFieldGet(_this, _stage)) {
                        tr.nodes([]);
                        __classPrivateFieldGet(_this, _layer).draw();
                        return;
                    }
                    // do nothing if clicked NOT on our rectangles
                    if (!e.target.hasName('rect') && !e.target.hasName('image')) {
                        return;
                    }
                    // do we pressed shift or ctrl?
                    var metaPressed = e.evt.shiftKey || e.evt.ctrlKey || e.evt.metaKey;
                    var isSelected = tr.nodes().indexOf(e.target) >= 0;
                    if (!metaPressed && !isSelected) {
                        // if no key pressed and the node is not selected
                        // select just one
                        tr.nodes([e.target]);
                    }
                    else if (metaPressed && isSelected) {
                        // if we pressed keys and node was selected
                        // we need to remove it from selection:
                        var nodes = tr.nodes().slice(); // use slice to have new copy of array
                        // remove node from array
                        nodes.splice(nodes.indexOf(e.target), 1);
                        tr.nodes(nodes);
                    }
                    else if (metaPressed && !isSelected) {
                        // add the node into selection
                        var nodes = tr.nodes().concat([e.target]);
                        tr.nodes(nodes);
                    }
                    __classPrivateFieldGet(_this, _layer).draw();
                });
            }));
        };
        SdMergeImages.prototype.ngOnDestroy = function () {
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        return SdMergeImages;
    }());
    _height = new WeakMap(), _width = new WeakMap(), _images = new WeakMap(), _stage = new WeakMap(), _layer = new WeakMap(), _elementRef = new WeakMap(), _onLoad = new WeakMap(), _subscription = new WeakMap();
    SdMergeImages.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-merge-images',
                    template: "<div [id]=\"id\" #container></div>",
                    styles: [":host ::ng-deep .konvajs-content{border:2px solid #dadada}"]
                },] }
    ];
    SdMergeImages.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    SdMergeImages.propDecorators = {
        height: [{ type: core.Input }],
        width: [{ type: core.Input }],
        images: [{ type: core.Input }],
        save: [{ type: core.Output }],
        container: [{ type: core.ViewChild, args: ['container',] }]
    };

    var SdKonvaModule = /** @class */ (function () {
        function SdKonvaModule() {
        }
        return SdKonvaModule;
    }());
    SdKonvaModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        SdMergeImages
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        SdMergeImages
                    ]
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdKonvaModule = SdKonvaModule;
    exports.SdMergeImages = SdMergeImages;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-konva.umd.js.map
