(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/icon')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/label', ['exports', '@angular/core', '@angular/common', '@angular/material/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.label = {}), global.ng.core, global.ng.common, global.ng.material.icon));
}(this, (function (exports, core, common, icon) { 'use strict';

    var SdLabel = /** @class */ (function () {
        function SdLabel() {
            this.fontSet = 'material-icons';
        }
        SdLabel.prototype.ngOnInit = function () {
        };
        SdLabel.prototype.ngAfterViewInit = function () {
        };
        return SdLabel;
    }());
    SdLabel.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-label',
                    template: "<div class=\"d-inline mr-2\">\r\n  <mat-icon *ngIf=\"icon\" class=\"align-middle mr-2\" [fontSet]=\"fontSet\">{{icon}}</mat-icon><span class=\"T14R\">{{label}}:</span>\r\n</div>\r\n<ng-content></ng-content>"
                },] }
    ];
    SdLabel.ctorParameters = function () { return []; };
    SdLabel.propDecorators = {
        label: [{ type: core.Input }],
        icon: [{ type: core.Input }],
        fontSet: [{ type: core.Input }]
    };

    var SdLabelModule = /** @class */ (function () {
        function SdLabelModule() {
        }
        return SdLabelModule;
    }());
    SdLabelModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        icon.MatIconModule
                    ],
                    declarations: [
                        SdLabel
                    ],
                    exports: [
                        SdLabel
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdLabelModule = SdLabelModule;
    exports.ɵa = SdLabel;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-label.umd.js.map
