(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/material/icon'), require('@angular/material/tooltip'), require('@angular/material/progress-spinner'), require('@sd-angular/core/common'), require('rxjs'), require('rxjs/operators'), require('@angular/material/select'), require('@sd-angular/core/translate'), require('@angular/material/checkbox')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/select-badge', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@angular/material/form-field', '@angular/material/input', '@angular/material/icon', '@angular/material/tooltip', '@angular/material/progress-spinner', '@sd-angular/core/common', 'rxjs', 'rxjs/operators', '@angular/material/select', '@sd-angular/core/translate', '@angular/material/checkbox'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['select-badge'] = {}), global.ng.core, global.ng.common, global.ng.forms, global.ng.material.formField, global.ng.material.input, global.ng.material.icon, global.ng.material.tooltip, global.ng.material.progressSpinner, global['sd-angular'].core.common, global.rxjs, global.rxjs.operators, global.ng.material.select, global['sd-angular'].core.translate, global.ng.material.checkbox));
}(this, (function (exports, core, common$1, forms, formField, input, icon, tooltip, progressSpinner, common, rxjs, operators, select, translate, checkbox) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _subscription, _modelChanges;
    var SdSelectBadge = /** @class */ (function () {
        function SdSelectBadge(ref) {
            var _this = this;
            this.ref = ref;
            // Items
            this.items = [];
            this.modelChange = new core.EventEmitter();
            this.sdChange = new core.EventEmitter();
            this.sdSelection = new core.EventEmitter();
            _subscription.set(this, new rxjs.Subscription());
            _modelChanges.set(this, new rxjs.Subject());
            this.isShowContent = false;
            this.onToogle = function () {
                _this.isShowContent = !_this.isShowContent;
            };
            this.onModelChange = function (val) {
                _this.modelChange.emit(val);
                _this.sdChange.emit(val);
            };
        }
        Object.defineProperty(SdSelectBadge.prototype, "model", {
            set: function (val) {
                if (this.value !== val) {
                    this.value = val;
                    __classPrivateFieldGet(this, _modelChanges).next(val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelectBadge.prototype, "_items", {
            set: function (items) {
                if (!Array.isArray(items)) {
                    this.items = [];
                }
                this.items = items;
            },
            enumerable: false,
            configurable: true
        });
        SdSelectBadge.prototype.clickout = function (event) {
            if (!this.selectbadge.nativeElement.contains(event.target)) {
                this.isShowContent = false;
            }
        };
        SdSelectBadge.prototype.ngOnInit = function () {
            var _this = this;
            __classPrivateFieldGet(this, _subscription).add(__classPrivateFieldGet(this, _modelChanges).pipe(operators.startWith(this.value)).subscribe(function () {
                var _a;
                _this.selectedItem = (_a = _this.items) === null || _a === void 0 ? void 0 : _a.find(function (e) { var _a, _b; return ((_a = _this.value) === null || _a === void 0 ? void 0 : _a.toString()) === ((_b = e === null || e === void 0 ? void 0 : e[_this.valueField]) === null || _b === void 0 ? void 0 : _b.toString()); });
            }));
        };
        SdSelectBadge.prototype.onSelected = function (item) {
            var _this = this;
            var _a;
            this.selectedItem = item;
            var emitVal = this.selectedItem[this.valueField];
            this.modelChange.emit(emitVal);
            this.sdChange.emit(emitVal);
            this.sdSelection.emit({
                value: emitVal,
                item: (_a = this.items) === null || _a === void 0 ? void 0 : _a.find(function (e) { var _a; return (emitVal === null || emitVal === void 0 ? void 0 : emitVal.toString()) === ((_a = e === null || e === void 0 ? void 0 : e[_this.valueField]) === null || _a === void 0 ? void 0 : _a.toString()); })
            });
        };
        return SdSelectBadge;
    }());
    _subscription = new WeakMap(), _modelChanges = new WeakMap();
    SdSelectBadge.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-select-badge',
                    template: "<ng-container *ngIf=\"sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\">\r\n  </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"label&&!sdLabelDef?.templateRef\" class=\"d-block mb-6 T14M\">{{label}}</label>\r\n<div #selectbadge class=\"c-selectbadge-dropdown\" (click)=\"onToogle()\">\r\n  <div class=\"c-selectbadge-dropdown__label\">\r\n    <div class=\"media align-items-center\">\r\n      <div class=\"media-body d-flex align-items-center\">\r\n        <ng-container *ngIf=\"selectedItem\">\r\n          <span class=\"c-selectbadge-icon c-badge mr-6\" [ngClass]=\"{\r\n            'material-icons-outlined': !selectedItem[iconColorField],\r\n            'material-icons-round': selectedItem[iconColorField],\r\n            'c-primary': selectedItem[iconColorField] === 'primary', \r\n            'c-black400': selectedItem[iconColorField] === 'normal', \r\n            'c-info': selectedItem[iconColorField] === 'info', \r\n            'c-success': selectedItem[iconColorField] === 'success', \r\n            'c-danger': selectedItem[iconColorField] === 'danger', \r\n            'c-warning': selectedItem[iconColorField] === 'warning'\r\n          }\">\r\n            {{selectedItem[iconField]}}\r\n          </span>\r\n          <span>{{selectedItem[displayField]}}</span>\r\n        </ng-container>\r\n      </div>\r\n      <span class=\"material-icons-outlined ml-6\">\r\n        arrow_drop_down\r\n      </span>\r\n    </div>\r\n\r\n  </div>\r\n  <div class=\"c-selectbadge-dropdown__content\" [ngClass]=\"isShowContent ? '' : 'd-none'\">\r\n    <div class=\"c-selectbadge-item media align-items-center py-12\" *ngFor=\"let item of items\"\r\n      (click)=\"onSelected(item)\">\r\n      <span class=\"c-selectbadge-icon c-badge\" [ngClass]=\"{\r\n        'material-icons-outlined': !item[iconColorField],\r\n        'material-icons-round': item[iconColorField],\r\n        'c-primary': item[iconColorField] === 'primary', \r\n        'c-black400': item[iconColorField] === 'normal', \r\n        'c-info': item[iconColorField] === 'info', \r\n        'c-success': item[iconColorField] === 'success', \r\n        'c-danger': item[iconColorField] === 'danger', \r\n        'c-warning': item[iconColorField] === 'warning'\r\n      }\">\r\n        <ng-container *ngIf=\"item[iconField]\">\r\n          {{item[iconField]}}\r\n        </ng-container>\r\n        <ng-container *ngIf=\"!item[iconField]\">\r\n          fiber_manual_record\r\n        </ng-container>\r\n      </span>\r\n\r\n      <div class=\"media-body ml-12\">\r\n        <div class=\"d-flex justify-content-between align-items-center\">\r\n          <div class=\"mr-16\">\r\n            <div class=\"c-selectbadge-item__title\">{{item[displayField]}}</div>\r\n            <div class=\"c-selectbadge-item__desc\">{{item[descriptionField]}}</div>\r\n          </div>\r\n          <span *ngIf=\"selectedItem && item[valueField] === selectedItem[valueField]\"\r\n            class=\"material-icons-outlined c-selectbadge-icon__checked\">check</span>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".text-black400{color:#757575}.c-selectbadge-dropdown{color:#5f6368;cursor:pointer;display:inline-flex;position:relative}.c-selectbadge-dropdown__label{border:1px solid #dadce0;border-radius:18px;font-weight:500;height:36px;min-width:110px;padding:4px 8px}.c-selectbadge-dropdown__label:hover{background-color:rgba(32,33,36,.059)}.c-selectbadge-dropdown__label:active{background:rgba(32,33,36,.122)}.c-selectbadge-dropdown .c-selectbadge-icon{display:inline-block;font-size:18px}.c-selectbadge-dropdown .c-selectbadge-icon__checked{color:rgba(0,0,0,.5);font-size:16px}.c-selectbadge-dropdown .c-selectbadge-icon.c-primary{color:#2962ff}.c-selectbadge-dropdown .c-selectbadge-icon.c-black400{color:#757575}.c-selectbadge-dropdown .c-selectbadge-icon.c-info{color:#2962ff}.c-selectbadge-dropdown .c-selectbadge-icon.c-warning{color:#ff9600}.c-selectbadge-dropdown .c-selectbadge-icon.c-success{color:#4caf50}.c-selectbadge-dropdown .c-selectbadge-icon.c-danger{color:#f82c13}.c-selectbadge-dropdown__content{background-color:#fff;border-radius:3px;box-shadow:0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12),0 5px 5px -3px rgba(0,0,0,.2);display:block;left:0;min-width:160px;min-width:256px;padding:12px 0;position:absolute;top:36px;z-index:9}.c-selectbadge-dropdown__content .c-selectbadge-item{padding:16px 12px}.c-selectbadge-dropdown__content .c-selectbadge-item:hover{background-color:#eee;outline:1px dashed transparent}.c-selectbadge-dropdown__content .c-selectbadge-item__desc{color:rgba(0,0,0,.5);font-size:12px}"]
                },] }
    ];
    SdSelectBadge.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    SdSelectBadge.propDecorators = {
        selectbadge: [{ type: core.ViewChild, args: ['selectbadge',] }],
        label: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        model: [{ type: core.Input }],
        _items: [{ type: core.Input, args: ['items',] }],
        valueField: [{ type: core.Input }],
        displayField: [{ type: core.Input }],
        iconField: [{ type: core.Input }],
        iconColorField: [{ type: core.Input }],
        descriptionField: [{ type: core.Input }],
        modelChange: [{ type: core.Output }],
        sdChange: [{ type: core.Output }],
        sdSelection: [{ type: core.Output }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }],
        clickout: [{ type: core.HostListener, args: ['document:click', ['$event'],] }]
    };

    var SdSelectBadgeDisplayDefDirective = /** @class */ (function () {
        function SdSelectBadgeDisplayDefDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return SdSelectBadgeDisplayDefDirective;
    }());
    SdSelectBadgeDisplayDefDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[sdSelectBadgeDisplayDef]'
                },] }
    ];
    SdSelectBadgeDisplayDefDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var SdSelectBadgeModule = /** @class */ (function () {
        function SdSelectBadgeModule() {
        }
        return SdSelectBadgeModule;
    }());
    SdSelectBadgeModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        input.MatInputModule,
                        tooltip.MatTooltipModule,
                        formField.MatFormFieldModule,
                        icon.MatIconModule,
                        select.MatSelectModule,
                        progressSpinner.MatProgressSpinnerModule,
                        checkbox.MatCheckboxModule,
                        translate.SdTranslateModule,
                        common.SdCommonModule
                    ],
                    declarations: [
                        SdSelectBadge,
                        SdSelectBadgeDisplayDefDirective
                    ],
                    exports: [
                        SdSelectBadge,
                        SdSelectBadgeDisplayDefDirective,
                        common.SdCommonModule
                    ],
                    providers: []
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdSelectBadge = SdSelectBadge;
    exports.SdSelectBadgeDisplayDefDirective = SdSelectBadgeDisplayDefDirective;
    exports.SdSelectBadgeModule = SdSelectBadgeModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-select-badge.umd.js.map
