(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs/operators'), require('@angular/core'), require('rxjs'), require('@sd-angular/core/notify'), require('@angular/cdk/drag-drop'), require('@angular/router'), require('object-hash'), require('@angular/common'), require('@angular/material/icon'), require('@angular/material/tooltip')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/tab-router', ['exports', 'rxjs/operators', '@angular/core', 'rxjs', '@sd-angular/core/notify', '@angular/cdk/drag-drop', '@angular/router', 'object-hash', '@angular/common', '@angular/material/icon', '@angular/material/tooltip'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['tab-router'] = {}), global.rxjs.operators, global.ng.core, global.rxjs, global['sd-angular'].core.notify, global.ng.cdk.dragDrop, global.ng.router, global.hash, global.ng.common, global.ng.material.icon, global.ng.material.tooltip));
}(this, (function (exports, operators, i0, rxjs, i1, dragDrop, router, hash, common, icon, tooltip) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _tab;
    var SdTabBase = /** @class */ (function () {
        function SdTabBase(tab) {
            _tab.set(this, void 0);
            __classPrivateFieldSet(this, _tab, tab);
        }
        Object.defineProperty(SdTabBase.prototype, "tab", {
            get: function () {
                return __classPrivateFieldGet(this, _tab);
            },
            enumerable: false,
            configurable: true
        });
        return SdTabBase;
    }());
    _tab = new WeakMap();
    var SdTabActivated = /** @class */ (function (_super) {
        __extends(SdTabActivated, _super);
        function SdTabActivated() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return SdTabActivated;
    }(SdTabBase));
    var SdTabDeactivated = /** @class */ (function (_super) {
        __extends(SdTabDeactivated, _super);
        function SdTabDeactivated() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return SdTabDeactivated;
    }(SdTabBase));

    var _currentTab, _componentBuilders;
    var SdTabRouterService = /** @class */ (function () {
        function SdTabRouterService(notifyService) {
            var _this = this;
            this.notifyService = notifyService;
            this.events = new rxjs.BehaviorSubject(new SdTabBase(null));
            this.actions = new rxjs.BehaviorSubject(null);
            this.builders = new rxjs.BehaviorSubject([]);
            this.currentTabChanges = new rxjs.BehaviorSubject(null);
            this.newTabs = new rxjs.BehaviorSubject(null);
            _currentTab.set(this, null);
            _componentBuilders.set(this, []);
            this.addBuilder = function (builder) {
                if (!__classPrivateFieldGet(_this, _componentBuilders).some(function (e) { return e.component === builder.component; })) {
                    __classPrivateFieldGet(_this, _componentBuilders).push(builder);
                    _this.builders.next(__classPrivateFieldGet(_this, _componentBuilders));
                }
            };
            // select = (tabOrKey: string | SdTab): void => {
            //   const tab = this.#tabs.find(e => {
            //     if (typeof (tabOrKey) === 'string') {
            //       return e.key === tabOrKey;
            //     }
            //     return e.key === tabOrKey?.key;
            //   });
            //   if (tab) {
            //     this.#currentTab = tab;
            //   }
            // }
            // add = (tab: SdTab): void => {
            //   if (!tab.key) {
            //     this.notifyService.notify.warning('Tab key is required');
            //   }
            //   if (!tab.component) {
            //     this.notifyService.notify.warning('Tab component is required');
            //   }
            //   const existedTab = this.#tabs.find(e => e.key === tab.key);
            //   if (!existedTab) {
            //     this.#tabs.push(tab);
            //     this.select(tab);
            //   } else {
            //     this.select(existedTab);
            //   }
            // }
            // remove = (tabOrKey: string | SdTab): void => {
            //   this.#tabs = this.#tabs.filter(e => {
            //     if (typeof (tabOrKey) === 'string') {
            //       return e.key !== tabOrKey;
            //     }
            //     return e.key !== tabOrKey?.key;
            //   });
            // }
            this.setCurrentTab = function (tab) {
                __classPrivateFieldSet(_this, _currentTab, tab);
                _this.currentTabChanges.next(tab);
            };
            this.pushEvent = function (tab, Event) {
                _this.events.next(new Event(tab));
            };
            this.setOptions = function () { };
            this.close = function (tab) {
                if (tab) {
                    _this.actions.next({
                        type: 'close',
                        tab: tab,
                    });
                }
                else if (__classPrivateFieldGet(_this, _currentTab)) {
                    _this.actions.next({
                        type: 'close',
                        tab: __classPrivateFieldGet(_this, _currentTab),
                    });
                }
            };
        }
        Object.defineProperty(SdTabRouterService.prototype, "currentTab", {
            get: function () {
                return __classPrivateFieldGet(this, _currentTab);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdTabRouterService.prototype, "key", {
            get: function () {
                var _a;
                return ((_a = __classPrivateFieldGet(this, _currentTab)) === null || _a === void 0 ? void 0 : _a.key) || null;
            },
            enumerable: false,
            configurable: true
        });
        return SdTabRouterService;
    }());
    _currentTab = new WeakMap(), _componentBuilders = new WeakMap();
    SdTabRouterService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SdTabRouterService_Factory() { return new SdTabRouterService(i0.ɵɵinject(i1.SdNotifyService)); }, token: SdTabRouterService, providedIn: "root" });
    SdTabRouterService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    SdTabRouterService.ctorParameters = function () { return [
        { type: i1.SdNotifyService }
    ]; };

    var SdTabDecoratorService = /** @class */ (function () {
        function SdTabDecoratorService(tabRouterService) {
            SdTabDecoratorService.tabRouterService.next(tabRouterService);
        }
        return SdTabDecoratorService;
    }());
    SdTabDecoratorService.tabRouterService = new rxjs.BehaviorSubject(undefined);
    SdTabDecoratorService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SdTabDecoratorService_Factory() { return new SdTabDecoratorService(i0.ɵɵinject(SdTabRouterService)); }, token: SdTabDecoratorService, providedIn: "root" });
    SdTabDecoratorService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    SdTabDecoratorService.ctorParameters = function () { return [
        { type: SdTabRouterService }
    ]; };

    function SdTabComponent(builder) {
        return function (constructor) {
            SdTabDecoratorService.tabRouterService.pipe(operators.filter(function (service) { return service !== undefined && service !== null; }), operators.take(1)).subscribe(function (service) {
                service.addBuilder(builder);
            });
        };
    }

    var _subsctiption;
    var SdTabRouterItemComponent = /** @class */ (function () {
        function SdTabRouterItemComponent(cdRef, tabRouterService) {
            var _this = this;
            this.cdRef = cdRef;
            this.tabRouterService = tabRouterService;
            _subsctiption.set(this, new rxjs.Subscription());
            this.close = function (event) {
                event.preventDefault();
                event.stopPropagation();
                _this.tabRouterService.close(_this.tab);
            };
        }
        SdTabRouterItemComponent.prototype.ngOnInit = function () {
            var _this = this;
            __classPrivateFieldGet(this, _subsctiption).add(this.tabRouterService.events.pipe(operators.debounceTime(100)).subscribe(function () {
                _this.cdRef.markForCheck();
            }));
        };
        SdTabRouterItemComponent.prototype.ngOnDestroy = function () {
            __classPrivateFieldGet(this, _subsctiption).unsubscribe();
        };
        return SdTabRouterItemComponent;
    }());
    _subsctiption = new WeakMap();
    SdTabRouterItemComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: "sd-tab-router-item",
                    template: "<a [routerLink]=\"[tab.url]\" [queryParams]=\"tab.queryParams\" [state]=\"{ switchTab: true }\"\r\n  class=\"tab-router__item d-flex align-items-center\" [ngClass]=\"{\r\n    'tab-router__item--active': tab.isActive\r\n  }\">\r\n  <ng-container *ngIf=\"tab.overrideTabInfo | sdTabInfo:tab | async as tabInfo\">\r\n    <div class=\"\r\n    tab-router__icon\r\n    mr-8\r\n  \" [ngStyle]=\"{\r\n    'background-color': tabInfo.color\r\n  }\" [matTooltip]=\"tabInfo.tooltip || tabInfo.name\" matTooltipPosition=\"below\" matTooltipShowDelay=\"1000\">\r\n      {{ tabInfo.initialName || 'SD' }}\r\n    </div>\r\n    <div class=\"flex-1 overflow-hidden\">\r\n      <div class=\"tab-router__name\" [matTooltip]=\"tabInfo.tooltip || tabInfo.name\" matTooltipPosition=\"below\"\r\n        matTooltipShowDelay=\"1000\">\r\n        {{ tabInfo.name }}\r\n      </div>\r\n    </div>\r\n    <button aria-hidden=\"true\" type=\"button\"\r\n      class=\"tab-router__close d-flex align-items-center justify-content-center ml-4\" (click)=\"close($event)\"\r\n      (mousedown)=\"$event.stopPropagation()\">\r\n      <mat-icon aria-hidden=\"true\">close</mat-icon>\r\n    </button>\r\n  </ng-container>\r\n</a>",
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    styles: [":host{display:block;flex:1 1 64px;max-width:240px;overflow:hidden;position:relative}:host:after{background:#dde0e5;bottom:0;content:\"\";height:16px;margin:auto;position:absolute;right:0;top:0;width:1px}:host:last-child:after{content:none}.flex-1{flex:1}.tab-router__icon{background-color:#5c6bc0;border-radius:2px;color:#fff;font-size:10px;height:16px;line-height:16px;text-align:center;text-transform:uppercase;width:16px}.tab-router__icon .mat-icon{font-size:10px;height:10px;width:10px}.tab-router__close{background:none;border:0;border-radius:50%;color:#757575;height:16px;outline:none;width:16px}.tab-router__close:hover{background-color:rgba(0,0,0,.12)}.tab-router__close .mat-icon{font-size:12px;height:12px;width:12px}.tab-router__item{background:#f2f3f4;color:inherit;font-size:12px;line-height:16px;overflow:hidden;padding:16px 16px 8px;text-decoration:none}.tab-router__item:hover{background-color:#fff}.tab-router__name{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.tab-router__item--active{background-color:#fff;border-radius:8px 8px 0 0}"]
                },] }
    ];
    SdTabRouterItemComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef },
        { type: SdTabRouterService }
    ]; };
    SdTabRouterItemComponent.propDecorators = {
        tab: [{ type: i0.Input }]
    };

    var SdTabRouterNavComponent = /** @class */ (function () {
        function SdTabRouterNavComponent(cdRef, elementRef) {
            var _this = this;
            this.cdRef = cdRef;
            this.elementRef = elementRef;
            this.mode = 'default';
            this.checkUI = function () {
                var width = _this.tabRouterNav.nativeElement.clientWidth;
                var nameWidth = (width - _this.tabs.length * 68) / _this.tabs.length;
                if (nameWidth <= 20) {
                    _this.mode = 'compact';
                }
                else {
                    _this.mode = 'default';
                }
                _this.cdRef.markForCheck();
            };
            this.onDrop = function (event) {
                dragDrop.moveItemInArray(_this.tabs, event.previousIndex, event.currentIndex);
            };
        }
        SdTabRouterNavComponent.prototype.onResize = function (event) {
            this.checkUI();
        };
        return SdTabRouterNavComponent;
    }());
    SdTabRouterNavComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'sd-tab-router-nav',
                    template: "<div\r\n  #tabRouterNav\r\n  cdkDropList\r\n  cdkDropListLockAxis=\"x\"\r\n  cdkDropListOrientation=\"horizontal\"\r\n  (cdkDropListDropped)=\"onDrop($event)\"\r\n  class=\"tab-router__nav tab-router__nav--{{ mode }} d-flex align-items-center flex-nowrap\"\r\n  [class.d-none]=\"tabs?.length > 1\"\r\n>\r\n  <ng-container *ngFor=\"let tab of tabs\">\r\n    <sd-tab-router-item [tab]=\"tab\" cdkDrag [cdkDragBoundary]=\"elementRef?.nativeElement\"></sd-tab-router-item>\r\n  </ng-container>\r\n</div>\r\n",
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    styles: [".tab-router__nav{background:#f9f9f9;overflow:hidden}.tab-router__nav--compact::ng-deep .tab-router__name{display:none}.tab-router__nav--compact::ng-deep .tab-router__icon{margin:0!important}.tab-router__nav--compact::ng-deep .tab-router__item--active{min-width:240px}.tab-router__nav--compact::ng-deep .tab-router__item--active .tab-router__icon{margin-right:8px!important}.tab-router__nav--compact::ng-deep .tab-router__item--active .tab-router__name{display:-webkit-box}"]
                },] }
    ];
    SdTabRouterNavComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef },
        { type: i0.ElementRef }
    ]; };
    SdTabRouterNavComponent.propDecorators = {
        tabRouterNav: [{ type: i0.ViewChild, args: ['tabRouterNav',] }],
        tabs: [{ type: i0.Input }],
        onResize: [{ type: i0.HostListener, args: ['window:resize', ['$event'],] }]
    };

    var _rootRoute, _subscription, _firstLoad, _closeTab, _activeRoute, _getActivatedRouteSnapshot, _getActivatedRoute;
    var SdTabRouterOutletComponent = /** @class */ (function () {
        function SdTabRouterOutletComponent(router$1, activatedRoute, cd, injector, compiler, tabDecoratorService, // KHÔNG XÓA
        tabRouterService, sdNotifyService) {
            var _this = this;
            this.router = router$1;
            this.activatedRoute = activatedRoute;
            this.cd = cd;
            this.injector = injector;
            this.compiler = compiler;
            this.tabDecoratorService = tabDecoratorService;
            this.tabRouterService = tabRouterService;
            this.sdNotifyService = sdNotifyService;
            this.tabs = [];
            _rootRoute.set(this, void 0);
            _subscription.set(this, new rxjs.Subscription());
            _firstLoad.set(this, true);
            this.tabTrackBy = function (index, tab) {
                return tab.key;
            };
            _closeTab.set(this, function (tab) {
                var _a;
                var isActive = tab.isActive, activeKey = tab.key;
                if (isActive) {
                    var activeIndex = _this.tabs.findIndex(function (_k) {
                        var key = _k.key;
                        return key === activeKey;
                    });
                    var nextTab = _this.tabs[activeIndex + 1] || _this.tabs[activeIndex - 1];
                    if (nextTab) {
                        var nextUrl = nextTab.url;
                        var nextQueryParams = Object.assign({}, (nextTab.queryParams || {}));
                        _this.tabs = _this.tabs.filter(function (_k) {
                            var key = _k.key;
                            return key !== activeKey;
                        });
                        _this.router.navigate([nextUrl], {
                            queryParams: nextQueryParams,
                            state: {
                                switchTab: true,
                            },
                        });
                    }
                    else {
                        _this.tabs = _this.tabs.filter(function (_k) {
                            var key = _k.key;
                            return key !== activeKey;
                        });
                        _this.router.navigateByUrl('/', {
                            state: {
                                switchTab: true,
                            },
                        });
                    }
                }
                else {
                    _this.tabs = _this.tabs.filter(function (_k) {
                        var key = _k.key;
                        return key !== tab.key;
                    });
                    (_a = _this.tabRouterNav) === null || _a === void 0 ? void 0 : _a.checkUI();
                    _this.cd.markForCheck();
                }
            });
            _activeRoute.set(this, function (fullUrl, route) { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, component, queryParams, params, data, _k, url, key, existedIndex, activatedIndex, currentNavigation, switchTab, replaceTab, existedTab, module, factory, injector_1, activatedRoute_1, tab, module, factory, injector_2, activatedRoute_2, tab;
                var _this = this;
                return __generator(this, function (_l) {
                    switch (_l.label) {
                        case 0:
                            if (!(route === null || route === void 0 ? void 0 : route.component)) {
                                return [2 /*return*/];
                            }
                            component = route.component;
                            queryParams = Object.assign({}, (route.queryParams || {}));
                            params = Object.assign({}, (route.params || {}));
                            data = Object.assign({}, (route.data || {}));
                            _k = __read(fullUrl.split('?'), 1), url = _k[0];
                            key = hash__default['default']({ url: url, queryParams: queryParams });
                            existedIndex = -1;
                            activatedIndex = -1;
                            this.tabs.forEach(function (tab, index) {
                                if (tab.key === key) {
                                    tab.isActive = true;
                                    existedIndex = index;
                                }
                                else {
                                    if (tab.isActive) {
                                        activatedIndex = index;
                                        _this.tabRouterService.pushEvent(tab, SdTabDeactivated);
                                    }
                                    tab.isActive = false;
                                }
                            });
                            currentNavigation = this.router.getCurrentNavigation();
                            switchTab = (_b = (_a = currentNavigation === null || currentNavigation === void 0 ? void 0 : currentNavigation.extras) === null || _a === void 0 ? void 0 : _a.state) === null || _b === void 0 ? void 0 : _b.switchTab;
                            replaceTab = (_d = (_c = currentNavigation === null || currentNavigation === void 0 ? void 0 : currentNavigation.extras) === null || _c === void 0 ? void 0 : _c.state) === null || _d === void 0 ? void 0 : _d.replaceTab;
                            if (!(existedIndex >= 0)) return [3 /*break*/, 5];
                            existedTab = this.tabs[existedIndex];
                            if (replaceTab && activatedIndex >= 0) {
                                if (activatedIndex >= 0) {
                                    this.tabs.splice(activatedIndex, 1);
                                }
                            }
                            if (!switchTab) return [3 /*break*/, 1];
                            this.tabRouterService.setCurrentTab(existedTab);
                            this.tabRouterService.pushEvent(existedTab, SdTabActivated);
                            return [3 /*break*/, 4];
                        case 1:
                            if (!(typeof ((_f = (_e = route === null || route === void 0 ? void 0 : route.parent) === null || _e === void 0 ? void 0 : _e.routeConfig) === null || _f === void 0 ? void 0 : _f.loadChildren) === 'function')) return [3 /*break*/, 4];
                            return [4 /*yield*/, route.parent.routeConfig.loadChildren()];
                        case 2:
                            module = _l.sent();
                            return [4 /*yield*/, this.compiler.compileModuleAsync(module)];
                        case 3:
                            factory = _l.sent();
                            injector_1 = factory.create(this.injector);
                            activatedRoute_1 = __classPrivateFieldGet(this, _getActivatedRoute).call(this, __classPrivateFieldGet(this, _rootRoute), component);
                            tab = {
                                key: key,
                                component: component,
                                injector: new SdOutletInjector(activatedRoute_1, injector_1),
                                isActive: true,
                                name: url,
                                url: url,
                                params: params,
                                queryParams: queryParams,
                                data: data
                            };
                            this.tabs[this.tabs.indexOf(existedTab)] = tab;
                            _l.label = 4;
                        case 4: return [3 /*break*/, 9];
                        case 5:
                            if (!(typeof ((_h = (_g = route === null || route === void 0 ? void 0 : route.parent) === null || _g === void 0 ? void 0 : _g.routeConfig) === null || _h === void 0 ? void 0 : _h.loadChildren) === 'function')) return [3 /*break*/, 8];
                            return [4 /*yield*/, route.parent.routeConfig.loadChildren()];
                        case 6:
                            module = _l.sent();
                            return [4 /*yield*/, this.compiler.compileModuleAsync(module)];
                        case 7:
                            factory = _l.sent();
                            injector_2 = factory.create(this.injector);
                            activatedRoute_2 = __classPrivateFieldGet(this, _getActivatedRoute).call(this, __classPrivateFieldGet(this, _rootRoute), component);
                            tab = {
                                key: key,
                                component: component,
                                injector: new SdOutletInjector(activatedRoute_2, injector_2),
                                isActive: true,
                                name: url,
                                url: url,
                                params: params,
                                queryParams: queryParams,
                                data: data
                            };
                            this.tabRouterService.setCurrentTab(tab);
                            if (activatedIndex >= 0 && replaceTab) {
                                this.tabs.splice(activatedIndex, 1);
                            }
                            this.tabs.push(tab);
                            _l.label = 8;
                        case 8:
                            (_j = this.tabRouterNav) === null || _j === void 0 ? void 0 : _j.checkUI();
                            if (this.tabs.length > 10) {
                                this.sdNotifyService.notify.warning('Bạn đã mở quá nhiều tab. Vui lòng tắt các tab không dùng để hệ thống hoạt động tốt hơn.');
                            }
                            if (this.tabs.length > 15) {
                                this.tabs.splice(0, this.tabs.length - 10);
                            }
                            _l.label = 9;
                        case 9:
                            // if (existedIndex >= 0 && switchTab) {
                            //   const existedTab = this.tabs[existedIndex];
                            //   this.tabRouterService.setCurrentTab(existedTab);
                            //   this.tabRouterService.pushEvent(existedTab, SdTabActivated);
                            // } else {
                            //   if (typeof route?.parent?.routeConfig?.loadChildren === 'function') {
                            //     const module = await route.parent.routeConfig.loadChildren();
                            //     const factory = await this.compiler.compileModuleAsync(module);
                            //     const injector = factory.create(this.injector);
                            //     const activatedRoute = this.#getActivatedRoute(
                            //       this.#rootRoute,
                            //       component
                            //     );
                            //     const tab = {
                            //       key,
                            //       component,
                            //       injector: new SdOutletInjector(activatedRoute, injector),
                            //       isActive: true,
                            //       name: url,
                            //       url,
                            //       params,
                            //       queryParams,
                            //       data
                            //     };
                            //     this.tabRouterService.setCurrentTab(tab);
                            //     if (activatedIndex >= 0 && replaceTab) {
                            //       this.tabs.splice(activatedIndex, 1);
                            //     }
                            //     if (existedIndex >= 0 && !switchTab) {
                            //       this.tabs[existedIndex] = tab;
                            //     } else {
                            //       this.tabs.push(tab);
                            //     }
                            //   }
                            //   this.tabRouterNav?.checkUI();
                            //   if (this.tabs.length > 10) {
                            //     this.sdNotifyService.notify.warning(
                            //       'Bạn đã mở quá nhiều tab. Vui lòng tắt các tab không dùng để hệ thống hoạt động tốt hơn.'
                            //     );
                            //   }
                            //   if (this.tabs.length > 15) {
                            //     this.tabs.splice(0, this.tabs.length - 10);
                            //   }
                            // }
                            this.cd.markForCheck();
                            return [2 /*return*/];
                    }
                });
            }); });
            _getActivatedRouteSnapshot.set(this, function (activatedRouteSnapshot) {
                if (!activatedRouteSnapshot) {
                    return null;
                }
                while (activatedRouteSnapshot.firstChild) {
                    activatedRouteSnapshot = activatedRouteSnapshot.firstChild;
                }
                return activatedRouteSnapshot;
            });
            _getActivatedRoute.set(this, function (activatedRoute, component) {
                if (!activatedRoute) {
                    return null;
                }
                if (activatedRoute.component && activatedRoute.component === component) {
                    return activatedRoute;
                }
                while (activatedRoute.firstChild) {
                    activatedRoute = activatedRoute.firstChild;
                    if (activatedRoute.component && activatedRoute.component === component) {
                        return activatedRoute;
                    }
                }
                return null;
            });
            __classPrivateFieldGet(this, _subscription).add(router$1.events
                .pipe(operators.filter(function (event) { return event instanceof router.RoutesRecognized ||
                event instanceof router.NavigationEnd; }))
                .subscribe(function (event) { return __awaiter(_this, void 0, void 0, function () {
                var route, route;
                return __generator(this, function (_k) {
                    switch (_k.label) {
                        case 0:
                            if (!(__classPrivateFieldGet(this, _firstLoad) && event instanceof router.NavigationEnd)) return [3 /*break*/, 2];
                            __classPrivateFieldSet(this, _firstLoad, false);
                            route = __classPrivateFieldGet(this, _getActivatedRouteSnapshot).call(this, this.activatedRoute.snapshot);
                            __classPrivateFieldSet(this, _rootRoute, this.router.routerState.root);
                            return [4 /*yield*/, __classPrivateFieldGet(this, _activeRoute).call(this, event.urlAfterRedirects || event.url, route)];
                        case 1:
                            _k.sent();
                            return [2 /*return*/];
                        case 2:
                            if (!(!__classPrivateFieldGet(this, _firstLoad) && event instanceof router.RoutesRecognized)) return [3 /*break*/, 4];
                            route = __classPrivateFieldGet(this, _getActivatedRouteSnapshot).call(this, event.state.root);
                            __classPrivateFieldSet(this, _rootRoute, this.router.routerState.root);
                            return [4 /*yield*/, __classPrivateFieldGet(this, _activeRoute).call(this, event.urlAfterRedirects || event.url, route)];
                        case 3:
                            _k.sent();
                            _k.label = 4;
                        case 4: return [2 /*return*/];
                    }
                });
            }); }));
            __classPrivateFieldGet(this, _subscription).add(tabRouterService.actions.subscribe(function (event) {
                if (event && event.type === 'close') {
                    __classPrivateFieldGet(_this, _closeTab).call(_this, event.tab);
                }
            }));
        }
        SdTabRouterOutletComponent.prototype.ngOnDestroy = function () {
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        return SdTabRouterOutletComponent;
    }());
    _rootRoute = new WeakMap(), _subscription = new WeakMap(), _firstLoad = new WeakMap(), _closeTab = new WeakMap(), _activeRoute = new WeakMap(), _getActivatedRouteSnapshot = new WeakMap(), _getActivatedRoute = new WeakMap();
    SdTabRouterOutletComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'sd-tab-router-outlet',
                    template: "<sd-tab-router-nav [tabs]=\"tabs\" #tabRouterNav></sd-tab-router-nav>\r\n\r\n<div class=\"tab-router__list\">\r\n  <ng-container *ngFor=\"let tab of tabs;trackBy:tabTrackBy\">\r\n    <div class=\"tab-router__pane\" [class.active]=\"tab.isActive\" [id]=\"tab.key\">\r\n      <div class=\"tab-router__content\">\r\n        <ng-container\r\n          *ngComponentOutlet=\"tab.component; injector: tab.injector\"\r\n        ></ng-container>\r\n      </div>\r\n    </div>\r\n  </ng-container>\r\n</div>\r\n",
                    styles: [":host{display:flex;flex-direction:column;height:calc(100vh - 64px);width:100%}:host ::ng-deep .sd-loading{max-height:100%;max-width:100%}::ng-deep page-layout{height:100%!important}.tab-router__list{flex:1}.tab-router__pane{display:none;height:100%;position:relative;width:100%}.tab-router__pane.active{display:block}.tab-router__content{bottom:0;height:100%;left:0;overflow:auto;position:absolute;right:0;top:0;width:100%}"]
                },] }
    ];
    SdTabRouterOutletComponent.ctorParameters = function () { return [
        { type: router.Router },
        { type: router.ActivatedRoute },
        { type: i0.ChangeDetectorRef },
        { type: i0.Injector },
        { type: i0.Compiler },
        { type: SdTabDecoratorService },
        { type: SdTabRouterService },
        { type: i1.SdNotifyService }
    ]; };
    SdTabRouterOutletComponent.propDecorators = {
        tabRouterNav: [{ type: i0.ViewChild, args: ['tabRouterNav',] }]
    };
    var SdOutletInjector = /** @class */ (function () {
        function SdOutletInjector(route, 
        // private childContexts: ChildrenOutletContexts,
        parent) {
            this.route = route;
            this.parent = parent;
        }
        SdOutletInjector.prototype.get = function (token, notFoundValue) {
            if (token === router.ActivatedRoute && this.route) {
                return this.route;
            }
            // if (token === ChildrenOutletContexts) {
            //   return this.childContexts;
            // }
            return this.parent.get(token, notFoundValue);
        };
        return SdOutletInjector;
    }());

    var SdTabInfoPipe = /** @class */ (function () {
        function SdTabInfoPipe(tabRouterService) {
            this.tabRouterService = tabRouterService;
        }
        SdTabInfoPipe.prototype.transform = function (tabInfo, tab) {
            if (tabInfo) {
                return rxjs.of(tabInfo);
            }
            return this.tabRouterService.builders.pipe(operators.map(function (builders) {
                var builder = builders.find(function (e) { return e.component === tab.component; });
                if (builder) {
                    var url = tab.url, params = tab.params, queryParams = tab.queryParams, data = tab.data;
                    tab.tabInfo = {
                        name: typeof (builder.name) === 'function' ?
                            builder.name({ url: url, params: params, queryParams: queryParams, data: data }) : builder.name,
                        initialName: typeof (builder.initialName) === 'function' ?
                            builder.initialName({ url: url, params: params, queryParams: queryParams }) : builder.initialName,
                        tooltip: typeof (builder.tooltip) === 'function' ?
                            builder.tooltip({ url: url, params: params, queryParams: queryParams }) : builder.tooltip,
                        color: typeof (builder.color) === 'function' ?
                            builder.color({ url: url, params: params, queryParams: queryParams }) : builder.color
                    };
                    return tab.tabInfo;
                }
                tab.tabInfo = {
                    name: tab.url,
                    initialName: null,
                };
                return tab.tabInfo;
            }));
        };
        return SdTabInfoPipe;
    }());
    SdTabInfoPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'sdTabInfo'
                },] }
    ];
    SdTabInfoPipe.ctorParameters = function () { return [
        { type: SdTabRouterService }
    ]; };

    var RouterLinkMouseDownDirective = /** @class */ (function (_super) {
        __extends(RouterLinkMouseDownDirective, _super);
        function RouterLinkMouseDownDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RouterLinkMouseDownDirective.prototype.onMouseDown = function (button, ctrlKey, shiftKey, altKey, metaKey) {
            return this.onClick(button, ctrlKey, shiftKey, altKey, metaKey);
        };
        return RouterLinkMouseDownDirective;
    }(router.RouterLinkWithHref));
    RouterLinkMouseDownDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: "a[routerLink],area[routerLink]",
                },] }
    ];
    RouterLinkMouseDownDirective.propDecorators = {
        onMouseDown: [{ type: i0.HostListener, args: ["mousedown", [
                        "$event.button",
                        "$event.ctrlKey",
                        "$event.shiftKey",
                        "$event.altKey",
                        "$event.metaKey",
                    ],] }]
    };

    var SdTabRouterModule = /** @class */ (function () {
        function SdTabRouterModule() {
        }
        return SdTabRouterModule;
    }());
    SdTabRouterModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        SdTabRouterItemComponent,
                        SdTabRouterNavComponent,
                        SdTabRouterOutletComponent,
                        SdTabInfoPipe,
                        RouterLinkMouseDownDirective,
                    ],
                    imports: [
                        router.RouterModule,
                        common.CommonModule,
                        icon.MatIconModule,
                        tooltip.MatTooltipModule,
                        dragDrop.DragDropModule
                    ],
                    exports: [
                        SdTabRouterItemComponent,
                        SdTabRouterNavComponent,
                        SdTabRouterOutletComponent,
                    ],
                    providers: [],
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdTabActivated = SdTabActivated;
    exports.SdTabBase = SdTabBase;
    exports.SdTabComponent = SdTabComponent;
    exports.SdTabDeactivated = SdTabDeactivated;
    exports.SdTabDecoratorService = SdTabDecoratorService;
    exports.SdTabRouterItemComponent = SdTabRouterItemComponent;
    exports.SdTabRouterModule = SdTabRouterModule;
    exports.SdTabRouterNavComponent = SdTabRouterNavComponent;
    exports.SdTabRouterOutletComponent = SdTabRouterOutletComponent;
    exports.SdTabRouterService = SdTabRouterService;
    exports.ɵa = SdTabInfoPipe;
    exports.ɵb = RouterLinkMouseDownDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-tab-router.umd.js.map
