import '@sd-angular/core/common';
import { MatDialog } from '@angular/material/dialog';
import { SdBadgeColor } from '@sd-angular/core/badge';
export declare class SdConfirmService {
    private dialog;
    constructor(dialog: MatDialog);
    withInput: (option?: {
        title?: string;
        message?: string;
        yesTitle?: string;
        noTitle?: string;
        required?: boolean;
        maxlength?: number;
        yesButtonColor?: SdBadgeColor;
        noButtonColor?: SdBadgeColor;
        defaultValue?: string;
    }) => Promise<string>;
    withDate: (option?: {
        title?: string;
        message?: string;
        yesTitle?: string;
        noTitle?: string;
        required?: boolean;
        yesButtonColor?: SdBadgeColor;
        noButtonColor?: SdBadgeColor;
        defaultValue?: string | Date;
        placeholder?: string;
    }) => Promise<string>;
}
