export declare const Constants: {
    ARE_YOU_WANT_TO_DELETE: string;
    ACTIVE: string;
    IN_ACTIVE: string;
    APPROVE: string;
    UN_APPROVE: string;
    ACCEPT_SIZE_IMAGE: string;
    ACCEPT_TYPE_IMAGE: string;
    PAGE_TYPE_NEW: string;
    PAGE_TYPE_EDIT: string;
    SAVE: string;
    SAVE_AND_CONTINUE: string;
    IMAGE_SIZE: number;
    SUCCESS: string;
    IMPORT_SUCCESSFULLY: string;
    ERROR: string;
    FAILED: string;
    FILE: string;
    NONE: string;
    NOT_EXIST_ID_OR_LINK: string;
    FEATURE_IS_PENDING: string;
    NOT_SUPPORT_FILE_IMAGE: string;
    NOT_SUPPORT_FILE_IMPORT: string;
    NETWORK_ERROR: string;
    SORT_BY: {
        value: number;
        name: string;
    }[];
    DESC: {
        value: boolean;
        name: string;
    }[];
    FORM_ERRORS: {
        Id: string;
        textSearch: string;
        ImportLogId: string;
        SortBy: string;
        Reverse: string;
    };
    VALIDATION_MESSAGES: {};
};
export declare const PROMOTION_PERMISSIONS: string[];
export declare const ValidateMessageConstants: {
    TITLE_REQUIRED: string;
    TITLE_MAXLENGTH: string;
    TITLE_PATTERN: string;
    CREATED_AT_REQUIRED: string;
    SHOW_ON_HOME_REQUIRED: string;
    DISPLAY_NUMBER_REQUIRED: string;
    CONTENT_TYPE_REQUIRED: string;
    DISCOUNT_PERCENT_REQUIRED: string;
    DISCOUNT_PERCENT_MAX: string;
    DISCOUNT_PERCENT_MIN: string;
};
export declare const PROMOTION_FORM: {
    FORM_ERRORS: {
        title: string;
        createdAt: string;
        displayNumber: string;
        showOnHome: string;
        discountPercent: string;
        isActive: string;
        ctaLabelName: string;
        ctaDeepLink: string;
        tags: string;
    };
    VALIDATION_MESSAGES: {
        title: {
            required: string;
            maxlength: string;
            pattern: string;
        };
        createdAt: {
            required: string;
        };
        showOnHome: {
            required: string;
        };
        displayNumber: {
            required: string;
        };
        discountPercent: {
            required: string;
            max: string;
            min: string;
        };
        tags: {
            required: string;
        };
    };
};
