import '@sd-angular/core/common';
import '@sd-angular/core/label';
import '@sd-angular/core/input-upload-file';
import '@sd-angular/core/chip';
import '@sd-angular/core/textarea';
import '@sd-angular/core/checkbox';
import '@sd-angular/core/time';
import '@sd-angular/core/side-drawer';
import '@sd-angular/core/tab-router';
import '@sd-angular/core/input';
import '@sd-angular/core/select';
import '@sd-angular/core/quick-action';
import '@sd-angular/core/image-preview';
import '@sd-angular/core/comment';
import '@sd-angular/core/filter';
import '@sd-angular/core/modal-resizable';
import '@sd-angular/core/db';
import '@sd-angular/core/group';
import '@sd-angular/core/json-editor';
import '@sd-angular/core/input-number';
import '@sd-angular/core/confirm';
export * from '@sd-angular/core/popover';
import '@sd-angular/core/pdf';
import '@sd-angular/core/print';
import '@sd-angular/core/zip';
import '@sd-angular/core/export';
import { SdTableModule } from '@sd-angular/core/table';
import '@sd-angular/core/date';
import '@sd-angular/core/month';
import '@sd-angular/core/date-full';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatInputModule } from '@angular/material/input';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSelectModule } from '@angular/material/select';
import { MatRadioModule } from '@angular/material/radio';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatIconModule } from '@angular/material/icon';
import { MatMenuModule } from '@angular/material/menu';
import { MatChipsModule } from '@angular/material/chips';
import { MatButtonModule } from '@angular/material/button';
import { MatDialogModule } from '@angular/material/dialog';
import { MatBottomSheetModule } from '@angular/material/bottom-sheet';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatTabsModule } from '@angular/material/tabs';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { MatPaginatorModule } from '@angular/material/paginator';
import { SdServiceModule } from '@sd-angular/core/service';
export * from '@sd-angular/core/service';
import { SdChartModule } from '@sd-angular/core/chart';
export * from '@sd-angular/core/chart';
import { SdGridMaterialModule } from '@sd-angular/core/grid-material';
export { SdGridMaterial } from '@sd-angular/core/grid-material';
import { SdEditorModule } from '@sd-angular/core/editor';
export * from '@sd-angular/core/editor';
import { SdKonvaModule } from '@sd-angular/core/konva';
export * from '@sd-angular/core/konva';
import { SdUploadExcelModule } from '@sd-angular/core/upload-excel';
export * from '@sd-angular/core/upload-excel';
import { SdGridModule } from '@sd-angular/core/grid';
export * from '@sd-angular/core/grid';
import { SdFormModule } from '@sd-angular/core/form';
export * from '@sd-angular/core/form';
export { SdApiModule, SdApiService } from '@sd-angular/core/api';
export * from '@sd-angular/core/loading';
export * from '@sd-angular/core/notify';
export * from '@sd-angular/core/setting';
export * from '@sd-angular/core/translate';
export * from '@sd-angular/core/utility';
export * from '@sd-angular/core/dynamic-report';
export * from '@sd-angular/core/upload-file';
export * from '@sd-angular/core/date-range';
export * from '@sd-angular/core/date-time';
export * from '@sd-angular/core/button';
export * from '@sd-angular/core/autocomplete';
export * from '@sd-angular/core/select-editor';
export * from '@sd-angular/core/modal';
export * from '@sd-angular/core/switch';
export * from '@sd-angular/core/radio';

class MaterialModule {
}
MaterialModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    MatTooltipModule,
                    MatFormFieldModule,
                    MatInputModule,
                    MatSelectModule,
                    MatAutocompleteModule,
                    MatCheckboxModule,
                    MatSlideToggleModule,
                    MatRadioModule,
                    MatIconModule,
                    MatMenuModule,
                    MatChipsModule,
                    MatButtonModule,
                    MatDialogModule,
                    MatBottomSheetModule,
                    MatProgressSpinnerModule,
                    DragDropModule,
                    MatExpansionModule,
                    MatTabsModule,
                    MatPaginatorModule
                ],
                exports: [
                    MatTooltipModule,
                    MatFormFieldModule,
                    MatInputModule,
                    MatSelectModule,
                    MatAutocompleteModule,
                    MatCheckboxModule,
                    MatSlideToggleModule,
                    MatRadioModule,
                    MatIconModule,
                    MatMenuModule,
                    MatChipsModule,
                    MatButtonModule,
                    MatDialogModule,
                    MatBottomSheetModule,
                    MatProgressSpinnerModule,
                    DragDropModule,
                    MatExpansionModule,
                    MatTabsModule,
                    MatPaginatorModule
                ]
            },] }
];

class SdCoreModule {
}
SdCoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MaterialModule,
                    SdChartModule,
                    SdKonvaModule,
                    SdGridMaterialModule,
                    SdUploadExcelModule,
                    SdGridModule,
                    SdFormModule,
                    SdTableModule,
                    SdServiceModule
                ],
                declarations: [],
                exports: [
                    SdChartModule,
                    SdKonvaModule,
                    SdGridMaterialModule,
                    SdEditorModule,
                    SdUploadExcelModule,
                    SdGridModule,
                    SdFormModule,
                    SdTableModule,
                    SdServiceModule,
                    MaterialModule,
                ],
                providers: []
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { MaterialModule, SdCoreModule };
//# sourceMappingURL=sd-angular-core.js.map
