import { ElementRef, Renderer2 } from '@angular/core';
import { SdMaterialCellDefDirective } from '../../directives/sd-material-cell-def.directive';
import { SdGridMaterialColumn } from '../../models/grid-column.model';
import { SdGridMaterialOption } from '../../models/grid-option.model';
export declare class SdDesktopCell {
    private elementRef;
    private renderer;
    sdId: string;
    value: any;
    key: string;
    column: SdGridMaterialColumn;
    set _column(column: SdGridMaterialColumn);
    item: any;
    gridOption: SdGridMaterialOption;
    cellDef: {
        [column: string]: SdMaterialCellDefDirective;
    };
    idx: number;
    constructor(elementRef: ElementRef, renderer: Renderer2);
}
