import { OnInit, ChangeDetectorRef, OnDestroy } from '@angular/core';
import { SdNotifyService } from '@sd-angular/core/notify';
import { SdTranslateService } from '@sd-angular/core/translate';
import { SdGridMaterialOption } from '../../models/grid-option.model';
import { SdGridConfigurationService } from '../../services/grid-configuration.service';
import { SdGeneratedColumnService } from '../../services/generated-column/generated-column.service';
import { SdGeneratedColumn } from '../../services/generated-column/generated-column.model';
import { FormGroup } from '@angular/forms';
import { SdSideDrawer } from '@sd-angular/core/side-drawer';
import { SdGridMaterialColumn } from '../../models/grid-column.model';
export declare class SdDynamicColumn implements OnInit, OnDestroy {
    #private;
    private ref;
    private generatedColumnService;
    private notifyService;
    private translateService;
    private gridConfigurationService;
    sideDrawer: SdSideDrawer;
    gridOption: SdGridMaterialOption;
    systemColumns: SdGeneratedColumn[];
    columns: SdGeneratedColumn[];
    columnTypes: string[];
    form: FormGroup;
    isDetail: boolean;
    detail: SdGeneratedColumn;
    originColumns: SdGridMaterialColumn[];
    constructor(ref: ChangeDetectorRef, generatedColumnService: SdGeneratedColumnService, notifyService: SdNotifyService, translateService: SdTranslateService, gridConfigurationService: SdGridConfigurationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onDetail: (column?: SdGeneratedColumn) => void;
    onSave: () => void;
}
