import { SdBadgeColor } from "@sd-angular/core/badge";
export interface SdCellView {
    badge?: {
        type: 'round' | 'circle' | 'icon';
        color: SdBadgeColor;
        icon: string;
    };
    tooltip?: string;
    display: {
        align: 'center' | 'left' | 'right';
        value: string;
        hasHtml?: boolean;
        html?: string;
    };
    click?: () => void;
}
