export declare type SdGridMaterialCommand<T = any> = SdGridMaterialCommandNormal<T> | SdGridMaterialCommandChildren<T>;
export interface SdGridMaterialCommandNormal<T = any> {
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    title?: string | ((rowData: T) => string);
    disabled?: boolean | ((rowData: T) => boolean);
    hidden?: boolean | ((rowData: T) => boolean | Promise<boolean>);
    click: (rowData: T) => void;
    htmlTemplate?: (rowData: T) => string;
}
interface SdGridMaterialCommandChildren<T = any> {
    icon?: string | ((rowData: T) => string);
    fontSet?: 'material-icons' | 'material-icons-outlined' | 'material-icons-outlined' | 'material-icons-round' | 'material-icons-sharp';
    title?: string | ((rowData: T) => string);
    disabled?: boolean | ((rowData: T) => boolean);
    hidden?: boolean | ((rowData: T) => boolean | Promise<boolean>);
    children: SdGridMaterialCommandNormal<T>[];
}
export {};
