import { InjectionToken } from '@angular/core';
import { SdFilterOperator } from './grid-column.model';
export interface ISdGridMaterialConfiguration {
    filter?: {
        quickFilter?: boolean;
        operator?: {
            defaultListString?: SdFilterOperator[];
            defaultListNumber?: SdFilterOperator[];
            defaultListDate?: SdFilterOperator[];
            defaultListValues?: SdFilterOperator[];
        };
    };
    paginate?: {
        pageSize?: number;
        pages?: number[];
    };
    translate?: boolean;
}
export declare const DEFAULT_GRID_MATERIAL_CONFIG: ISdGridMaterialConfiguration;
export declare const GRID_MATERIAL_CONFIG: InjectionToken<ISdGridMaterialConfiguration>;
