import { SdGridMaterialAction } from './grid-action.model';
import { SdGridMaterialItem } from './grid.model';
export interface SdGridMaterialSelection<T = any> {
    visible?: boolean;
    single?: boolean;
    onSelect?: (rowData?: SdGridMaterialItem<T>, selectedItems?: SdGridMaterialItem<T>[]) => void;
    onSelectAll?: (selectedItems: SdGridMaterialItem<T>[]) => void;
    disabled?: (rowData?: SdGridMaterialItem<T>, selectedItems?: SdGridMaterialItem<T>[]) => boolean;
    actions?: SdGridMaterialAction<T>[];
    message?: string;
}
