import { PipeTransform } from '@angular/core';
import { SdUtilityService } from '@sd-angular/core/utility';
import { DeviceDetectorService } from 'ngx-device-detector';
import { SdCellView } from '../models/grid-cell.model';
import { SdGridMaterialColumn } from '../models/grid-column.model';
import { SdGridMaterialOption } from '../models/grid-option.model';
import { SdColumnValuesPipe } from './column-values.pipe';
export declare class SdCellViewPipe implements PipeTransform {
    #private;
    private utilityService;
    private columnValuesPipe;
    constructor(deviceService: DeviceDetectorService, utilityService: SdUtilityService, columnValuesPipe: SdColumnValuesPipe);
    transform(value: any, rowData: any, column: SdGridMaterialColumn, gridOption: SdGridMaterialOption): Promise<SdCellView>;
}
