import { PipeTransform } from '@angular/core';
import { SdGridMaterialOption } from '../models/grid-option.model';
import { SdGridConfiguration, SdGridConfigurationResult } from '../models/grid-config.model';
import { SdGridConfigurationService } from '../services/grid-configuration.service';
import { SdMaterialSubInformationDefDirective } from '../directives/sd-material-sub-information-def.directive';
export declare class SdGridConfigurationResultPipe implements PipeTransform {
    private gridConfigurationService;
    constructor(gridConfigurationService: SdGridConfigurationService);
    transform(configuration: SdGridConfiguration, gridOption: SdGridMaterialOption, sdSubInformation: SdMaterialSubInformationDefDirective): SdGridConfigurationResult;
}
