import { SdGridColumn } from '../../grid.model';
export interface OriginColumn {
    field: string;
    title: string;
    width?: string;
    fixed?: boolean;
}
export interface ConfigOption {
    key?: string;
    pageSize: number;
    columns: SdGridColumn[];
}
export interface ConfigResult {
    pageSize: number;
    columns: SdGridColumn[];
    fixedColumns: SdGridColumn[];
    normalColumns: SdGridColumn[];
}
export interface ConfigStorage {
    pageSize?: number;
    columnConfigs?: ConfigColumn[];
}
export interface ConfigColumn {
    originColumn: OriginColumn;
    title?: string;
    width?: string;
    hidden?: boolean;
    fixed?: boolean;
}
