import { ChangeDetectorRef, EventEmitter } from '@angular/core';
import { SdGridColumn, GridItem } from '../../grid.model';
export declare class SdGridDesktopColumnEdit {
    private ref;
    column: SdGridColumn;
    item: GridItem;
    sdChange: EventEmitter<{
        column: SdGridColumn;
        item: GridItem;
        value: any;
    }>;
    constructor(ref: ChangeDetectorRef);
    onEditorChange: (column: SdGridColumn, item: GridItem, value: any) => void;
    onAutocompleteChange: (item: any) => void;
    onSelectionChange: (params: {
        value: any;
        item: any;
        items: any[];
    }) => void;
    dynamicItems: (value: any) => Promise<any[]>;
}
