import { InjectionToken } from '@angular/core';
import { IHandlerServer } from './handler';
export interface IGridConfiguration {
    filter?: {
        type?: 'inline' | 'popup';
        columnInline?: 'outside';
        quickFilterVisibility?: 'inline' | 'popup' | 'none';
    };
    style?: {
        bordered?: boolean;
        stripped?: boolean;
    };
    translate?: boolean;
    handlerCustom?: IHandlerServer;
}
export declare const GRID_CONFIG: InjectionToken<IGridConfiguration>;
