import { ElementRef } from "@angular/core";
import { MatDialog } from "@angular/material/dialog";
export interface ImagePreview {
    extension: string;
    file: File;
    fileName: string;
    previewSrc: string;
    src: string;
}
export declare class ImagePreviewDirective {
    private el;
    dialog: MatDialog;
    images?: Array<Partial<ImagePreview>> | string;
    sdPreviewCurrentIdx: number;
    constructor(el: ElementRef, dialog: MatDialog);
    onClick(): void;
}
