import { MatDialogRef } from '@angular/material/dialog';
import { SdBadgeColor } from '@sd-angular/core/badge';
export interface DialogData {
    icon?: string;
    title?: string;
    message?: string;
    yesTitle?: string;
    noTitle?: string;
    yesButtonColor?: SdBadgeColor;
    noButtonColor?: SdBadgeColor;
    input?: {
        placeholder?: string;
        minlength?: number;
        maxlength?: number;
        required?: boolean;
        defaultValue?: string;
    };
}
export declare class DialogConfirmComponent {
    dialogRef: MatDialogRef<DialogConfirmComponent>;
    data: DialogData;
    value: any;
    required: boolean;
    isString: boolean;
    id: string;
    constructor(dialogRef: MatDialogRef<DialogConfirmComponent>, data: DialogData);
}
