import { Directionality } from "@angular/cdk/bidi";
import { Overlay } from "@angular/cdk/overlay";
import { Platform } from "@angular/cdk/platform";
import { AfterViewInit, ElementRef, EventEmitter, NgZone, OnDestroy, ViewContainerRef } from "@angular/core";
import { PopoverComponent } from "../popover/popover.component";
export declare class PopoverTriggerDirective implements AfterViewInit, OnDestroy {
    #private;
    private _overlay;
    private _element;
    private _ngZone;
    private viewContainerRef;
    private elementRef;
    private platform;
    private _dir;
    popoverOpen: boolean;
    get popover(): PopoverComponent;
    set popover(popover: PopoverComponent);
    popoverData: any;
    disabled: boolean;
    popoverOpened: EventEmitter<void>;
    popoverClosed: EventEmitter<void>;
    constructor(_overlay: Overlay, _element: ElementRef<HTMLElement>, _ngZone: NgZone, viewContainerRef: ViewContainerRef, elementRef: ElementRef, platform: Platform, _dir: Directionality);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    openPopover: () => void;
    closePopover: () => void;
}
