import { EventEmitter, ChangeDetectorRef, OnDestroy, OnInit } from "@angular/core";
import { MatSelect } from "@angular/material/select";
import { SdLabelDefDirective } from "@sd-angular/core/common";
import { IFormConfiguration } from "@sd-angular/core/common";
import { SdSelect } from "@sd-angular/core/select";
export declare class SdSelectEditor extends SdSelect implements OnInit, OnDestroy {
    private cdRef;
    private formConfiguration;
    matSelect: MatSelect;
    addable: boolean;
    editable: boolean;
    deletable: boolean;
    sdAdd: EventEmitter<any>;
    sdEdit: EventEmitter<any>;
    sdDelete: EventEmitter<any>;
    sdLabelDef: SdLabelDefDirective;
    constructor(cdRef: ChangeDetectorRef, formConfiguration: IFormConfiguration);
    onAdd: ($event: Event) => void;
    onEdit: ($event: Event, item: any) => void;
    onDelete: ($event: Event, item: any) => void;
}
