import { Type } from '@angular/core';
export declare interface SdTabComponentBuilder {
    component: Type<any>;
    name: string | ((args: {
        url: string;
        params: any;
        queryParams: any;
        data: Record<string, any>;
    }) => string);
    initialName: string | ((args: {
        url: string;
        params: any;
        queryParams: any;
    }) => string);
    tooltip?: string | ((args: {
        url: string;
        params: any;
        queryParams: any;
    }) => string);
    color?: string | ((args: {
        url: string;
        params: any;
        queryParams: any;
    }) => string);
    isDetail?: boolean;
}
export declare function SdTabComponent<T>(builder: SdTabComponentBuilder): (constructor: T) => void;
