import { ITranslateConfiguration } from './translate.model';
export declare class SdTranslateService {
    private configuration;
    private undeclaredLanguage;
    private currentLanguage;
    private dictionary;
    constructor(configuration: ITranslateConfiguration);
    translate: (keyWord: string, language?: string) => string;
    setDictionary: (language: string, keyWord: string, value: string) => void;
    setDictionaries: (language: string, dictionary: {
        [keyWord: string]: string;
    }) => void;
    setDefaultLanguage: (language: string) => void;
    getUndeclaredLanguage: () => {
        [keyWord: string]: boolean;
    };
}
