import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { Observable } from 'rxjs';
import { IApiConfiguration } from './api.model';
import { SdTokenService } from './token.service';
export declare class SdHttpInterceptor implements HttpInterceptor {
    private configuration;
    private tokenService;
    constructor(configuration: IApiConfiguration, tokenService: SdTokenService);
    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
}
