(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@sd-angular/core/translate'), require('@angular/material/icon'), require('@angular/material/button'), require('@sd-angular/core/textarea'), require('rxjs'), require('rxjs/operators'), require('@sd-angular/core/loading'), require('@sd-angular/core/button'), require('@sd-angular/core/input'), require('@sd-angular/core/utility'), require('@angular/material/tooltip'), require('@sd-angular/core/editor'), require('@sd-angular/core/modal')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/comment', ['exports', '@angular/core', '@angular/common', '@sd-angular/core/translate', '@angular/material/icon', '@angular/material/button', '@sd-angular/core/textarea', 'rxjs', 'rxjs/operators', '@sd-angular/core/loading', '@sd-angular/core/button', '@sd-angular/core/input', '@sd-angular/core/utility', '@angular/material/tooltip', '@sd-angular/core/editor', '@sd-angular/core/modal'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.comment = {}), global.ng.core, global.ng.common, global['sd-angular'].core.translate, global.ng.material.icon, global.ng.material.button, global['sd-angular'].core.textarea, global.rxjs, global.rxjs.operators, global['sd-angular'].core.loading, global['sd-angular'].core.button, global['sd-angular'].core.input, global['sd-angular'].core.utility, global.ng.material.tooltip, global['sd-angular'].core.editor, global['sd-angular'].core.modal));
}(this, (function (exports, core, common, translate, icon, button, textarea, rxjs, operators, loading, button$1, input, utility, tooltip, editor, modal) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _items, _send, _timerReload, _load, _scrollToBottom;
    var SdComment = /** @class */ (function () {
        function SdComment(loadingService) {
            var _this = this;
            this.loadingService = loadingService;
            _items.set(this, new rxjs.BehaviorSubject([]));
            _send.set(this, new rxjs.BehaviorSubject(''));
            _timerReload.set(this, void 0);
            this.isReloading = false;
            this.fullCommentStyles = {
                'min-height': '150px'
            };
            this.onSend = function () {
                var _a, _b, _c;
                if (_this.message) {
                    (_b = (_a = _this.commentOption) === null || _a === void 0 ? void 0 : _a.event) === null || _b === void 0 ? void 0 : _b.onSend(_this.message);
                    _this.message = null;
                    (_c = _this.textarea) === null || _c === void 0 ? void 0 : _c.focus();
                }
            };
            _load.set(this, function () { return __awaiter(_this, void 0, void 0, function () {
                var items, results;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            items = this.commentOption.items;
                            results = items();
                            if (!(results instanceof Promise)) return [3 /*break*/, 2];
                            return [4 /*yield*/, results];
                        case 1: return [2 /*return*/, _d.sent()];
                        case 2: return [2 /*return*/, results];
                    }
                });
            }); });
            this.reload = function () { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, _d, _e;
                var _this = this;
                return __generator(this, function (_f) {
                    switch (_f.label) {
                        case 0:
                            this.loadingService.start('.c-comment-loading');
                            _e = (_d = __classPrivateFieldGet(this, _items)).next;
                            return [4 /*yield*/, __classPrivateFieldGet(this, _load).call(this)];
                        case 1:
                            _e.apply(_d, [_f.sent()]);
                            this.loadingService.stop('.c-comment-loading');
                            __classPrivateFieldGet(this, _scrollToBottom).call(this);
                            if ((_b = (_a = this.commentOption) === null || _a === void 0 ? void 0 : _a.autoReload) === null || _b === void 0 ? void 0 : _b.timerMs) {
                                clearInterval(__classPrivateFieldGet(this, _timerReload));
                                __classPrivateFieldSet(this, _timerReload, setInterval(function () { return __awaiter(_this, void 0, void 0, function () {
                                    var _d, _e;
                                    return __generator(this, function (_f) {
                                        switch (_f.label) {
                                            case 0:
                                                this.loadingService.start('.c-comment-loading');
                                                _e = (_d = __classPrivateFieldGet(this, _items)).next;
                                                return [4 /*yield*/, __classPrivateFieldGet(this, _load).call(this)];
                                            case 1:
                                                _e.apply(_d, [_f.sent()]);
                                                this.loadingService.stop('.c-comment-loading');
                                                __classPrivateFieldGet(this, _scrollToBottom).call(this);
                                                return [2 /*return*/];
                                        }
                                    });
                                }); }, this.commentOption.autoReload.timerMs));
                            }
                            return [2 /*return*/];
                    }
                });
            }); };
            this.clearAllData = function () {
                _this.message = '';
            };
            _scrollToBottom.set(this, function () {
                try {
                    setTimeout(function () {
                        _this.commentScroll.nativeElement.scrollTop = _this.commentScroll.nativeElement.scrollHeight;
                    }, 500);
                }
                catch (err) {
                }
            });
        }
        Object.defineProperty(SdComment.prototype, "option", {
            set: function (option) {
                this.commentOption = option;
                this.reload();
            },
            enumerable: false,
            configurable: true
        });
        ;
        SdComment.prototype.ngOnInit = function () {
            this.items = __classPrivateFieldGet(this, _items).pipe(operators.map(function (items) {
                return items.map(function (e) {
                    var _a;
                    return (Object.assign(Object.assign({}, e), { picture: (_a = e.picture) !== null && _a !== void 0 ? _a : "https://ui-avatars.com/api/?size=32&rounded=true&background=random&name=" + e.creator }));
                });
            }));
            this.count = this.items.pipe(operators.map(function (items) { return items.length; }));
        };
        SdComment.prototype.ngOnDestroy = function () {
            var _a, _b;
            if ((_b = (_a = this.commentOption) === null || _a === void 0 ? void 0 : _a.autoReload) === null || _b === void 0 ? void 0 : _b.timerMs) {
                clearInterval(__classPrivateFieldGet(this, _timerReload));
            }
        };
        SdComment.prototype.ngAfterViewInit = function () {
        };
        return SdComment;
    }());
    _items = new WeakMap(), _send = new WeakMap(), _timerReload = new WeakMap(), _load = new WeakMap(), _scrollToBottom = new WeakMap();
    SdComment.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-comment',
                    template: "<div class=\"c-container\">\r\n  <div class=\"c-header\">\r\n    <div class=\"c-title\">{{'Comments' | sdTranslate}} <a href=\"javascript:;\">({{count | async}})</a></div>\r\n  </div>\r\n  <div class=\"c-body c-comment-loading\" *ngIf=\"commentOption?.style==='basic'\" #commentScroll>\r\n    <ng-container *ngFor=\"let item of items | async\">\r\n      <div class=\"d-flex my-8\">\r\n        <div class=\"c-avatar mr-12\">\r\n          <img height=\"32\" width=\"32px\" [src]=\"item.picture\">\r\n        </div>\r\n        <div class=\"c-comment\">\r\n          <div class=\"c-info mb-4\">\r\n            {{'By' | sdTranslate}}\r\n            <span class=\"c-creator ml-2\">\r\n              {{item.creator}}\r\n            </span>\r\n            <ng-container *ngIf=\"item.createdDate\">\r\n              <span class=\"mx-4\">\u2022</span>\r\n              <span\r\n                [matTooltip]=\"item.createdDate | date:'dd/MM/yyyy HH:mm'\">{{item.createdDate | sdTimeDifferent:'dd/MM/yyyy HH:mm':'hour' | async}}</span>\r\n            </ng-container>\r\n          </div>\r\n          <div class=\"c-content\" [innerHtml]=\"item.content\">\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"c-body-style1 c-comment-loading\" *ngIf=\"commentOption?.style==='style1'\" sdScroll #commentScroll>\r\n    <ng-container *ngFor=\"let item of items | async; let i = index\">\r\n      <div class=\"d-flex my-8\">\r\n        <div class=\"c-avatar mr-12\">\r\n          <img height=\"32\" width=\"32px\" [src]=\"item.picture\">\r\n        </div>\r\n        <div class=\"c-comment {{i + 1 === (count | async) ? 'c-comment-border': ''}}\">\r\n          <div class=\"c-info mb-4\">\r\n            <div class=\"c-col-left\">\r\n              <div class=\"c-creator\">\r\n                {{item.creator}}\r\n              </div>\r\n              <div class=\"c-email\">\r\n                {{item.email}}\r\n              </div>\r\n            </div>\r\n            <ng-container *ngIf=\"item.createdDate\">\r\n              <div class=\"c-col-right\"\r\n                   [matTooltip]=\"item.createdDate | date:'dd/MM/yyyy H:mm'\">{{item.createdDate | date:'dd/MM/yyyy H:mm'}}</div>\r\n            </ng-container>\r\n          </div>\r\n          <div class=\"c-content\" [innerHtml]=\"item.content\">\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"c-footer p-16\">\r\n    <div class=\"row\">\r\n      <div class=\"col-12 c-position-relative\">\r\n        <ng-container *ngIf=\"commentOption?.editor?.enabled else noUseEditor\">\r\n          <div class=\"mb-8\">\r\n            <sd-editor [(model)]=\"message\" [styles]=\"commentOption?.editor?.styles\"\r\n                       [toolbar]=\"commentOption?.editor?.toolbar\"\r\n                       [mentionValues]=\"commentOption?.editor?.mentionValues\"\r\n                       [hashTagValues]=\"commentOption?.editor?.hashTagValues\" [args]=\"commentOption?.editor?.args\"></sd-editor>\r\n          </div>\r\n          <div *ngIf=\"commentOption?.fullComment?.enabled\" class=\"c-full-comment-backdrop\"\r\n               (click)=\"modalFullComment.open()\"></div>\r\n        </ng-container>\r\n        <ng-template #noUseEditor>\r\n          <sd-textarea [(model)]=\"message\" rows=\"1\" autoHeight></sd-textarea>\r\n        </ng-template>\r\n      </div>\r\n    </div>\r\n    <div class=\"row action-comment\">\r\n      <div class=\"col-7 pr-0\">\r\n        <sd-button title=\"G\u1EEDi b\u00ECnh lu\u1EADn\" icon=\"send\" (action)=\"onSend()\" [disabled]=\"!message\" color=\"primary\" type=\"fill\"\r\n          size=\"sm\">\r\n        </sd-button>\r\n      </div>\r\n      <div class=\"col-5\">\r\n        <sd-button class=\"btn-refresh\" title=\"L\u00E0m m\u1EDBi\" icon=\"refresh\" (action)=\"reload()\" *ngIf=\"commentOption?.autoReload?.enabledButton\" type=\"fill\"\r\n                   size=\"sm\">\r\n        </sd-button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<sd-modal [title]=\"'Comments' | sdTranslate\" width=\"sm\" [closeClickOutSide]=\"commentOption?.fullComment?.closeClickOutSide\" #modalFullComment>\r\n  <sd-modal-body>\r\n    <sd-editor [(model)]=\"message\" [styles]=\"fullCommentStyles\"\r\n               [toolbar]=\"commentOption?.editor?.toolbar\"\r\n               [mentionValues]=\"commentOption?.editor?.mentionValues\"\r\n               [hashTagValues]=\"commentOption?.editor?.hashTagValues\"\r\n               [args]=\"commentOption?.editor?.args\"></sd-editor>\r\n  </sd-modal-body>\r\n  <sd-modal-footer>\r\n    <sd-button class=\"ml-8\" title=\"X\u00F3a to\u00E0n b\u1ED9\" size=\"sm\" type=\"link\"\r\n               (action)=\"clearAllData()\">\r\n    </sd-button>\r\n    <sd-button *ngIf=\"!commentOption?.fullComment?.enableSendButton\" class=\"ml-8\" title=\"\u0110\u00F3ng\" size=\"sm\" (action)=\"modalFullComment.close()\"\r\n               color=\"primary\" type=\"fill\">\r\n    </sd-button>\r\n    <sd-button class=\"ml-8\" title=\"T\u1EA3i l\u1EA1i\" (action)=\"reload()\"  *ngIf=\"commentOption?.autoReload?.enabledButton\" color=\"warning\" type=\"fill\"\r\n               size=\"sm\">\r\n    </sd-button>\r\n    <sd-button *ngIf=\"commentOption?.fullComment?.enableSendButton\" class=\"ml-8\" title=\"G\u1EEDi\" size=\"sm\" (action)=\"onSend();modalFullComment.close();\" [disabled]=\"!message\"\r\n               color=\"primary\" type=\"fill\">\r\n    </sd-button>\r\n  </sd-modal-footer>\r\n</sd-modal>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".text-black400{color:#757575}.c-container{display:flex;flex-direction:column;height:100%}.c-container .c-header{align-items:center;background-color:#fff;display:flex;height:40px;padding:0 16px}.c-container .c-header .c-title{font-weight:500}.c-container .c-body{background:#f8f9fa;flex:1;overflow-y:hidden;padding:16px}.c-container .c-body:hover{overflow-y:auto}.c-container .c-body .c-comment{background:#fff;border:1px solid #f2f2f2;border-radius:4px;flex:1;overflow-wrap:break-word;padding:12px 16px;white-space:pre-wrap;word-break:break-word}.c-container .c-body .c-comment .c-info{color:#757575}.c-container .c-body .c-comment .c-info .c-creator{color:#000;font-weight:500}.c-container .c-body-style1{background:#fff;flex:1;overflow-y:hidden;padding:16px}.c-container .c-body-style1 .c-comment{background:#fff;border-bottom:3px solid #f2f2f2;border-radius:4px;flex:1;overflow-wrap:break-word;white-space:pre-wrap;word-break:break-word}.c-container .c-body-style1 .c-comment .c-info{color:#757575}.c-container .c-body-style1 .c-comment .c-info .c-creator{color:#000;font-weight:500;white-space:nowrap}.c-container .c-body-style1 .c-comment .c-info .c-email{color:#000;font-weight:400;white-space:nowrap}.c-container .c-body-style1 .c-comment .c-info .c-col-left{display:inline-block;overflow:hidden;vertical-align:top;width:calc(100% - 128px)}.c-container .c-body-style1 .c-comment .c-info .c-col-right{display:inline-block;margin-left:8px;width:120px}.c-container .c-body-style1 .c-comment-border{border-bottom:none}.c-container .c-footer{background:#fff;min-height:120px}.c-container .c-footer .c-position-relative{position:relative}.c-container .c-footer .c-full-comment-backdrop{height:100%;left:0;position:absolute;top:0;width:100%;z-index:1}:host ::ng-deep .action-comment button.c-button.c-sm{width:100%!important}:host ::ng-deep .action-comment .btn-refresh button{background-color:#e9e9e9!important;color:#a6a6a6!important}"]
                },] }
    ];
    SdComment.ctorParameters = function () { return [
        { type: loading.SdLoadingService }
    ]; };
    SdComment.propDecorators = {
        commentScroll: [{ type: core.ViewChild, args: ['commentScroll',] }],
        textarea: [{ type: core.ViewChild, args: [textarea.SdTextarea,] }],
        option: [{ type: core.Input }]
    };

    var SdCommentModule = /** @class */ (function () {
        function SdCommentModule() {
        }
        return SdCommentModule;
    }());
    SdCommentModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        button.MatButtonModule,
                        icon.MatIconModule,
                        tooltip.MatTooltipModule,
                        translate.SdTranslateModule,
                        button$1.SdButtonModule,
                        input.SdInputModule,
                        textarea.SdTextareaModule,
                        editor.SdEditorModule,
                        utility.SdUtilityModule,
                        modal.SdModalModule
                    ],
                    declarations: [
                        SdComment
                    ],
                    exports: [
                        SdComment
                    ],
                    providers: []
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdComment = SdComment;
    exports.SdCommentModule = SdCommentModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-comment.umd.js.map
