(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@sd-angular/core/common'), require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@angular/material/form-field'), require('@angular/material/datepicker'), require('@angular/material-moment-adapter'), require('@angular/material/core'), require('ngx-device-detector'), require('moment'), require('uuid'), require('object-hash'), require('rxjs'), require('@angular/material/icon'), require('@sd-angular/core/translate')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/date-range', ['exports', '@sd-angular/core/common', '@angular/core', '@angular/common', '@angular/forms', '@angular/material/form-field', '@angular/material/datepicker', '@angular/material-moment-adapter', '@angular/material/core', 'ngx-device-detector', 'moment', 'uuid', 'object-hash', 'rxjs', '@angular/material/icon', '@sd-angular/core/translate'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['date-range'] = {}), global['sd-angular'].core.common, global.ng.core, global.ng.common, global.ng.forms, global.ng.material.formField, global.ng.material.datepicker, global.ng.materialMomentAdapter, global.ng.material.core, global['ngx-device-detector'], global.moment, global.uuid, global.hash, global.rxjs, global.ng.material.icon, global['sd-angular'].core.translate));
}(this, (function (exports, common, core, common$1, forms, formField, datepicker, materialMomentAdapter, core$1, ngxDeviceDetector, moment, uuid, hash, rxjs, icon, translate) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var moment__default = /*#__PURE__*/_interopDefaultLegacy(moment);
    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _from, _to, _name, _form, _c1, _c2, _subscription, _onChanges, _emit;
    var CUSTOM_DATE_FORMATS = {
        parse: {
            dateInput: 'DD/MM/YYYY'
        },
        display: {
            dateInput: 'DD/MM/YYYY',
            monthYearLabel: 'MMM YYYY',
            dateA11yLabel: 'LL',
            monthYearA11yLabel: 'MMMM YYYY'
        }
    };
    var ɵ0 = CUSTOM_DATE_FORMATS;
    var SdDateRange = /** @class */ (function () {
        function SdDateRange(cdRef, detectorService, formConfig) {
            var _this = this;
            this.cdRef = cdRef;
            this.detectorService = detectorService;
            this.formConfig = formConfig;
            this.id1 = "I" + uuid.v4();
            this.id2 = "I" + uuid.v4();
            _from.set(this, null);
            _to.set(this, null);
            this.isMobileOrTablet = false;
            _name.set(this, uuid.v4());
            _form.set(this, void 0);
            this.formControl = new forms.FormControl();
            this.required = false;
            this.disableErrorMessage = false;
            this.sdChange = new core.EventEmitter();
            this.fromChange = new core.EventEmitter();
            this.toChange = new core.EventEmitter();
            this.control1 = new forms.FormControl();
            _c1.set(this, uuid.v4());
            this.control2 = new forms.FormControl();
            _c2.set(this, uuid.v4());
            _subscription.set(this, new rxjs.Subscription());
            _onChanges.set(this, function () {
                var from = Date.isDate(__classPrivateFieldGet(_this, _from)) ? moment__default['default'](Date.toFormat(__classPrivateFieldGet(_this, _from), 'MM/dd/yyyy HH:mm:ss'), 'MM/DD/YYYY HH:mm:ss') : null;
                var to = Date.isDate(__classPrivateFieldGet(_this, _to)) ? moment__default['default'](Date.toFormat(__classPrivateFieldGet(_this, _to), 'MM/dd/yyyy HH:mm:ss'), 'MM/DD/YYYY HH:mm:ss') : null;
                _this.control1.setValue(from, {
                    emitEvent: false
                });
                _this.control2.setValue(to, {
                    emitEvent: false
                });
                _this.formControl.setValue({
                    from: from,
                    to: to
                }, {
                    emitEvent: false
                });
                _this.cdRef.markForCheck();
            });
            this.onStartChange = function (event) {
                var _a, _b;
                var value = ((_a = event.value) === null || _a === void 0 ? void 0 : _a.toDate()) || null;
                var current = Date.toFormat((_b = event.value) === null || _b === void 0 ? void 0 : _b.toDate(), 'MM/dd/yyyy HH:mm:ss');
                var previous = Date.toFormat(__classPrivateFieldGet(_this, _from), 'MM/dd/yyyy HH:mm:ss');
                if (previous !== current) {
                    __classPrivateFieldSet(_this, _from, value);
                    _this.fromChange.emit(value);
                    __classPrivateFieldGet(_this, _emit).call(_this);
                }
            };
            this.onEndChange = function (event) {
                var _a, _b;
                var value = ((_a = event.value) === null || _a === void 0 ? void 0 : _a.toDate()) || null;
                var current = Date.toFormat((_b = event.value) === null || _b === void 0 ? void 0 : _b.toDate(), 'MM/dd/yyyy HH:mm:ss');
                var previous = Date.toFormat(__classPrivateFieldGet(_this, _to), 'MM/dd/yyyy HH:mm:ss');
                if (previous !== current) {
                    __classPrivateFieldSet(_this, _to, value);
                    _this.toChange.emit(value);
                    __classPrivateFieldGet(_this, _emit).call(_this);
                }
            };
            _emit.set(this, function () {
                var _a, _b;
                var from = ((_a = _this.control1.value) === null || _a === void 0 ? void 0 : _a.toDate()) || null;
                var to = ((_b = _this.control2.value) === null || _b === void 0 ? void 0 : _b.toDate()) || null;
                _this.formControl.setValue({
                    from: from,
                    to: to
                }, {
                    emitEvent: false
                });
                _this.sdChange.emit(_this.formControl.value);
                _this.cdRef.markForCheck();
            });
            this.clear = function () {
                _this.control1.setValue(null, {
                    emitEvent: false
                });
                _this.control2.setValue(null, {
                    emitEvent: false
                });
                _this.formControl.setValue({
                    from: null,
                    to: null
                }, {
                    emitEvent: false
                });
                __classPrivateFieldSet(_this, _from, _this.control1.value);
                __classPrivateFieldSet(_this, _to, _this.control2.value);
                _this.fromChange.emit(__classPrivateFieldGet(_this, _from));
                _this.toChange.emit(__classPrivateFieldGet(_this, _to));
                _this.sdChange.emit(_this.formControl.value);
                _this.cdRef.markForCheck();
            };
            this.isMobileOrTablet = !this.detectorService.isDesktop();
            this.cdRef.markForCheck();
        }
        Object.defineProperty(SdDateRange.prototype, "name", {
            set: function (val) {
                if (val) {
                    __classPrivateFieldSet(this, _name, val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "form", {
            set: function (val) {
                if (val) {
                    if (val instanceof forms.NgForm) {
                        __classPrivateFieldSet(this, _form, val.form);
                    }
                    else {
                        __classPrivateFieldSet(this, _form, val);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "disabled", {
            // @Input() disabled = false;
            set: function (val) {
                val = (val === '') || val;
                if (val) {
                    this.formControl.disable();
                }
                else {
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "_required", {
            set: function (val) {
                this.required = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "_label", {
            set: function (val) {
                this.label = val;
                this.qcId = hash__default['default']({
                    selector: 'sd-date-range',
                    label: val
                });
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = (val === '') || val;
                val = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "_min", {
            set: function (val) {
                if (Date.isDate(val)) {
                    this.min = new Date(val);
                }
                else {
                    this.min = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "_max", {
            set: function (val) {
                if (Date.isDate(val)) {
                    this.max = new Date(val);
                }
                else {
                    this.max = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "from", {
            set: function (val) {
                if (!Date.isDate(val)) {
                    val = null;
                }
                if (__classPrivateFieldGet(this, _from) !== val) {
                    __classPrivateFieldSet(this, _from, val);
                    __classPrivateFieldGet(this, _onChanges).call(this);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateRange.prototype, "to", {
            set: function (val) {
                if (!Date.isDate(val)) {
                    val = null;
                }
                if (__classPrivateFieldGet(this, _to) !== val) {
                    __classPrivateFieldSet(this, _to, val);
                    __classPrivateFieldGet(this, _onChanges).call(this);
                }
            },
            enumerable: false,
            configurable: true
        });
        SdDateRange.prototype.ngOnDestroy = function () {
            var _a, _b, _c;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.removeControl(__classPrivateFieldGet(this, _c1));
            (_b = __classPrivateFieldGet(this, _form)) === null || _b === void 0 ? void 0 : _b.removeControl(__classPrivateFieldGet(this, _c2));
            (_c = __classPrivateFieldGet(this, _form)) === null || _c === void 0 ? void 0 : _c.removeControl(__classPrivateFieldGet(this, _name));
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        SdDateRange.prototype.ngOnInit = function () {
            var _a, _b, _c, _d;
            this.appearance = this.appearance || ((_a = this.formConfig) === null || _a === void 0 ? void 0 : _a.appearance);
            (_b = __classPrivateFieldGet(this, _form)) === null || _b === void 0 ? void 0 : _b.addControl(__classPrivateFieldGet(this, _c1), this.control1);
            (_c = __classPrivateFieldGet(this, _form)) === null || _c === void 0 ? void 0 : _c.addControl(__classPrivateFieldGet(this, _c2), this.control2);
            (_d = __classPrivateFieldGet(this, _form)) === null || _d === void 0 ? void 0 : _d.addControl(__classPrivateFieldGet(this, _name), this.formControl);
        };
        SdDateRange.prototype.ngAfterViewInit = function () {
            // this.#subscription.add(merge(this.control1.valueChanges, this.control2.valueChanges).pipe(debounceTime(500)).subscribe(() => {
            //   const from = this.control1.value?.toDate() || null;
            //   const to = this.control2.value?.toDate() || null;
            //   const from1 = Date.toFormat(this.#from, 'dd/MM/yyyy HH:mm:ss');
            //   const from2 = Date.toFormat(from, 'dd/MM/yyyy HH:mm:ss');
            //   const to1 = Date.toFormat(this.#to, 'dd/MM/yyyy HH:mm:ss');
            //   const to2 = Date.toFormat(to, 'dd/MM/yyyy HH:mm:ss');
            //   if (from1 !== from2 || to1 !== to2) {
            //     if (from && to) {
            //       this.sdChange.emit({
            //         from,
            //         to
            //       });
            //     } else if (!from && !to) {
            //       this.sdChange.emit({
            //         from: null,
            //         to: null
            //       });
            //     }
            //   }
            // }));
            __classPrivateFieldGet(this, _onChanges).call(this);
        };
        return SdDateRange;
    }());
    _from = new WeakMap(), _to = new WeakMap(), _name = new WeakMap(), _form = new WeakMap(), _c1 = new WeakMap(), _c2 = new WeakMap(), _subscription = new WeakMap(), _onChanges = new WeakMap(), _emit = new WeakMap();
    SdDateRange.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-date-range',
                    template: "<ng-container *ngIf=\"!appearance && sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\">\r\n  </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"!appearance && label &&!sdLabelDef?.templateRef\" class=\"d-block mb-0 T14M\">{{label}} <span class=\"text-danger mb-2\"\r\n    *ngIf=\"required\">*</span></label>\r\n<mat-form-field class=\"sd-md\" [ngClass]=\"{'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage}\"\r\n  [appearance]=\"appearance || 'outline'\">\r\n  <mat-label *ngIf=\"appearance && label\">{{label}}</mat-label>\r\n  <mat-date-range-input [max]=\"max\" [min]=\"min\" [rangePicker]=\"picker\" [disabled]=\"formControl.disabled\">\r\n    <input aria-hidden=\"true\" [id]=\"id1\" autocomplete=\"off\" autocorrect=\"off\" matStartDate [formControl]=\"control1\"\r\n      (dateInput)=\"onStartChange($event)\" [placeholder]=\"formControl.disabled ? '' : ('Start' | sdTranslate)\"\r\n      [attr.data-qclabel]=\"label\" [attr.data-qcid]=\"qcId + 'input1'\">\r\n    <input aria-hidden=\"true\" [id]=\"id2\" [autocomplete]=\"id2\" autocorrect=\"off\" matEndDate [formControl]=\"control2\"\r\n      (dateInput)=\"onEndChange($event)\" [placeholder]=\"formControl.disabled ? '' : ('End' | sdTranslate)\"\r\n      [attr.data-qclabel]=\"label\" [attr.data-qcid]=\"qcId + 'input2'\">\r\n  </mat-date-range-input>\r\n  <mat-icon *ngIf=\"control1?.value || control2?.value\" class=\"pointer sd-suffix-icon\" (click)=\"clear()\" matSuffix>cancel\r\n  </mat-icon>\r\n  <mat-icon class=\"pointer sd-suffix-icon\" (click)=\"!formControl.disabled && picker.open()\" matSuffix>today\r\n  </mat-icon>\r\n  <mat-date-range-picker [touchUi]=\"isMobileOrTablet\" #picker></mat-date-range-picker>\r\n</mat-form-field>",
                    providers: [{ provide: core$1.MAT_DATE_FORMATS, useValue: ɵ0 }],
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host{display:block;padding-top:5px}:host ::ng-deep .mat-form-field.no-padding-wrapper .mat-form-field-wrapper{padding-bottom:0}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{background:#f6f6f6;color:#e9e9e9}:host ::ng-deep .mat-form-field input.mat-end-date:disabled,:host ::ng-deep .mat-form-field input.mat-start-date:disabled{color:#4d4d4d!important}:host ::ng-deep .mat-form-field .mat-placeholder-required{color:#f82c13}"]
                },] }
    ];
    SdDateRange.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: ngxDeviceDetector.DeviceDetectorService },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.FORM_CONFIG,] }, { type: core.Optional }] }
    ]; };
    SdDateRange.propDecorators = {
        name: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        size: [{ type: core.Input }],
        form: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        _required: [{ type: core.Input, args: ['required',] }],
        _label: [{ type: core.Input, args: ['label',] }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        _min: [{ type: core.Input, args: ['min',] }],
        _max: [{ type: core.Input, args: ['max',] }],
        from: [{ type: core.Input }],
        to: [{ type: core.Input }],
        sdChange: [{ type: core.Output }],
        fromChange: [{ type: core.Output }],
        toChange: [{ type: core.Output }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }]
    };

    var SdDateRangeModule = /** @class */ (function () {
        function SdDateRangeModule() {
        }
        return SdDateRangeModule;
    }());
    SdDateRangeModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        formField.MatFormFieldModule,
                        icon.MatIconModule,
                        datepicker.MatDatepickerModule,
                        materialMomentAdapter.MatMomentDateModule,
                        translate.SdTranslateModule
                    ],
                    declarations: [
                        SdDateRange
                    ],
                    exports: [
                        SdDateRange
                    ],
                    providers: []
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdDateRange = SdDateRange;
    exports.SdDateRangeModule = SdDateRangeModule;
    exports.ɵ0 = ɵ0;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-date-range.umd.js.map
