(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular-material-components/datetime-picker'), require('@angular-material-components/moment-adapter'), require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('@angular/material-moment-adapter'), require('@angular/material/datepicker'), require('@angular/material/form-field'), require('@angular/material/icon'), require('@angular/material/input'), require('@sd-angular/core/button'), require('@sd-angular/core/common'), require('@sd-angular/core/translate'), require('ngx-material-timepicker'), require('uuid'), require('object-hash'), require('moment'), require('ngx-device-detector'), require('@angular/material/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/date-time', ['exports', '@angular-material-components/datetime-picker', '@angular-material-components/moment-adapter', '@angular/common', '@angular/core', '@angular/forms', '@angular/material-moment-adapter', '@angular/material/datepicker', '@angular/material/form-field', '@angular/material/icon', '@angular/material/input', '@sd-angular/core/button', '@sd-angular/core/common', '@sd-angular/core/translate', 'ngx-material-timepicker', 'uuid', 'object-hash', 'moment', 'ngx-device-detector', '@angular/material/core', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['date-time'] = {}), global['@angular-material-components/datetime-picker'], global['@angular-material-components/moment-adapter'], global.ng.common, global.ng.core, global.ng.forms, global.ng.materialMomentAdapter, global.ng.material.datepicker, global.ng.material.formField, global.ng.material.icon, global.ng.material.input, global['sd-angular'].core.button, global['sd-angular'].core.common, global['sd-angular'].core.translate, global.ngxMaterialTimepicker, global.uuid, global.hash, global.moment, global['ngx-device-detector'], global.ng.material.core, global.rxjs));
}(this, (function (exports, datetimePicker, momentAdapter, common$1, core, forms, materialMomentAdapter, datepicker, formField, icon, input, button, common, translate, ngxMaterialTimepicker, uuid, hash, moment, ngxDeviceDetector, core$1, rxjs) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);
    var moment__default = /*#__PURE__*/_interopDefaultLegacy(moment);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _date, _name, _form, _subscription;
    var CUSTOM_DATETIME_FORMATS = {
        parse: {
            dateInput: 'DD/MM/YYYY HH:mm'
        },
        display: {
            dateInput: 'DD/MM/YYYY HH:mm',
            monthYearLabel: 'MMM YYYY',
            dateA11yLabel: 'LL',
            monthYearA11yLabel: 'MMMM YYYY'
        }
    };
    var CUSTOM_DATE_FORMATS = {
        parse: {
            dateInput: 'DD/MM/YYYY'
        },
        display: {
            dateInput: 'DD/MM/YYYY',
            monthYearLabel: 'MMM YYYY',
            dateA11yLabel: 'LL',
            monthYearA11yLabel: 'MMMM YYYY'
        }
    };
    var ɵ0 = CUSTOM_DATE_FORMATS, ɵ1 = CUSTOM_DATETIME_FORMATS;
    var SdDateTime = /** @class */ (function () {
        function SdDateTime(ref, deviceService, formConfig) {
            var _this = this;
            this.ref = ref;
            this.formConfig = formConfig;
            this.id = "I" + uuid.v4();
            this.isMobileOrTablet = false;
            _date.set(this, void 0);
            _name.set(this, uuid.v4());
            this.disableErrorMessage = false;
            this.formControl = new common.SdFormControl();
            _form.set(this, void 0);
            this.type = 'datetime';
            this.required = false;
            this.sdChange = new core.EventEmitter();
            this.sdFocus = new core.EventEmitter();
            this.modelChange = new core.EventEmitter();
            _subscription.set(this, new rxjs.Subscription());
            this.isFocused = false;
            this.onFocus = function () {
                _this.isFocused = true;
                _this.sdFocus.emit();
            };
            this.onBlur = function () {
                _this.isFocused = false;
            };
            this.onClick = function () {
                var _a;
                if ((_a = _this.sdView) === null || _a === void 0 ? void 0 : _a.templateRef) {
                    if (!_this.formControl.disabled && !_this.isFocused) {
                        _this.focus();
                    }
                }
            };
            this.blur = function () {
                var _a, _b;
                (_b = (_a = _this.input) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.blur();
            };
            this.focus = function () {
                _this.isFocused = true;
                setTimeout(function () {
                    var _a, _b, _c, _d;
                    (_b = (_a = _this.input) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.focus();
                    if (_this.type === 'date') {
                        (_c = _this.datePicker) === null || _c === void 0 ? void 0 : _c.open();
                    }
                    else {
                        (_d = _this.dateTimePicker) === null || _d === void 0 ? void 0 : _d.open();
                    }
                    //
                }, 100);
            };
            this.onKeyDown = function (event) {
                var key = event.keyCode || event.charCode;
                var isShift = false;
                if (key === 16) {
                    isShift = true;
                }
                // cho phép copy parse
                if (event.ctrlKey && (key === 67 || key === 86)) {
                    console.log('action copy parse... datepicker');
                    return true;
                }
                // Allow only Numeric Keys.
                if (((key >= 48 && key <= 57) || key === 8 || key <= 37 || key <= 39 || (key >= 96 && key <= 105) || key === 191 || key === 186 || key === 59) && isShift === false) {
                    return true;
                }
                else {
                    return false;
                }
            };
            this.onKeyup = function (event) {
                var currentVal = event.target.value;
                var formControl = _this.formControl;
                var regex = /^([1-9]|([012][0-9])|(3[01]))\/([0]{0,1}[1-9]|1[012])\/\d\d\d\d$/g;
                if (_this.type === 'datetime' || _this.type === 'time') {
                    regex = /^([1-9]|([012][0-9])|(3[01]))\/([0]{0,1}[1-9]|1[012])\/\d\d\d\d [012]{0,1}[0-9]:[0-6][0-9]$/g;
                }
                if (_this.type === 'month') {
                    regex = /^([0]{0,1}[1-9]|1[012])\/\d\d\d\d [012]{0,1}[0-9]:[0-6][0-9]$/g;
                }
                var errorMessage = _this.type === 'date' ? 'dd/MM/yyyy' : 'dd/MM/yyyy HH:mm';
                if (currentVal && !regex.test(currentVal)) {
                    setTimeout(function () {
                        _this.isValid = true;
                        formControl.markAsDirty();
                        formControl.markAsTouched();
                        formControl.setErrors(Object.assign(Object.assign({}, formControl.errors), { date: "Ch\u01B0a \u0111\u00FAng \u0111\u1ECBnh d\u1EA1ng " + errorMessage }));
                    }, 0);
                }
                else {
                    setTimeout(function () {
                        _this.isValid = false;
                        formControl.setErrors(Object.assign(Object.assign({}, formControl.errors), { date: null }));
                        _this.formControl.updateValueAndValidity();
                    }, 0);
                }
            };
            this.onChange = function (event) {
                var _a, _b, _c;
                var value = (_a = event.value) === null || _a === void 0 ? void 0 : _a.toDate();
                if (!_this.dateTimePicker) {
                    (_c = (_b = _this.input) === null || _b === void 0 ? void 0 : _b.nativeElement) === null || _c === void 0 ? void 0 : _c.focus();
                }
                if (!_this.isValid) {
                    if (new Date(__classPrivateFieldGet(_this, _date)) !== value) {
                        _this.modelChange.emit(value);
                        _this.sdChange.emit(value);
                    }
                }
                else {
                    _this.isValid = false;
                    _this.formControl.setValue(null);
                    _this.modelChange.emit(null);
                    _this.sdChange.emit(null);
                }
            };
            this.timeChanged = function (event) {
                var value = event;
                _this.formControl.setValue(value);
                _this.modelChange.emit(value);
                _this.sdChange.emit(value);
            };
            this.clear = function ($event) {
                $event === null || $event === void 0 ? void 0 : $event.stopPropagation();
                if (_this.formControl.value) {
                    _this.formControl.setValue(null);
                    _this.modelChange.emit(null);
                    _this.sdChange.emit(null);
                }
            };
            this.setMonthAndYear = function (normalizedMonthAndYear, datepicker) {
                var ctrlValue = _this.formControl.value || moment__default['default']();
                ctrlValue.month(normalizedMonthAndYear.month());
                ctrlValue.year(normalizedMonthAndYear.year());
                _this.formControl.setValue(ctrlValue);
                datepicker.close();
                _this.modelChange.emit(ctrlValue);
                _this.sdChange.emit(ctrlValue);
            };
            this.isMobileOrTablet = !deviceService.isDesktop();
        }
        Object.defineProperty(SdDateTime.prototype, "name", {
            set: function (val) {
                if (val) {
                    __classPrivateFieldSet(this, _name, val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = (val === '') || val;
                val = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "_min", {
            set: function (val) {
                if (Date.isDate(val)) {
                    this.min = new Date(val);
                }
                else {
                    this.min = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "_max", {
            set: function (val) {
                if (Date.isDate(val)) {
                    this.max = new Date(val);
                }
                else {
                    this.max = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "form", {
            set: function (val) {
                if (val) {
                    if (val instanceof forms.NgForm) {
                        __classPrivateFieldSet(this, _form, val.form);
                    }
                    else {
                        __classPrivateFieldSet(this, _form, val);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "_type", {
            set: function (val) {
                this.type = val || 'datetime';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "disabled", {
            set: function (val) {
                val = (val === '') || val;
                if (val) {
                    this.formControl.disable();
                }
                else {
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "_required", {
            set: function (val) {
                this.required = (val === '') || val;
                if (this.required) {
                    this.formControl.setValidators([forms.Validators.required]);
                }
                else {
                    this.formControl.clearValidators();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "_inlineError", {
            set: function (val) {
                this.inlineError = val;
                // this.#updateValidator();
                if (this.inlineError) {
                    this.formControl.setValidators([this.customInlineErrorValidator()]);
                    this.formControl.updateValueAndValidity();
                }
                else {
                    this.formControl.clearValidators();
                    this.formControl.updateValueAndValidity();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "_label", {
            set: function (val) {
                this.label = val;
                this.qcId = hash__default['default']({
                    selector: 'sd-date-time',
                    label: val
                });
            },
            enumerable: false,
            configurable: true
        });
        ;
        Object.defineProperty(SdDateTime.prototype, "minDate", {
            set: function (val) {
                if (Date.isDate(val)) {
                    this.min = new Date(val);
                }
                else {
                    this.min = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "maxDate", {
            set: function (val) {
                if (Date.isDate(val)) {
                    this.max = new Date(val);
                }
                else {
                    this.max = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdDateTime.prototype, "model", {
            set: function (val) {
                if (!Date.isDate(val)) {
                    val = null;
                }
                if (__classPrivateFieldGet(this, _date) !== val) {
                    __classPrivateFieldSet(this, _date, val);
                    var date = Date.isDate(__classPrivateFieldGet(this, _date)) ? moment__default['default'](Date.toFormat(__classPrivateFieldGet(this, _date), 'MM/dd/yyyy HH:mm:ss'), 'MM/DD/YYYY HH:mm:ss') : null;
                    this.formControl.setValue(date);
                }
            },
            enumerable: false,
            configurable: true
        });
        SdDateTime.prototype.ngOnDestroy = function () {
            var _a;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.removeControl(__classPrivateFieldGet(this, _name));
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        SdDateTime.prototype.ngOnInit = function () {
            var _this = this;
            var _a, _b;
            this.maxlength = this.type === 'datetime' ? 16 : 10;
            this.appearance = this.appearance || ((_a = this.formConfig) === null || _a === void 0 ? void 0 : _a.appearance);
            __classPrivateFieldGet(this, _subscription).add(this.formControl.sdChanges.subscribe(function () {
                // this.formControl.updateValueAndValidity();
                _this.ref.markForCheck();
            }));
            (_b = __classPrivateFieldGet(this, _form)) === null || _b === void 0 ? void 0 : _b.addControl(__classPrivateFieldGet(this, _name), this.formControl);
        };
        // Hàm tạo Validators tùy chỉnh cho inlineError
        SdDateTime.prototype.customInlineErrorValidator = function () {
            return function (control) {
                return { inlineError: true };
            };
        };
        SdDateTime.prototype.ngAfterViewInit = function () {
        };
        SdDateTime.prototype.focusInputElement = function () {
            var _a, _b;
            (_b = (_a = this.input) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.focus();
        };
        return SdDateTime;
    }());
    _date = new WeakMap(), _name = new WeakMap(), _form = new WeakMap(), _subscription = new WeakMap();
    SdDateTime.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-date-time',
                    template: "<ng-container *ngIf=\"!appearance && sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\"> </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"!appearance && label && !sdLabelDef?.templateRef\" class=\"d-block mb-0 T14M\"\r\n  >{{ label }} <span class=\"text-danger mb-2\" *ngIf=\"required\">*</span></label\r\n>\r\n<div\r\n  class=\"d-flex align-items-center\"\r\n  [class.sd-view]=\"sdView?.templateRef\"\r\n  [class.c-focused]=\"isFocused\"\r\n  [class.c-disabled]=\"formControl.disabled\"\r\n  (click)=\"onClick()\">\r\n  <ng-container *ngIf=\"sdView?.templateRef && !isFocused && !datePicker?.opened && !dateTimePicker?.opened; else default\">\r\n    <ng-container *ngTemplateOutlet=\"sdView.templateRef; context: { value: formControl.value }\"> </ng-container>\r\n  </ng-container>\r\n  <ng-template #default>\r\n    <mat-form-field\r\n      *ngIf=\"type === 'datetime'\"\r\n      class=\"sd-md\"\r\n      [ngClass]=\"{ 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage }\"\r\n      [appearance]=\"appearance || 'outline'\">\r\n      <mat-label *ngIf=\"appearance && label\">{{ label }}</mat-label>\r\n      <input\r\n        aria-hidden=\"true\"\r\n        [id]=\"id\"\r\n        matInput\r\n        (keyup)=\"onKeyup($event)\"\r\n        (keydown)=\"onKeyDown($event)\"\r\n        (dateChange)=\"onChange($event)\"\r\n        [autocomplete]=\"id\"\r\n        autocorrect=\"off\"\r\n        [formControl]=\"formControl\"\r\n        [ngxMatDatetimePicker]=\"picker1\"\r\n        [placeholder]=\"placeholder || (appearance ? label : '')\"\r\n        [min]=\"min\"\r\n        [required]=\"required\"\r\n        [max]=\"max\"\r\n        (focus)=\"onFocus()\"\r\n        (blur)=\"onBlur()\"\r\n        [attr.data-qclabel]=\"label\"\r\n        [attr.data-qcid]=\"qcId\"\r\n        #input\r\n        [maxLength]=\"maxlength\" />\r\n      <!-- <mat-icon class=\"pointer sd-suffix-icon\" (click)=\"!formControl?.disabled && picker1.open()\" matSuffix>today\r\n      </mat-icon> -->\r\n      <ng-content select=\"[sdSuffixIcon]\" matSuffix></ng-content>\r\n      <mat-icon\r\n        *ngIf=\"formControl?.value && !required && !formControl.disabled\"\r\n        class=\"pointer sd-suffix-icon\"\r\n        (click)=\"clear($event)\"\r\n        matSuffix\r\n        >cancel\r\n      </mat-icon>\r\n      <mat-datepicker-toggle matSuffix [for]=\"picker1\"> </mat-datepicker-toggle>\r\n      <ngx-mat-datetime-picker\r\n        #picker1\r\n        [defaultTime]=\"defaultTime\"\r\n        [touchUi]=\"isMobileOrTablet\"\r\n        [showSpinners]=\"false\"\r\n        (opened)=\"onFocus()\"\r\n        (closed)=\"onBlur(); focusInputElement()\">\r\n      </ngx-mat-datetime-picker>\r\n\r\n      <mat-error *ngIf=\"formControl?.errors?.required && formControl?.touched\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ 'This field is required' | sdTranslate }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatetimePickerMin && formControl?.touched && !isFocused\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Min date' | sdTranslate }}:\r\n          <strong>{{ min | date : 'dd/MM/yyyy HH:mm' }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatetimePickerMax && formControl?.touched && !isFocused\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Max date' | sdTranslate }}:\r\n          <strong>{{ max | date : 'dd/MM/yyyy HH:mm' }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatetimePickerParse && formControl?.touched && !isFocused\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Parse error' | sdTranslate }}:\r\n          <strong>{{ formControl?.errors?.matDatetimePickerParse?.text }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.customValidator && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ formControl?.errors?.customValidator }} </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.date && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ formControl?.errors?.date }} </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.inlineError && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ inlineError }}</ng-container>\r\n      </mat-error>\r\n    </mat-form-field>\r\n    <mat-form-field\r\n      *ngIf=\"type === 'date'\"\r\n      class=\"sd-md\"\r\n      [ngClass]=\"{ 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage }\"\r\n      [appearance]=\"appearance || 'outline'\">\r\n      <mat-label *ngIf=\"appearance && label\">{{ label }}</mat-label>\r\n      <input\r\n        aria-hidden=\"true\"\r\n        [id]=\"id\"\r\n        matInput\r\n        (keyup)=\"onKeyup($event)\"\r\n        (keydown)=\"onKeyDown($event)\"\r\n        (dateChange)=\"onChange($event)\"\r\n        [autocomplete]=\"id\"\r\n        autocorrect=\"off\"\r\n        [formControl]=\"formControl\"\r\n        [required]=\"required\"\r\n        [matDatepicker]=\"picker2\"\r\n        [placeholder]=\"placeholder || (appearance ? label : '')\"\r\n        [min]=\"min\"\r\n        [max]=\"max\"\r\n        (focus)=\"onFocus()\"\r\n        (blur)=\"onBlur()\"\r\n        [attr.data-qclabel]=\"label\"\r\n        [attr.data-qcid]=\"qcId\"\r\n        #input\r\n        [maxLength]=\"maxlength\" />\r\n      <ng-content select=\"[sdSuffixIcon]\" matSuffix></ng-content>\r\n      <mat-icon\r\n        *ngIf=\"formControl?.value && !required && !formControl.disabled\"\r\n        class=\"pointer sd-suffix-icon\"\r\n        (click)=\"clear($event)\"\r\n        matSuffix\r\n        >cancel\r\n      </mat-icon>\r\n\r\n      <mat-icon class=\"pointer sd-suffix-icon\" (click)=\"!formControl?.disabled && picker2.open()\" #btn matSuffix>today </mat-icon>\r\n\r\n      <mat-datepicker #picker2 [touchUi]=\"isMobileOrTablet\"></mat-datepicker>\r\n\r\n      <mat-error *ngIf=\"formControl?.errors?.required && formControl?.touched\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ 'This field is required' | sdTranslate }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatepickerMin && formControl?.touched && !isFocused\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Min date' | sdTranslate }}:\r\n          <strong>{{ min | date : 'dd/MM/yyyy HH:mm' }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatepickerMax && formControl?.touched && !isFocused\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Max date' | sdTranslate }}:\r\n          <strong>{{ max | date : 'dd/MM/yyyy HH:mm' }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatetimePickerParse && formControl?.touched && !isFocused\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Parse error' | sdTranslate }}:\r\n          <strong>{{ formControl?.errors?.matDatetimePickerParse?.text }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.customValidator && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ formControl?.errors?.customValidator }} </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.date && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ formControl?.errors?.date }} </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.inlineError && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ inlineError }}</ng-container>\r\n      </mat-error>\r\n    </mat-form-field>\r\n\r\n    <mat-form-field\r\n      *ngIf=\"type === 'month'\"\r\n      class=\"sd-md\"\r\n      [ngClass]=\"{ 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage }\"\r\n      appearance=\"outline\">\r\n      <mat-label *ngIf=\"label\">{{ label }}</mat-label>\r\n      <input\r\n        aria-hidden=\"true\"\r\n        [id]=\"id\"\r\n        matInput\r\n        (keyup)=\"onKeyup($event)\"\r\n        (keydown)=\"onKeyDown($event)\"\r\n        (dateChange)=\"onChange($event)\"\r\n        [autocomplete]=\"id\"\r\n        autocorrect=\"off\"\r\n        [formControl]=\"formControl\"\r\n        [required]=\"required\"\r\n        [matDatepicker]=\"pickerMonth\"\r\n        [placeholder]=\"placeholder || (appearance ? label : '')\"\r\n        [min]=\"min\"\r\n        [max]=\"max\"\r\n        (focus)=\"onFocus()\"\r\n        (blur)=\"onBlur()\"\r\n        #input />\r\n\r\n      <mat-icon\r\n        *ngIf=\"formControl?.value && !required && !formControl.disabled\"\r\n        class=\"pointer sd-suffix-icon\"\r\n        (click)=\"clear($event)\"\r\n        matSuffix\r\n        >cancel\r\n      </mat-icon>\r\n      <mat-icon class=\"pointer sd-suffix-icon\" (click)=\"!formControl?.disabled && pickerMonth.open()\" #btn matSuffix> today </mat-icon>\r\n\r\n      <mat-datepicker\r\n        #pickerMonth\r\n        [touchUi]=\"isMobileOrTablet\"\r\n        startView=\"multi-year\"\r\n        (monthSelected)=\"setMonthAndYear($event, pickerMonth)\"></mat-datepicker>\r\n\r\n      <mat-error *ngIf=\"formControl?.errors?.required && formControl?.touched\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ 'This field is required' | sdTranslate }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatepickerMin && formControl?.touched\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Min date' | sdTranslate }}:\r\n          <strong>{{ min | date : 'dd/MM/yyyy HH:mm' }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatepickerMax && formControl?.touched\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Max date' | sdTranslate }}:\r\n          <strong>{{ max | date : 'dd/MM/yyyy HH:mm' }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.matDatetimePickerParse && formControl?.touched\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\"\r\n          >{{ 'Parse error' | sdTranslate }}:\r\n          <strong>{{ formControl?.errors?.matDatetimePickerParse?.text }}</strong>\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.customValidator && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ formControl?.errors?.customValidator }} </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.inlineError && formControl?.touched && !disableErrorMessage\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ inlineError }}</ng-container>\r\n      </mat-error>\r\n    </mat-form-field>\r\n\r\n    <ng-container *ngIf=\"type === 'time'\">\r\n      <mat-form-field [appearance]=\"appearance || 'outline'\" class=\"sd-md pt-5\">\r\n        <mat-label *ngIf=\"appearance && label\">{{ label }}</mat-label>\r\n        <input\r\n          [ngxTimepicker]=\"openingTime\"\r\n          aria-hidden=\"true\"\r\n          [id]=\"id\"\r\n          matInput\r\n          (keyup)=\"onKeyup($event)\"\r\n          (keydown)=\"onKeyDown($event)\"\r\n          [autocomplete]=\"id\"\r\n          autocorrect=\"off\"\r\n          [formControl]=\"formControl\"\r\n          [required]=\"required\"\r\n          [placeholder]=\"placeholder || (appearance ? label : '')\"\r\n          [min]=\"min\"\r\n          [max]=\"max\"\r\n          (focus)=\"onFocus()\"\r\n          (blur)=\"onBlur()\"\r\n          [attr.data-qclabel]=\"label\"\r\n          [attr.data-qcid]=\"qcId\"\r\n          #input\r\n          [format]=\"24\" />\r\n\r\n        <ngx-material-timepicker\r\n          #openingTime\r\n          [defaultTime]=\"defaultTime\"\r\n          (timeChanged)=\"timeChanged($event)\"\r\n          [enableKeyboardInput]=\"true\"\r\n          [cancelBtnTmpl]=\"cancelBtn\"\r\n          [confirmBtnTmpl]=\"confirmBtn\"></ngx-material-timepicker>\r\n\r\n        <mat-error *ngIf=\"formControl?.errors?.required && formControl?.touched\">\r\n          <ng-container *ngIf=\"!disableErrorMessage\">{{ 'This field is required' | sdTranslate }}</ng-container>\r\n        </mat-error>\r\n        <mat-error *ngIf=\"formControl.errors?.inlineError && formControl?.touched\">\r\n          <ng-container *ngIf=\"!disableErrorMessage\">{{ inlineError }}</ng-container>\r\n        </mat-error>\r\n      </mat-form-field>\r\n\r\n      <ng-template #cancelBtn>\r\n        <sd-button title=\"{{ 'Cancel' | sdTranslate }}\" size=\"sm\"></sd-button>\r\n      </ng-template>\r\n      <ng-template #confirmBtn>\r\n        <sd-button class=\"ml-8\" title=\"{{ 'Apply' | sdTranslate }}\" color=\"primary\" size=\"sm\"></sd-button>\r\n      </ng-template>\r\n    </ng-container>\r\n  </ng-template>\r\n</div>\r\n<!-- <sd-popover #error=\"sdPopover\" type=\"danger\" width=\"300px\">\r\n  <span *ngIf=\"formControl.errors?.required\">\r\n    {{ \"This field is required\" | sdTranslate }}\r\n  </span>\r\n  <span *ngIf=\"formControl?.errors?.matDatetimePickerMin\">\r\n    {{ \"Min date\" | sdTranslate }}:\r\n    <strong>{{ min | date: \"dd/MM/yyyy HH:mm\" }}</strong>\r\n  </span>\r\n  <span *ngIf=\"formControl?.errors?.matDatetimePickerMax\">\r\n    {{ \"Max date\" | sdTranslate }}:\r\n    <strong>{{ max | date: \"dd/MM/yyyy HH:mm\" }}</strong>\r\n  </span>\r\n  <span *ngIf=\"formControl?.errors?.matDatetimePickerParse\">\r\n    {{ \"Parse error\" | sdTranslate }}:\r\n    <strong>{{ formControl?.errors?.matDatetimePickerParse?.text }}</strong>\r\n  </span>\r\n  <span *ngIf=\"formControl?.errors?.customValidator\">\r\n    {{ formControl?.errors?.customValidator }}\r\n  </span>\r\n</sd-popover> -->\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        { provide: core$1.MAT_DATE_FORMATS, useValue: ɵ0 },
                        { provide: datetimePicker.NGX_MAT_DATE_FORMATS, useValue: ɵ1 }
                    ],
                    styles: [":host{display:block;padding-top:5px}:host ::ng-deep .mat-form-field.no-padding-wrapper .mat-form-field-wrapper{padding-bottom:0}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{background:#f6f6f6;color:#e9e9e9}:host ::ng-deep .mat-form-field input.mat-input-element:disabled{color:#4d4d4d!important}:host ::ng-deep .mat-form-field .mat-placeholder-required{color:#f82c13}.sd-view:not(.c-focused):not(.c-disabled):hover{background-color:#ebecf0}"]
                },] }
    ];
    SdDateTime.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: ngxDeviceDetector.DeviceDetectorService },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.FORM_CONFIG,] }, { type: core.Optional }] }
    ]; };
    SdDateTime.propDecorators = {
        name: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        _min: [{ type: core.Input, args: ['min',] }],
        _max: [{ type: core.Input, args: ['max',] }],
        size: [{ type: core.Input }],
        form: [{ type: core.Input }],
        _type: [{ type: core.Input, args: ['type',] }],
        disabled: [{ type: core.Input }],
        _required: [{ type: core.Input, args: ['required',] }],
        _inlineError: [{ type: core.Input, args: ['inlineError',] }],
        _label: [{ type: core.Input, args: ['label',] }],
        placeholder: [{ type: core.Input }],
        defaultTime: [{ type: core.Input }],
        minDate: [{ type: core.Input }],
        maxDate: [{ type: core.Input }],
        validator: [{ type: core.Input }],
        sdChange: [{ type: core.Output }],
        sdFocus: [{ type: core.Output }],
        model: [{ type: core.Input }],
        modelChange: [{ type: core.Output }],
        sdView: [{ type: core.ContentChild, args: [common.SdViewDefDirective,] }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }],
        input: [{ type: core.ViewChild, args: ['input',] }],
        datePicker: [{ type: core.ViewChild, args: [datepicker.MatDatepicker,] }],
        dateTimePicker: [{ type: core.ViewChild, args: [datetimePicker.NgxMatDatetimePicker,] }]
    };

    var SdDateTimeModule = /** @class */ (function () {
        function SdDateTimeModule() {
        }
        return SdDateTimeModule;
    }());
    SdDateTimeModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        input.MatInputModule,
                        icon.MatIconModule,
                        formField.MatFormFieldModule,
                        datepicker.MatDatepickerModule,
                        materialMomentAdapter.MatMomentDateModule,
                        datetimePicker.NgxMatDatetimePickerModule,
                        datetimePicker.NgxMatTimepickerModule,
                        momentAdapter.NgxMatMomentModule,
                        translate.SdTranslateModule,
                        common.SdCommonModule,
                        ngxMaterialTimepicker.NgxMaterialTimepickerModule,
                        button.SdButtonModule
                    ],
                    declarations: [
                        SdDateTime
                    ],
                    exports: [
                        common.SdCommonModule,
                        SdDateTime
                    ],
                    providers: []
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdDateTime = SdDateTime;
    exports.SdDateTimeModule = SdDateTimeModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-date-time.umd.js.map
