(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@sd-angular/core/common'), require('@angular/core'), require('@sd-angular/core/api'), require('uuid'), require('object-hash'), require('export-to-csv'), require('exceljs'), require('@sd-angular/core/notify')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/export', ['exports', '@sd-angular/core/common', '@angular/core', '@sd-angular/core/api', 'uuid', 'object-hash', 'export-to-csv', 'exceljs', '@sd-angular/core/notify'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.export = {}), global['sd-angular'].core.common, global.ng.core, global['sd-angular'].core.api, global.uuid, global['object-hash'], global.exportToCsv, global.exceljs, global['sd-angular'].core.notify));
}(this, (function (exports, i3, i0, i1, uuid, hash, exportToCsv, exceljs, i2) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    var API = {
        uploadTemplate: '/excel/uploadTemplate',
        generateUploadTemplate: '/excel/generateUploadTemplate',
        filesInFolder: '/excel/filesInFolder',
        removeFile: '/excel/remove',
        sdExportByTemplate: '/excel/sd-export-by-template',
        sdMergePDF: '/excel/sd-merge-pdf',
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _fieldStyle, _titleColor, _titleFgColor, _titleStyle, _requiredStyle, _descriptionStyle, _cellStyle, _directory;
    var SdExportService = /** @class */ (function () {
        function SdExportService(apiService, notifyService, firebaseConfiguration) {
            var _this = this;
            this.apiService = apiService;
            this.notifyService = notifyService;
            this.firebaseConfiguration = firebaseConfiguration;
            _fieldStyle.set(this, {
                border: {
                    bottom: { style: 'thin' },
                    left: { style: 'thin' },
                    right: { style: 'thin' },
                },
                alignment: {
                    vertical: 'middle',
                    horizontal: 'center',
                    wrapText: true,
                },
                font: {
                    bold: true,
                    size: 11,
                    color: { argb: '000000' },
                },
                fill: {
                    type: 'pattern',
                    pattern: 'solid',
                    fgColor: {
                        argb: 'FAFAFA',
                    },
                },
            });
            _titleColor.set(this, 'FFFFFF');
            _titleFgColor.set(this, '143180');
            _titleStyle.set(this, {
                border: {
                    bottom: { style: 'thin' },
                    left: { style: 'thin' },
                    right: { style: 'thin' },
                },
                alignment: {
                    vertical: 'middle',
                    horizontal: 'center',
                    wrapText: true,
                },
                font: {
                    bold: true,
                    size: 11,
                    color: { argb: __classPrivateFieldGet(this, _titleColor) },
                },
                fill: {
                    type: 'pattern',
                    pattern: 'solid',
                    fgColor: {
                        argb: __classPrivateFieldGet(this, _titleFgColor),
                    },
                },
            });
            _requiredStyle.set(this, {
                border: {
                    bottom: { style: 'thin' },
                    left: { style: 'thin' },
                    right: { style: 'thin' },
                },
                alignment: {
                    vertical: 'middle',
                    horizontal: 'center',
                    wrapText: true,
                },
                font: {
                    italic: true,
                    size: 11,
                    color: { argb: 'FFFFFF' },
                },
                fill: {
                    type: 'pattern',
                    pattern: 'solid',
                    fgColor: {
                        argb: 'FF1744',
                    },
                },
            });
            _descriptionStyle.set(this, {
                border: {
                    bottom: { style: 'thin' },
                    left: { style: 'thin' },
                    right: { style: 'thin' },
                },
                alignment: {
                    wrapText: true,
                },
                font: {
                    italic: true,
                    size: 9,
                    color: { argb: '000000' },
                },
                fill: {
                    type: 'pattern',
                    pattern: 'solid',
                    fgColor: {
                        argb: 'CFD8DC',
                    },
                },
            });
            _cellStyle.set(this, {
                alignment: {
                    vertical: 'middle',
                    wrapText: true,
                },
            });
            _directory.set(this, function (key, group) {
                var hashedFolder = hash__default['default']({
                    folder: _this.folder,
                    userFolder: _this.userFolder,
                });
                if (!group) {
                    return "dir1=" + _this.folder + "&dir2=U-" + hashedFolder + "&dir3=" + (key || '');
                }
                hashedFolder = hash__default['default']({
                    folder: _this.folder,
                    group: group,
                });
                return "dir1=" + _this.folder + "&dir2=G-" + hashedFolder + "&dir3=" + (key || '');
            });
            this.generateTemplate = function (template) { return __awaiter(_this, void 0, void 0, function () {
                var fileName, columns, sheets, _g, _h, _j, idx, column, hasDescription, workbook, firstSheet, _loop_1, sheets_1, sheets_1_1, sheet, file;
                var e_1, _k, e_2, _l;
                var _this = this;
                return __generator(this, function (_m) {
                    switch (_m.label) {
                        case 0:
                            fileName = template.fileName, columns = template.columns, sheets = template.sheets;
                            if (!Array.isArray(columns)) {
                                throw new Error('Excel template columns must be an array');
                            }
                            try {
                                for (_g = __values(columns.entries()), _h = _g.next(); !_h.done; _h = _g.next()) {
                                    _j = __read(_h.value, 2), idx = _j[0], column = _j[1];
                                    if (!column.field) {
                                        throw new Error("Column " + (idx + 1) + ": Field is required");
                                    }
                                    if (!column.title) {
                                        throw new Error("Column " + (idx + 1) + ": Title is required");
                                    }
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_h && !_h.done && (_k = _g.return)) _k.call(_g);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            hasDescription = columns.some(function (column) { return column.description; });
                            workbook = new exceljs.Workbook();
                            firstSheet = workbook.addWorksheet('template');
                            columns.forEach(function (column, index) {
                                var _a, _b, _c, _d, _e, _f;
                                var required = column.required, fill = column.fill, fontColor = column.fontColor;
                                var cellField = firstSheet.getCell(1, index + 1);
                                var cellTitle = firstSheet.getCell(2, index + 1);
                                var cellDescription = firstSheet.getCell(3, index + 1);
                                var width = 120;
                                if (column.width && column.width.endsWith('px')) {
                                    width = +column.width.replace('px', '');
                                }
                                firstSheet.getColumn(index + 1).width = width / 7 || 20;
                                cellField.style = __classPrivateFieldGet(_this, _fieldStyle);
                                if (required) {
                                    cellField.style = __classPrivateFieldGet(_this, _requiredStyle);
                                }
                                else {
                                    cellField.style = __classPrivateFieldGet(_this, _fieldStyle);
                                }
                                cellTitle.style = Object.assign(Object.assign({}, __classPrivateFieldGet(_this, _titleStyle)), { font: Object.assign(Object.assign({}, (_a = __classPrivateFieldGet(_this, _titleStyle)) === null || _a === void 0 ? void 0 : _a.font), { color: Object.assign(Object.assign({}, (_c = (_b = __classPrivateFieldGet(_this, _titleStyle)) === null || _b === void 0 ? void 0 : _b.font) === null || _c === void 0 ? void 0 : _c.color), { argb: fontColor || ((_f = (_e = (_d = __classPrivateFieldGet(_this, _titleStyle)) === null || _d === void 0 ? void 0 : _d.font) === null || _e === void 0 ? void 0 : _e.color) === null || _f === void 0 ? void 0 : _f.argb) }) }), fill: {
                                        type: 'pattern',
                                        pattern: 'solid',
                                        fgColor: {
                                            argb: fill || __classPrivateFieldGet(_this, _titleFgColor),
                                        },
                                    } });
                                cellField.value = column.field;
                                cellTitle.value = column.title;
                                if (hasDescription) {
                                    cellDescription.style = __classPrivateFieldGet(_this, _descriptionStyle);
                                    cellDescription.value = column.description || '';
                                }
                            });
                            if (sheets === null || sheets === void 0 ? void 0 : sheets.length) {
                                _loop_1 = function (sheet) {
                                    if (sheet.name && Array.isArray(sheet.items) && Array.isArray(sheet.fields)) {
                                        var newSheet_1 = workbook.addWorksheet(sheet.name);
                                        sheet.fields.forEach(function (field, index) {
                                            newSheet_1.getColumn(index + 1).width = 30;
                                            newSheet_1.getCell(1, index + 1).style = __classPrivateFieldGet(_this, _titleStyle);
                                            newSheet_1.getCell(1, index + 1).value = field;
                                        });
                                        sheet.items.forEach(function (item, idx1) {
                                            sheet.fields.forEach(function (field, idx2) {
                                                newSheet_1.getCell(2 + idx1, 1 + idx2).value = item[field];
                                                newSheet_1.getCell(2 + idx1, 1 + idx2).style = __classPrivateFieldGet(_this, _cellStyle);
                                            });
                                        });
                                    }
                                };
                                try {
                                    for (sheets_1 = __values(sheets), sheets_1_1 = sheets_1.next(); !sheets_1_1.done; sheets_1_1 = sheets_1.next()) {
                                        sheet = sheets_1_1.value;
                                        _loop_1(sheet);
                                    }
                                }
                                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                                finally {
                                    try {
                                        if (sheets_1_1 && !sheets_1_1.done && (_l = sheets_1.return)) _l.call(sheets_1);
                                    }
                                    finally { if (e_2) throw e_2.error; }
                                }
                            }
                            return [4 /*yield*/, workbook.xlsx.writeBuffer()];
                        case 1:
                            file = _m.sent();
                            SdUtility.downloadBlob(new Blob([file], { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' }), fileName);
                            return [2 /*return*/];
                    }
                });
            }); };
            this.uploadTemplate = function (args) { return __awaiter(_this, void 0, void 0, function () {
                var key, group, validator, uploadTemplate, url, file, _g, filePath, fileName;
                var _this = this;
                return __generator(this, function (_h) {
                    switch (_h.label) {
                        case 0:
                            key = args.key, group = args.group, validator = args.validator;
                            uploadTemplate = API.uploadTemplate;
                            url = "" + this.functionUrl + uploadTemplate + "?" + __classPrivateFieldGet(this, _directory).call(this, key, group);
                            return [4 /*yield*/, SdUtility.upload({
                                    extensions: ['xlsx'],
                                    maxSizeInMb: 0.1,
                                    validator: validator,
                                })];
                        case 1:
                            file = _h.sent();
                            if (!file) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.apiService.upload(url, file).catch(function (err) {
                                    _this.notifyService.notify.warning(err === null || err === void 0 ? void 0 : err.message);
                                    throw err;
                                })];
                        case 2:
                            _g = _h.sent(), filePath = _g.filePath, fileName = _g.fileName;
                            return [2 /*return*/, {
                                    filePath: filePath,
                                    fileName: fileName,
                                }];
                        case 3: return [2 /*return*/, null];
                    }
                });
            }); };
            this.generateUploadTemplate = function (args) { return __awaiter(_this, void 0, void 0, function () {
                var key, template, group, generateUploadTemplate, url, _g, filePath, fileName;
                return __generator(this, function (_h) {
                    switch (_h.label) {
                        case 0:
                            key = args.key, template = args.template, group = args.group;
                            generateUploadTemplate = API.generateUploadTemplate;
                            url = "" + this.functionUrl + generateUploadTemplate + "?" + __classPrivateFieldGet(this, _directory).call(this, key, group);
                            return [4 /*yield*/, this.apiService.post(url, template)];
                        case 1:
                            _g = _h.sent(), filePath = _g.filePath, fileName = _g.fileName;
                            return [2 /*return*/, { filePath: filePath, fileName: fileName }];
                    }
                });
            }); };
            this.removeFile = function (args) { return __awaiter(_this, void 0, void 0, function () {
                var key, group, fileName, removeFile, url;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            key = args.key, group = args.group, fileName = args.fileName;
                            removeFile = API.removeFile;
                            url = "" + this.functionUrl + removeFile + "?" + __classPrivateFieldGet(this, _directory).call(this, key, group) + "&name=" + fileName;
                            return [4 /*yield*/, this.apiService.post(url)];
                        case 1:
                            _g.sent();
                            return [2 /*return*/];
                    }
                });
            }); };
            this.filesInFolder = function (args) { return __awaiter(_this, void 0, void 0, function () {
                var _a, key, group, filesInFolder, url, res;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            key = args.key, group = args.group;
                            filesInFolder = API.filesInFolder;
                            url = "" + this.functionUrl + filesInFolder + "?" + __classPrivateFieldGet(this, _directory).call(this, key, group);
                            return [4 /*yield*/, this.apiService.get(url)];
                        case 1:
                            res = _g.sent();
                            return [2 /*return*/, (((_a = res.files) === null || _a === void 0 ? void 0 : _a.map(function (e) { return ({
                                    filePath: e.publicUrl,
                                    fileName: e.name,
                                }); })) || [])];
                    }
                });
            }); };
            this.download = function (filePath, fileName) {
                var link = document.createElement('a');
                link.download = (fileName || uuid.v4()) + ".xlsx";
                link.href = filePath;
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);
            };
            this.exportByTemplate = function (args) { return __awaiter(_this, void 0, void 0, function () {
                var filePath, columns, items, fileName, sdExportByTemplate, url, buffer, blob;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            filePath = args.filePath, columns = args.columns, items = args.items, fileName = args.fileName;
                            sdExportByTemplate = API.sdExportByTemplate;
                            url = "" + this.functionUrl + sdExportByTemplate;
                            return [4 /*yield*/, this.apiService.post(url, {
                                    filePath: filePath,
                                    columns: columns,
                                    items: items,
                                    fileName: fileName,
                                }, null, {
                                    responseType: 'arraybuffer',
                                })];
                        case 1:
                            buffer = _g.sent();
                            blob = new Blob([buffer], { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;base64,' });
                            SdUtility.downloadBlob(blob, fileName);
                            return [2 /*return*/];
                    }
                });
            }); };
            this.exportCSV = function (option) { return __awaiter(_this, void 0, void 0, function () {
                var columns, items, fileName, headerCSV, columns_1, columns_1_1, column, csvExporter;
                var e_3, _g;
                return __generator(this, function (_h) {
                    columns = option.columns, items = option.items, fileName = option.fileName;
                    headerCSV = {};
                    try {
                        for (columns_1 = __values(columns), columns_1_1 = columns_1.next(); !columns_1_1.done; columns_1_1 = columns_1.next()) {
                            column = columns_1_1.value;
                            headerCSV[column.field] = column.title;
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (columns_1_1 && !columns_1_1.done && (_g = columns_1.return)) _g.call(columns_1);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                    csvExporter = new exportToCsv.ExportToCsv({
                        filename: (fileName || 'CSV') + "_" + Date.toFormat(new Date(), 'yyyy-MM-dd-HH-mm-ss'),
                        fieldSeparator: ',',
                        quoteStrings: '"',
                        decimalSeparator: '.',
                        showLabels: true,
                        showTitle: false,
                        title: fileName || 'CSV',
                        useBom: true,
                    });
                    csvExporter.generateCsv(__spread([headerCSV], items));
                    return [2 /*return*/];
                });
            }); };
            this.export = function (option) { return __awaiter(_this, void 0, void 0, function () {
                var columns, items, fileName, sheets, hasDescription, _g, _h, _j, idx, column, workbook, firstSheet, _loop_2, sheets_2, sheets_2_1, sheet, fromRow, file;
                var e_4, _k, e_5, _l;
                var _this = this;
                return __generator(this, function (_m) {
                    switch (_m.label) {
                        case 0:
                            columns = option.columns, items = option.items, fileName = option.fileName, sheets = option.sheets;
                            hasDescription = false;
                            try {
                                for (_g = __values(columns.entries()), _h = _g.next(); !_h.done; _h = _g.next()) {
                                    _j = __read(_h.value, 2), idx = _j[0], column = _j[1];
                                    if (!column.field) {
                                        throw new Error("Column " + (idx + 1) + ": Field is required");
                                    }
                                    if (!column.title) {
                                        throw new Error("Column " + (idx + 1) + ": Title is required");
                                    }
                                    if (column.description) {
                                        hasDescription = true;
                                    }
                                }
                            }
                            catch (e_4_1) { e_4 = { error: e_4_1 }; }
                            finally {
                                try {
                                    if (_h && !_h.done && (_k = _g.return)) _k.call(_g);
                                }
                                finally { if (e_4) throw e_4.error; }
                            }
                            workbook = new exceljs.Workbook();
                            firstSheet = workbook.addWorksheet('data');
                            columns.forEach(function (column, index) {
                                var width = 120;
                                if (column.width && column.width.endsWith('px')) {
                                    width = +column.width.replace('px', '');
                                }
                                firstSheet.getColumn(index + 1).width = width / 7 || 20;
                                firstSheet.getCell(1, index + 1).style = __classPrivateFieldGet(_this, _fieldStyle);
                                if (column.required) {
                                    firstSheet.getCell(2, index + 1).style = __classPrivateFieldGet(_this, _requiredStyle);
                                }
                                else {
                                    firstSheet.getCell(2, index + 1).style = __classPrivateFieldGet(_this, _titleStyle);
                                }
                                firstSheet.getCell(1, index + 1).value = column.field;
                                firstSheet.getCell(2, index + 1).value = column.title;
                                if (hasDescription) {
                                    firstSheet.getCell(3, index + 1).style = __classPrivateFieldGet(_this, _descriptionStyle);
                                    firstSheet.getCell(3, index + 1).value = column.description || '';
                                }
                            });
                            if (sheets === null || sheets === void 0 ? void 0 : sheets.length) {
                                _loop_2 = function (sheet) {
                                    if (sheet.name && Array.isArray(sheet.items) && Array.isArray(sheet.fields)) {
                                        var newSheet_2 = workbook.addWorksheet(sheet.name);
                                        sheet.fields.forEach(function (field, index) {
                                            newSheet_2.getColumn(index + 1).width = 30;
                                            newSheet_2.getCell(1, index + 1).style = __classPrivateFieldGet(_this, _titleStyle);
                                            newSheet_2.getCell(1, index + 1).value = field;
                                        });
                                        sheet.items.forEach(function (item, idx1) {
                                            sheet.fields.forEach(function (field, idx2) {
                                                newSheet_2.getCell(2 + idx1, 1 + idx2).value = item[field];
                                                newSheet_2.getCell(2 + idx1, 1 + idx2).style = __classPrivateFieldGet(_this, _cellStyle);
                                            });
                                        });
                                    }
                                };
                                try {
                                    for (sheets_2 = __values(sheets), sheets_2_1 = sheets_2.next(); !sheets_2_1.done; sheets_2_1 = sheets_2.next()) {
                                        sheet = sheets_2_1.value;
                                        _loop_2(sheet);
                                    }
                                }
                                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                                finally {
                                    try {
                                        if (sheets_2_1 && !sheets_2_1.done && (_l = sheets_2.return)) _l.call(sheets_2);
                                    }
                                    finally { if (e_5) throw e_5.error; }
                                }
                            }
                            fromRow = hasDescription ? 4 : 3;
                            items.forEach(function (e, idx1) {
                                columns.forEach(function (column, idx2) {
                                    if (typeof e[column.field] === 'number') {
                                        // Format mặc định với kiểu số
                                        firstSheet.getCell(fromRow + idx1, 1 + idx2).value = +e[column.field];
                                        firstSheet.getCell(fromRow + idx1, 1 + idx2).numFmt = '#';
                                    }
                                    else {
                                        firstSheet.getCell(fromRow + idx1, 1 + idx2).value = e[column.field];
                                    }
                                    firstSheet.getCell(fromRow + idx1, 1 + idx2).style = Object.assign({}, __classPrivateFieldGet(_this, _cellStyle));
                                });
                            });
                            return [4 /*yield*/, workbook.xlsx.writeBuffer()];
                        case 1:
                            file = _m.sent();
                            SdUtility.downloadBlob(new Blob([file], { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' }), fileName);
                            return [2 /*return*/];
                    }
                });
            }); };
            this.exportCustom = function (option) { return __awaiter(_this, void 0, void 0, function () {
                var fileName, sheets, workbook, _g, _h, _j, idx, sheet, name, columns, cells, worksheet, _k, _l, column, cells_1, cells_1_1, cell, row, column, value, style, file;
                var e_6, _m, e_7, _o, e_8, _p;
                return __generator(this, function (_q) {
                    switch (_q.label) {
                        case 0:
                            fileName = option.fileName, sheets = option.sheets;
                            if (!(sheets === null || sheets === void 0 ? void 0 : sheets.length)) {
                                this.notifyService.notify.warning('Phải có ít nhất 1 sheet');
                                return [2 /*return*/];
                            }
                            workbook = new exceljs.Workbook();
                            try {
                                for (_g = __values(sheets.entries()), _h = _g.next(); !_h.done; _h = _g.next()) {
                                    _j = __read(_h.value, 2), idx = _j[0], sheet = _j[1];
                                    name = sheet.name, columns = sheet.columns, cells = sheet.cells;
                                    worksheet = workbook.addWorksheet(name || "Sheet " + (idx + 1));
                                    try {
                                        for (_k = (e_7 = void 0, __values(columns || [])), _l = _k.next(); !_l.done; _l = _k.next()) {
                                            column = _l.value;
                                            worksheet.getColumn(column.index).style = column.style;
                                            worksheet.getColumn(column.index).width = column.width;
                                        }
                                    }
                                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                                    finally {
                                        try {
                                            if (_l && !_l.done && (_o = _k.return)) _o.call(_k);
                                        }
                                        finally { if (e_7) throw e_7.error; }
                                    }
                                    try {
                                        for (cells_1 = (e_8 = void 0, __values(cells)), cells_1_1 = cells_1.next(); !cells_1_1.done; cells_1_1 = cells_1.next()) {
                                            cell = cells_1_1.value;
                                            row = cell.row, column = cell.column, value = cell.value, style = cell.style;
                                            worksheet.getCell(row, column).style = style || worksheet.getColumn(column).style;
                                            worksheet.getCell(row, column).value = value;
                                        }
                                    }
                                    catch (e_8_1) { e_8 = { error: e_8_1 }; }
                                    finally {
                                        try {
                                            if (cells_1_1 && !cells_1_1.done && (_p = cells_1.return)) _p.call(cells_1);
                                        }
                                        finally { if (e_8) throw e_8.error; }
                                    }
                                }
                            }
                            catch (e_6_1) { e_6 = { error: e_6_1 }; }
                            finally {
                                try {
                                    if (_h && !_h.done && (_m = _g.return)) _m.call(_g);
                                }
                                finally { if (e_6) throw e_6.error; }
                            }
                            return [4 /*yield*/, workbook.xlsx.writeBuffer()];
                        case 1:
                            file = _q.sent();
                            SdUtility.downloadBlob(new Blob([file], { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' }), fileName);
                            return [2 /*return*/];
                    }
                });
            }); };
            this.mergePDF = function (urls) { return __awaiter(_this, void 0, void 0, function () {
                var sdMergePDF, url, buffer;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            sdMergePDF = API.sdMergePDF;
                            url = "" + this.functionUrl + sdMergePDF;
                            return [4 /*yield*/, this.apiService.post(url, {
                                    urls: urls,
                                }, null, {
                                    responseType: 'arraybuffer',
                                })];
                        case 1:
                            buffer = _g.sent();
                            SdUtility.downloadBlob(new Blob([buffer], { type: 'application/pdf' }));
                            return [2 /*return*/];
                    }
                });
            }); };
            this.uploadXlsx = function () { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0: return [4 /*yield*/, SdUtility.upload({
                                extensions: ['xlsx'],
                                maxSizeInMb: 10,
                            }).then(function (file) {
                                return _this.parseXlsx(file);
                            })];
                        case 1: return [2 /*return*/, _g.sent()];
                    }
                });
            }); };
            this.parseXlsx = function (file) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_g) {
                    if (file) {
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                var wb = new exceljs.Workbook();
                                var reader = new FileReader();
                                reader.onload = function () {
                                    var buffer = reader.result;
                                    if (!buffer) {
                                        reject('Có lỗi xảy ra khi đọc file');
                                        return;
                                    }
                                    wb.xlsx.load(buffer).then(function (workbook) {
                                        var sheet = workbook.worksheets[0];
                                        if (!sheet) {
                                            reject('Không tìm thấy dữ liệu');
                                            return;
                                        }
                                        var items = [];
                                        var headers = sheet.getRow(1).values;
                                        if (Array.isArray(headers)) {
                                            sheet.eachRow(function (row, rowIndex) {
                                                var hasValues = row.hasValues, values = row.values;
                                                // console.log(row, hasValues, values)
                                                if (hasValues && rowIndex > 1) {
                                                    var item_1 = {};
                                                    headers.forEach(function (cellValue, index) {
                                                        if (cellValue) {
                                                            var field = cellValue.toString();
                                                            item_1[field] = values[index];
                                                            if (typeof item_1[field] === 'string') {
                                                                item_1[field] = item_1[field].trim();
                                                            }
                                                            if (item_1[field] === '' || item_1[field] === undefined) {
                                                                item_1[field] = null;
                                                            }
                                                        }
                                                    });
                                                    items.push(item_1);
                                                }
                                            });
                                            resolve({
                                                items: items,
                                                file: file,
                                            });
                                        }
                                    });
                                };
                                reader.readAsArrayBuffer(file);
                            })];
                    }
                    else {
                        return [2 /*return*/, {
                                items: [],
                                file: null,
                            }];
                    }
                    return [2 /*return*/];
                });
            }); };
        }
        Object.defineProperty(SdExportService.prototype, "functionUrl", {
            get: function () {
                var _a;
                return (_a = this.firebaseConfiguration) === null || _a === void 0 ? void 0 : _a.functionUrl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdExportService.prototype, "folder", {
            get: function () {
                var _g = this.firebaseConfiguration, project = _g.project, env = _g.env;
                return project + "-" + env;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdExportService.prototype, "userFolder", {
            get: function () {
                var folder = this.firebaseConfiguration.folder;
                if (!folder) {
                    return;
                }
                if (typeof folder === 'string') {
                    return folder;
                }
                return folder();
            },
            enumerable: false,
            configurable: true
        });
        return SdExportService;
    }());
    _fieldStyle = new WeakMap(), _titleColor = new WeakMap(), _titleFgColor = new WeakMap(), _titleStyle = new WeakMap(), _requiredStyle = new WeakMap(), _descriptionStyle = new WeakMap(), _cellStyle = new WeakMap(), _directory = new WeakMap();
    SdExportService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SdExportService_Factory() { return new SdExportService(i0.ɵɵinject(i1.SdApiService), i0.ɵɵinject(i2.SdNotifyService), i0.ɵɵinject(i3.FIREBASE_CONFIG, 8)); }, token: SdExportService, providedIn: "root" });
    SdExportService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    SdExportService.ctorParameters = function () { return [
        { type: i1.SdApiService },
        { type: i2.SdNotifyService },
        { type: undefined, decorators: [{ type: i0.Inject, args: [i3.FIREBASE_CONFIG,] }, { type: i0.Optional }] }
    ]; };

    /**
     * Generated bundle index. Do not edit.
     */

    exports.API = API;
    exports.SdExportService = SdExportService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-export.umd.js.map
