(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/icon'), require('@angular/material/tooltip'), require('@angular/forms'), require('uuid'), require('rxjs'), require('ngx-currency'), require('@sd-angular/core/common'), require('@angular/material/input'), require('@angular/material/form-field'), require('@sd-angular/core/translate')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/input-currency', ['exports', '@angular/core', '@angular/common', '@angular/material/icon', '@angular/material/tooltip', '@angular/forms', 'uuid', 'rxjs', 'ngx-currency', '@sd-angular/core/common', '@angular/material/input', '@angular/material/form-field', '@sd-angular/core/translate'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['input-currency'] = {}), global.ng.core, global.ng.common, global.ng.material.icon, global.ng.material.tooltip, global.ng.forms, global.uuid, global.rxjs, global['ngx-currency'], global['sd-angular'].core.common, global.ng.material.input, global.ng.material.formField, global['sd-angular'].core.translate));
}(this, (function (exports, core, common$1, icon, tooltip, forms, uuid, rxjs, ngxCurrency, common, input, formField, translate) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _name, _form, _model, _align, _allowNegative, _decimal, _precision, _prefix, _suffix, _thousands, _nullable, _min, _max, _pattern, _validator, _subscription, _generateOption, _updateValidator, _onChange, _customValidator;
    var SdInputCurrency = /** @class */ (function () {
        function SdInputCurrency(ref, formConfig) {
            var _this = this;
            this.ref = ref;
            this.formConfig = formConfig;
            _name.set(this, uuid.v4());
            this.disableErrorMessage = false;
            _form.set(this, void 0);
            _model.set(this, void 0);
            this.modelChange = new core.EventEmitter();
            _align.set(this, 'left');
            _allowNegative.set(this, true);
            _decimal.set(this, ',');
            _precision.set(this, 0);
            _prefix.set(this, void 0);
            _suffix.set(this, void 0);
            _thousands.set(this, '.');
            _nullable.set(this, void 0);
            _min.set(this, void 0);
            _max.set(this, void 0);
            // Validator
            this.isRequired = false;
            _pattern.set(this, void 0);
            _validator.set(this, void 0);
            this.sdChange = new core.EventEmitter();
            this.sdFocus = new core.EventEmitter();
            this.keyupEnter = new core.EventEmitter();
            this.formControl = new common.SdFormControl();
            _subscription.set(this, new rxjs.Subscription());
            this.options = {};
            _generateOption.set(this, function () {
                _this.options = {
                    align: __classPrivateFieldGet(_this, _align) || '',
                    allowNegative: __classPrivateFieldGet(_this, _allowNegative),
                    decimal: __classPrivateFieldGet(_this, _decimal),
                    precision: __classPrivateFieldGet(_this, _precision),
                    prefix: __classPrivateFieldGet(_this, _prefix) || '',
                    suffix: __classPrivateFieldGet(_this, _suffix) || '',
                    thousands: __classPrivateFieldGet(_this, _thousands),
                    nullable: __classPrivateFieldGet(_this, _nullable),
                    min: __classPrivateFieldGet(_this, _min),
                    max: __classPrivateFieldGet(_this, _max),
                    inputMode: ngxCurrency.CurrencyMaskInputMode.NATURAL
                };
                _this.ref.markForCheck();
            });
            this.reValidate = function () {
                _this.formControl.updateValueAndValidity();
            };
            _updateValidator.set(this, function () {
                _this.formControl.clearValidators();
                _this.formControl.clearAsyncValidators();
                var validators = [];
                var asyncValidators = [];
                if (_this.isRequired) {
                    validators.push(forms.Validators.required);
                }
                if (__classPrivateFieldGet(_this, _pattern)) {
                    validators.push(forms.Validators.pattern(__classPrivateFieldGet(_this, _pattern)));
                }
                if (__classPrivateFieldGet(_this, _validator)) {
                    asyncValidators.push(__classPrivateFieldGet(_this, _customValidator).call(_this, __classPrivateFieldGet(_this, _validator)));
                }
                if (_this.inlineError) {
                    validators.push(_this.customInlineErrorValidator());
                }
                _this.formControl.setValidators(validators);
                _this.formControl.setAsyncValidators(asyncValidators);
                _this.formControl.updateValueAndValidity();
            }
            // Hàm tạo Validators tùy chỉnh cho inlineError
            );
            _onChange.set(this, function (value) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_b) {
                    this.modelChange.emit(value);
                    this.sdChange.emit(value);
                    return [2 /*return*/];
                });
            }); });
            this.onKeyupEnter = function () {
                _this.keyupEnter.emit(_this.formControl.value);
            };
            this.onFocus = function () {
                _this.sdFocus.emit();
            };
            this.onBlur = function () {
                var _a;
                var val = ((_a = _this.formControl.value) !== null && _a !== void 0 ? _a : '').toString();
                if (val.length > val.trim().length) {
                    _this.formControl.setValue(val.trim());
                }
                _this.ref.markForCheck();
            };
            _customValidator.set(this, function (func) {
                return function (c) { return __awaiter(_this, void 0, void 0, function () {
                    var value, result, message;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                value = c.value || null;
                                if (!(func && typeof (func) === 'function')) return [3 /*break*/, 3];
                                result = func(value);
                                if (!(result instanceof Promise)) return [3 /*break*/, 2];
                                return [4 /*yield*/, result];
                            case 1:
                                message = _b.sent();
                                if (message) {
                                    return [2 /*return*/, {
                                            customValidator: message
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 2:
                                if (result) {
                                    return [2 /*return*/, {
                                            customValidator: result
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 3: return [2 /*return*/, null];
                        }
                    });
                }); };
            });
        }
        Object.defineProperty(SdInputCurrency.prototype, "name", {
            set: function (val) {
                if (val) {
                    __classPrivateFieldSet(this, _name, val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = (val === '') || val;
                val = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "form", {
            set: function (val) {
                if (val) {
                    if (val instanceof forms.NgForm) {
                        __classPrivateFieldSet(this, _form, val.form);
                    }
                    else {
                        __classPrivateFieldSet(this, _form, val);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "model", {
            set: function (value) {
                if (__classPrivateFieldGet(this, _model) !== value) {
                    __classPrivateFieldSet(this, _model, value);
                    this.formControl.setValue(value, {
                        emitEvent: false
                    });
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "align", {
            set: function (val) {
                __classPrivateFieldSet(this, _align, val || 'left');
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "allowNegative", {
            set: function (val) {
                __classPrivateFieldSet(this, _allowNegative, (val === '') || val);
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "decimal", {
            set: function (val) {
                __classPrivateFieldSet(this, _decimal, val || ',');
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "precision", {
            set: function (val) {
                __classPrivateFieldSet(this, _precision, val || 0);
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "prefix", {
            set: function (val) {
                __classPrivateFieldSet(this, _prefix, val);
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "suffix", {
            set: function (val) {
                __classPrivateFieldSet(this, _suffix, val);
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "thousands", {
            set: function (val) {
                __classPrivateFieldSet(this, _thousands, val || '.');
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "nullable", {
            set: function (val) {
                __classPrivateFieldSet(this, _nullable, val);
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "min", {
            set: function (val) {
                __classPrivateFieldSet(this, _min, val);
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "max", {
            set: function (val) {
                __classPrivateFieldSet(this, _max, val);
                __classPrivateFieldGet(this, _generateOption).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "required", {
            set: function (val) {
                this.isRequired = (val === '') || val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "pattern", {
            set: function (val) {
                __classPrivateFieldSet(this, _pattern, val);
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "validator", {
            set: function (validator) {
                __classPrivateFieldSet(this, _validator, validator);
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "_inlineError", {
            set: function (val) {
                this.inlineError = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputCurrency.prototype, "disabled", {
            // Optional
            set: function (val) {
                val = (val === '') || val;
                if (val) {
                    this.formControl.disable();
                }
                else {
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        SdInputCurrency.prototype.ngOnInit = function () {
            var _this = this;
            var _a;
            this.appearance = this.appearance || ((_a = this.formConfig) === null || _a === void 0 ? void 0 : _a.appearance);
            __classPrivateFieldGet(this, _subscription).add(this.formControl.sdChanges.subscribe(function () {
                _this.ref.markForCheck();
            }));
            __classPrivateFieldGet(this, _generateOption).call(this);
        };
        SdInputCurrency.prototype.ngAfterViewInit = function () {
            var _a;
            __classPrivateFieldGet(this, _subscription).add(this.formControl.valueChanges.subscribe(__classPrivateFieldGet(this, _onChange)));
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.addControl(__classPrivateFieldGet(this, _name), this.formControl);
            this.ref.detectChanges();
        };
        SdInputCurrency.prototype.ngOnDestroy = function () {
            var _a;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.removeControl(__classPrivateFieldGet(this, _name));
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        // Hàm tạo Validators tùy chỉnh cho inlineError
        SdInputCurrency.prototype.customInlineErrorValidator = function () {
            return function (control) {
                return { inlineError: true };
            };
        };
        return SdInputCurrency;
    }());
    _name = new WeakMap(), _form = new WeakMap(), _model = new WeakMap(), _align = new WeakMap(), _allowNegative = new WeakMap(), _decimal = new WeakMap(), _precision = new WeakMap(), _prefix = new WeakMap(), _suffix = new WeakMap(), _thousands = new WeakMap(), _nullable = new WeakMap(), _min = new WeakMap(), _max = new WeakMap(), _pattern = new WeakMap(), _validator = new WeakMap(), _subscription = new WeakMap(), _generateOption = new WeakMap(), _updateValidator = new WeakMap(), _onChange = new WeakMap(), _customValidator = new WeakMap();
    SdInputCurrency.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-input-currency',
                    template: "<ng-container *ngIf=\"!appearance && sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\">\r\n  </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"!appearance && label && !sdLabelDef?.templateRef\" class=\"d-block mb-0 T14M\">{{label}} <span class=\"text-danger mb-2\" *ngIf=\"isRequired\">*</span></label>\r\n<div class=\"d-flex align-items-center\">\r\n  <mat-form-field class=\"sd-md\"\r\n    [ngClass]=\"{'sd-form-tooltip':tooltip, 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage}\"\r\n    [appearance]=\"appearance || 'outline'\">\r\n    <mat-label *ngIf=\"appearance && label\">{{label}}</mat-label>\r\n    <input currencyMask [options]=\"options\" [formControl]=\"formControl\" #control matInput\r\n      [placeholder]=\"placeholder || (appearance ? label : '')\" (keyup.enter)=\"onKeyupEnter()\" (focus)=\"onFocus()\" [required]=\"isRequired\"\r\n      autocomplete=\"off\">\r\n    <ng-container *ngIf=\"sdSuffix?.templateRef\" matSuffix>\r\n      <ng-container *ngTemplateOutlet=\"sdSuffix.templateRef\">\r\n      </ng-container>\r\n    </ng-container>\r\n    <mat-error *ngIf=\"formControl.errors?.required && !disableErrorMessage\">\r\n      {{'This field is required' | sdTranslate}}\r\n    </mat-error>\r\n    <mat-error *ngIf=\"formControl.errors?.pattern && !disableErrorMessage\">\r\n      {{'Pattern error' | sdTranslate}}\r\n    </mat-error>\r\n    <mat-error *ngIf=\"formControl.errors?.customValidator && !disableErrorMessage\">\r\n      <strong>{{formControl.errors?.customValidator}}</strong>\r\n    </mat-error>\r\n    <mat-error *ngIf=\"formControl.errors?.inlineError\">\r\n      <ng-container *ngIf=\"!disableErrorMessage\">{{inlineError}}</ng-container>\r\n    </mat-error>\r\n  </mat-form-field>\r\n  <div *ngIf=\"tooltip\" class=\"sd-tooltip\">\r\n    <mat-icon (click)=\"sdTooltip.toggle()\" [matTooltip]=\"formControl.value | sdInputCurrencyTooltipPipe:tooltip\"\r\n      matSuffix #sdTooltip=\"matTooltip\">info</mat-icon>\r\n  </div>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host ::ng-deep .mat-form-field.sd-form-tooltip{width:calc(100% - 30px)}.sd-tooltip{display:inline-block;margin:auto;text-align:center;width:30px}:host{display:block;padding-top:5px}:host ::ng-deep .mat-form-field.no-padding-wrapper .mat-form-field-wrapper{padding-bottom:0}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{background:#f6f6f6;color:#e9e9e9}:host ::ng-deep .mat-form-field input.mat-input-element:disabled{color:#4d4d4d!important}:host ::ng-deep .mat-form-field .mat-placeholder-required{color:#f82c13}"]
                },] }
    ];
    SdInputCurrency.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.FORM_CONFIG,] }, { type: core.Optional }] }
    ]; };
    SdInputCurrency.propDecorators = {
        name: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        size: [{ type: core.Input }],
        form: [{ type: core.Input }],
        label: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        model: [{ type: core.Input }],
        modelChange: [{ type: core.Output }],
        align: [{ type: core.Input }],
        allowNegative: [{ type: core.Input }],
        decimal: [{ type: core.Input }],
        precision: [{ type: core.Input }],
        prefix: [{ type: core.Input }],
        suffix: [{ type: core.Input }],
        thousands: [{ type: core.Input }],
        nullable: [{ type: core.Input }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        required: [{ type: core.Input }],
        pattern: [{ type: core.Input }],
        validator: [{ type: core.Input }],
        _inlineError: [{ type: core.Input, args: ['inlineError',] }],
        disabled: [{ type: core.Input }],
        sdSuffix: [{ type: core.ContentChild, args: [common.SdSuffixDirective,] }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }],
        tooltip: [{ type: core.Input }],
        sdChange: [{ type: core.Output }],
        sdFocus: [{ type: core.Output }],
        keyupEnter: [{ type: core.Output }],
        control: [{ type: core.ViewChild, args: ['control',] }]
    };

    var SdInputCurrencyTooltipPipe = /** @class */ (function () {
        function SdInputCurrencyTooltipPipe() {
        }
        SdInputCurrencyTooltipPipe.prototype.transform = function (value, tooltip) {
            if (typeof (tooltip) === 'string') {
                return tooltip;
            }
            return tooltip(value);
        };
        return SdInputCurrencyTooltipPipe;
    }());
    SdInputCurrencyTooltipPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'sdInputCurrencyTooltipPipe'
                },] }
    ];

    var SdInputCurrencyModule = /** @class */ (function () {
        function SdInputCurrencyModule() {
        }
        return SdInputCurrencyModule;
    }());
    SdInputCurrencyModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        icon.MatIconModule,
                        tooltip.MatTooltipModule,
                        common.SdCommonModule,
                        translate.SdTranslateModule,
                        ngxCurrency.NgxCurrencyModule
                    ],
                    declarations: [
                        SdInputCurrency,
                        SdInputCurrencyTooltipPipe
                    ],
                    exports: [
                        SdInputCurrency,
                        SdInputCurrencyTooltipPipe
                    ]
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdInputCurrency = SdInputCurrency;
    exports.SdInputCurrencyModule = SdInputCurrencyModule;
    exports.SdInputCurrencyTooltipPipe = SdInputCurrencyTooltipPipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-input-currency.umd.js.map
