(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('uuid'), require('object-hash'), require('rxjs'), require('@sd-angular/core/common'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/tooltip'), require('@sd-angular/core/translate')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/input-number', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'uuid', 'object-hash', 'rxjs', '@sd-angular/core/common', '@angular/material/form-field', '@angular/material/input', '@angular/material/button', '@angular/material/icon', '@angular/material/tooltip', '@sd-angular/core/translate'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['input-number'] = {}), global.ng.core, global.ng.common, global.ng.forms, global.uuid, global.hash, global.rxjs, global['sd-angular'].core.common, global.ng.material.formField, global.ng.material.input, global.ng.material.button, global.ng.material.icon, global.ng.material.tooltip, global['sd-angular'].core.translate));
}(this, (function (exports, core, common$1, forms, uuid, hash, rxjs, common, formField, input, button, icon, tooltip, translate) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _name, _form, _blurOnEnter_1, _model, _validator, _subscription, _getValueWithFormat, _formatNumber, _toNumber, _updateValidator, _onChange, _checkValue, _customValidator;
    var SdInputNumberErrotStateMatcher = /** @class */ (function () {
        function SdInputNumberErrotStateMatcher(formControl) {
            this.formControl = formControl;
        }
        SdInputNumberErrotStateMatcher.prototype.isErrorState = function (control, form) {
            var _a, _b, _c;
            var isSubmitted = form && form.submitted;
            return !!(((_a = this.formControl) === null || _a === void 0 ? void 0 : _a.invalid) && (((_b = this.formControl) === null || _b === void 0 ? void 0 : _b.dirty) || ((_c = this.formControl) === null || _c === void 0 ? void 0 : _c.touched) || isSubmitted));
        };
        return SdInputNumberErrotStateMatcher;
    }());
    var SdInputNumber = /** @class */ (function () {
        function SdInputNumber(ref, formConfig) {
            var _this = this;
            this.ref = ref;
            this.formConfig = formConfig;
            this.id = "I" + uuid.v4();
            _name.set(this, uuid.v4());
            _form.set(this, void 0);
            this.disableErrorMessage = false;
            _blurOnEnter_1.set(this, false);
            _model.set(this, void 0);
            this.modelChange = new core.EventEmitter();
            // Validator
            this.isRequired = false;
            this.precision = 3; //số chữ số thập phân 
            this.isReadonly = false;
            _validator.set(this, void 0);
            this.copyable = false;
            this.copied = false;
            this.sdChange = new core.EventEmitter();
            this.sdFocus = new core.EventEmitter();
            this.sdBlur = new core.EventEmitter();
            this.sdFocusForceBlur = new core.EventEmitter();
            this.keyupEnter = new core.EventEmitter();
            this.formControl = new common.SdFormControl();
            this.inputControl = new common.SdFormControl();
            _subscription.set(this, new rxjs.Subscription());
            this.matcher = new SdInputNumberErrotStateMatcher(this.formControl);
            this.isFocused = false;
            _getValueWithFormat.set(this, function (value) {
                var arrayNext = value.split(',');
                if (arrayNext.length >= 2) {
                    return __classPrivateFieldGet(_this, _formatNumber).call(_this, arrayNext[0]) + "," + arrayNext[1];
                }
                return __classPrivateFieldGet(_this, _formatNumber).call(_this, value);
            });
            _formatNumber.set(this, function (text) {
                return Number.toVNCurrency(((text === null || text === void 0 ? void 0 : text.toString()) || '').replace(/\./g, ''));
                // const arrs: string[] = (text?.toString() || '').replace(/\./g, '').split('');
                // return arrs.reverse().reduce((acc, num, index) => {
                //   return num + (num !== '-' && index && !(index % 3) ? '.' : '') + acc;
                // }, '');
            });
            _toNumber.set(this, function (text) { return +(((text === null || text === void 0 ? void 0 : text.toString()) || '').replace(/\./g, '').replace(/,/g, '.')); });
            this.reValidate = function () {
                _this.formControl.updateValueAndValidity();
            };
            _updateValidator.set(this, function () {
                _this.formControl.clearValidators();
                _this.formControl.clearAsyncValidators();
                var validators = [];
                var asyncValidators = [];
                if (_this.isRequired) {
                    validators.push(forms.Validators.required);
                }
                if (_this.minNumber || _this.minNumber === 0) {
                    validators.push(forms.Validators.min(_this.minNumber));
                }
                if (_this.maxNumber || _this.maxNumber === 0) {
                    validators.push(forms.Validators.max(_this.maxNumber));
                }
                if (__classPrivateFieldGet(_this, _validator)) {
                    asyncValidators.push(__classPrivateFieldGet(_this, _customValidator).call(_this, __classPrivateFieldGet(_this, _validator)));
                }
                if (_this.inlineError) {
                    validators.push(_this.customInlineErrorValidator());
                }
                _this.formControl.setValidators(validators);
                _this.formControl.setAsyncValidators(asyncValidators);
                _this.formControl.updateValueAndValidity();
            }
            // Hàm tạo Validators tùy chỉnh cho inlineError
            );
            _onChange.set(this, function (value) {
                __classPrivateFieldSet(_this, _model, value !== null && value !== void 0 ? value : null);
                _this.modelChange.emit(__classPrivateFieldGet(_this, _model));
                _this.sdChange.emit(__classPrivateFieldGet(_this, _model));
                _this.formControl.setValue(__classPrivateFieldGet(_this, _model));
            });
            this.onKeyupEnter = function () {
                var _a;
                var val = ((_a = _this.inputControl.value) !== null && _a !== void 0 ? _a : '').toString();
                if (val.length > val.trim().length) {
                    _this.inputControl.setValue(val.trim());
                }
                _this.keyupEnter.emit(_this.inputControl.value);
                if (__classPrivateFieldGet(_this, _blurOnEnter_1)) {
                    _this.blur();
                }
            };
            this.onKeydown = function (event) {
                if (event.ctrlKey && event.key == 'v') {
                    __classPrivateFieldGet(_this, _checkValue).call(_this, event, '');
                    return;
                }
                var key = event.keyCode || event.charCode;
                if (key == 8 || key == 46 || key == 37 || key == 39 || key == 35 || key == 36 || key == 9) {
                    return;
                }
                if (event.ctrlKey && (event.key == 'c' || event.key == 'x' || event.key == 'a')) {
                    return;
                }
                if (event.shiftKey && key == 9) {
                    return;
                }
                __classPrivateFieldGet(_this, _checkValue).call(_this, event, event.key);
            };
            _checkValue.set(this, function (event, nextKey) {
                var current = event.target.value;
                // if(this.maxNumber === +current.toString().replace(/\./g, '').replace(/,/g, '.')){
                //   event.preventDefault();
                //   return;
                // }
                var curval_arr = current.split("");
                curval_arr.splice(event.target.selectionStart, (event.target.selectionEnd - event.target.selectionStart), nextKey);
                var newval = curval_arr.join("");
                if (_this.type !== 'positive' && newval === '-') {
                    return;
                }
                var regExp = new RegExp("^" + _this.regex, 'g');
                if (newval && !String(newval).match(regExp)) {
                    event.preventDefault();
                    return;
                }
                // const value = (newval.toString().replace(/\./g, '').replace(/,/g, '.'));
                // if ((this.maxNumber || this.maxNumber === 0) && +value > this.maxNumber) {
                //   setTimeout(() => {
                //     this.inputControl.setValue(this.#getValueWithFormat(this.maxNumber.toString().replace(/\./g, ',')));
                //   }, 10);
                //   event.preventDefault();
                // }
            });
            this.onFocus = function () {
                var _a;
                _this.isFocused = true;
                _this.sdFocus.emit();
                if (((_a = _this.sdFocusForceBlur.observers) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                    _this.blur();
                    _this.sdFocusForceBlur.emit();
                }
            };
            this.onBlur = function () {
                var _a;
                _this.isFocused = false;
                var val = ((_a = _this.inputControl.value) !== null && _a !== void 0 ? _a : '').toString();
                var arrayValue = val.split(',');
                if (arrayValue.length >= 2 && arrayValue[1] == '') {
                    _this.inputControl.setValue(__classPrivateFieldGet(_this, _formatNumber).call(_this, arrayValue[0]));
                    return;
                }
                if (val.length > val.trim().length) {
                    _this.inputControl.setValue(val.trim());
                }
                _this.sdBlur.emit(_this.formControl.value);
            };
            this.onClick = function () {
                var _a;
                if ((_a = _this.sdView) === null || _a === void 0 ? void 0 : _a.templateRef) {
                    if (!_this.formControl.disabled && !_this.isFocused) {
                        _this.focus();
                    }
                }
            };
            this.blur = function () {
                var _a, _b;
                _this.isFocused = false;
                (_b = (_a = _this.control) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.blur();
            };
            this.focus = function () {
                _this.isFocused = true;
                setTimeout(function () {
                    var _a, _b;
                    (_b = (_a = _this.control) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.focus();
                }, 100);
            };
            _customValidator.set(this, function (func) {
                return function (c) { return __awaiter(_this, void 0, void 0, function () {
                    var _a, value, result, message;
                    return __generator(this, function (_d) {
                        switch (_d.label) {
                            case 0:
                                value = (_a = c.value) !== null && _a !== void 0 ? _a : null;
                                if (!(func && typeof (func) === 'function')) return [3 /*break*/, 3];
                                result = func(value);
                                if (!(result instanceof Promise)) return [3 /*break*/, 2];
                                return [4 /*yield*/, result];
                            case 1:
                                message = _d.sent();
                                if (message) {
                                    return [2 /*return*/, {
                                            customValidator: message
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 2:
                                if (result) {
                                    return [2 /*return*/, {
                                            customValidator: result
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 3: return [2 /*return*/, null];
                        }
                    });
                }); };
            });
        }
        Object.defineProperty(SdInputNumber.prototype, "name", {
            set: function (val) {
                if (val) {
                    __classPrivateFieldSet(this, _name, val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "form", {
            set: function (val) {
                if (val) {
                    if (val instanceof forms.NgForm) {
                        __classPrivateFieldSet(this, _form, val.form);
                    }
                    else {
                        __classPrivateFieldSet(this, _form, val);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "_label", {
            set: function (val) {
                this.label = val;
                this.qcId = hash__default['default']({
                    selector: 'sd-input-number',
                    label: val
                });
            },
            enumerable: false,
            configurable: true
        });
        ;
        Object.defineProperty(SdInputNumber.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "_blurOnEnter", {
            set: function (val) {
                __classPrivateFieldSet(this, _blurOnEnter_1, (val === '') || val);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "model", {
            set: function (value) {
                if (__classPrivateFieldGet(this, _model) !== value) {
                    __classPrivateFieldSet(this, _model, value);
                    this.formControl.setValue(__classPrivateFieldGet(this, _model), {
                        emitEvent: false
                    });
                    if (value || value === 0) {
                        var val = value.toString().replace(/\./g, ',');
                        this.inputControl.setValue(__classPrivateFieldGet(this, _getValueWithFormat).call(this, val), {
                            emitEvent: false
                        });
                    }
                    else {
                        this.inputControl.setValue('', {
                            emitEvent: false
                        });
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "required", {
            set: function (val) {
                this.isRequired = (val === '') || val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "readonly", {
            set: function (val) {
                this.isReadonly = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "min", {
            set: function (val) {
                this.minNumber = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "max", {
            set: function (val) {
                this.maxNumber = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "validator", {
            set: function (validator) {
                __classPrivateFieldSet(this, _validator, validator);
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "_inlineError", {
            set: function (val) {
                this.inlineError = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "disabled", {
            set: function (val) {
                val = (val === '') || val;
                if (val) {
                    this.inputControl.disable();
                    this.formControl.disable();
                }
                else {
                    this.inputControl.enable();
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputNumber.prototype, "_copyable", {
            set: function (val) {
                this.copyable = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        SdInputNumber.prototype.ngOnInit = function () {
            var _this = this;
            var _a;
            this.appearance = this.appearance || ((_a = this.formConfig) === null || _a === void 0 ? void 0 : _a.appearance);
            __classPrivateFieldGet(this, _subscription).add(this.inputControl.touchChanges.subscribe(function () {
                _this.formControl.markAsTouched();
                _this.ref.markForCheck();
            }));
            __classPrivateFieldGet(this, _subscription).add(this.formControl.sdChanges.subscribe(function () {
                _this.ref.markForCheck();
            }));
            __classPrivateFieldGet(this, _subscription).add(this.inputControl.sdChanges.subscribe(function () {
                _this.ref.markForCheck();
            }));
        };
        Object.defineProperty(SdInputNumber.prototype, "regex", {
            get: function () {
                var result = "(([0-9]+(\\.[0-9])?)+(\\,[0-9]{0," + this.precision + "}){0,1})$";
                if (this.precision === 0) {
                    result = "(([0-9]+(\\.[0-9])?)+)$";
                }
                if (this.type === 'negative') {
                    result = "[-]" + result;
                }
                if (!this.type) {
                    result = "[-]?" + result;
                }
                return result;
            },
            enumerable: false,
            configurable: true
        });
        SdInputNumber.prototype.ngAfterViewInit = function () {
            var _this = this;
            var _a;
            __classPrivateFieldGet(this, _subscription).add(this.inputControl.valueChanges.subscribe(function () {
                var val = _this.inputControl.value;
                if (!val) {
                    __classPrivateFieldGet(_this, _onChange).call(_this, undefined);
                    return;
                }
                var value = __classPrivateFieldGet(_this, _toNumber).call(_this, val);
                if (!isNaN(value)) {
                    _this.inputControl.setValue(__classPrivateFieldGet(_this, _getValueWithFormat).call(_this, val), {
                        emitEvent: false
                    });
                    __classPrivateFieldGet(_this, _onChange).call(_this, value);
                }
            }));
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.addControl(__classPrivateFieldGet(this, _name), this.formControl);
            this.ref.detectChanges();
        };
        SdInputNumber.prototype.ngOnDestroy = function () {
            var _a;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.removeControl(__classPrivateFieldGet(this, _name));
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        // Hàm tạo Validators tùy chỉnh cho inlineError
        SdInputNumber.prototype.customInlineErrorValidator = function () {
            return function (control) {
                return { inlineError: true };
            };
        };
        SdInputNumber.prototype.onPaste = function (event) {
            var nextKey = event.clipboardData.getData('text');
            __classPrivateFieldGet(this, _checkValue).call(this, event, nextKey);
        };
        SdInputNumber.prototype.onCopyText = function () {
            var _this = this;
            SdUtility.copyToClipboard(this.inputControl.value);
            this.copied = true;
            setTimeout(function () {
                _this.copied = false;
            }, 2000);
        };
        return SdInputNumber;
    }());
    _name = new WeakMap(), _form = new WeakMap(), _blurOnEnter_1 = new WeakMap(), _model = new WeakMap(), _validator = new WeakMap(), _subscription = new WeakMap(), _getValueWithFormat = new WeakMap(), _formatNumber = new WeakMap(), _toNumber = new WeakMap(), _updateValidator = new WeakMap(), _onChange = new WeakMap(), _checkValue = new WeakMap(), _customValidator = new WeakMap();
    SdInputNumber.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-input-number',
                    template: "<ng-container *ngIf=\"!appearance && sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\">\r\n  </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"!appearance && label && !sdLabelDef?.templateRef\" class=\"d-block mb-0 T14M\">{{label}} <span class=\"text-danger mb-2\"\r\n    *ngIf=\"isRequired\">*</span></label>\r\n<div class=\"d-flex align-items-center\" [class.sd-view]=\"sdView?.templateRef\" [class.c-focused]=\"isFocused\"\r\n  [class.c-disabled]=\"formControl.disabled\" (click)=\"onClick()\">\r\n  <ng-container *ngIf=\"sdView?.templateRef && !isFocused; else default\">\r\n    <ng-container *ngTemplateOutlet=\"sdView.templateRef;context: { value: formControl.value }\">\r\n    </ng-container>\r\n  </ng-container>\r\n  <ng-template #default>\r\n    <mat-form-field class=\"sd-md\" [ngClass]=\"{ 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage}\"\r\n      [appearance]=\"appearance || 'outline'\">\r\n      <mat-label *ngIf=\"appearance && label\">{{label}}</mat-label>\r\n      <input aria-hidden=\"true\" [id]=\"id\" [formControl]=\"inputControl\" #control matInput\r\n        [placeholder]=\"placeholder || (appearance ? label : '')\" [errorStateMatcher]=\"matcher\"\r\n        (keyup.enter)=\"onKeyupEnter()\" (focus)=\"onFocus()\" (blur)=\"onBlur()\" (keydown)=\"onKeydown($event)\"\r\n        [required]=\"isRequired\" [readonly]=\"isReadonly\" [autocomplete]=\"id\" (paste)=\"onPaste($event)\" autocorrect=\"off\"\r\n        [attr.data-qclabel]=\"label\" [attr.data-qcid]=\"qcId\">\r\n      <ng-container *ngIf=\"sdSuffix?.templateRef\" matSuffix>\r\n        <ng-container *ngTemplateOutlet=\"sdSuffix.templateRef\">\r\n        </ng-container>\r\n      </ng-container>\r\n      <ng-content select=\"[sdSuffixIcon]\" matSuffix></ng-content>\r\n      <svg \r\n        #copyTooltip=\"matTooltip\" \r\n        *ngIf=\"copyable\" \r\n        matSuffix \r\n        [matTooltip]=\"copied ? 'Copied' : 'Copy'\" \r\n        class=\"icon-copy\" \r\n        focusable=\"false\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 448 512\" \r\n        (click)=\"onCopyText()\">\r\n        <path d=\"M433.941 65.941l-51.882-51.882A48 48 0 0 0 348.118 0H176c-26.51 0-48 21.49-48 48v48H48c-26.51 0-48 21.49-48 48v320c0 26.51 21.49 48 48 48h224c26.51 0 48-21.49 48-48v-48h80c26.51 0 48-21.49 48-48V99.882a48 48 0 0 0-14.059-33.941zM266 464H54a6 6 0 0 1-6-6V150a6 6 0 0 1 6-6h74v224c0 26.51 21.49 48 48 48h96v42a6 6 0 0 1-6 6zm128-96H182a6 6 0 0 1-6-6V54a6 6 0 0 1 6-6h106v88c0 13.255 10.745 24 24 24h88v202a6 6 0 0 1-6 6zm6-256h-64V48h9.632c1.591 0 3.117.632 4.243 1.757l48.368 48.368a6 6 0 0 1 1.757 4.243V112z\"></path>\r\n      </svg>\r\n      <mat-error *ngIf=\"formControl?.errors?.required\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ \"This field is required\" | sdTranslate }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.min\">        \r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{'Kh\u00F4ng nh\u1EADp b\u00E9 h\u01A1n '}} <strong>{{minNumber}}</strong></ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.max\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{'Kh\u00F4ng nh\u1EADp l\u1EDBn h\u01A1n '}} <strong>{{maxNumber}}</strong></ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.customValidator\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{formControl.errors?.customValidator}}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.inlineError\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{inlineError}}</ng-container>\r\n      </mat-error>\r\n    </mat-form-field>\r\n  </ng-template>\r\n</div>\r\n<!-- <sd-popover #error=\"sdPopover\" type=\"danger\" width=\"300px\">\r\n  <span *ngIf=\"formControl.errors?.required\">\r\n    {{ \"This field is required\" | sdTranslate }}\r\n  </span>\r\n  <span *ngIf=\"formControl.errors?.customValidator\">\r\n    {{formControl.errors?.customValidator}}\r\n  </span>\r\n</sd-popover> -->",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host ::ng-deep .mat-form-field.sd-form-tooltip{width:calc(100% - 30px)}:host ::ng-deep .mat-form-field.no-padding-wrapper .mat-form-field-wrapper{padding-bottom:0}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{background:#f6f6f6;color:#e9e9e9}:host ::ng-deep .mat-form-field input.mat-input-element:disabled{color:#4d4d4d!important}:host ::ng-deep .mat-form-field .mat-placeholder-required{color:#f82c13}:host ::ng-deep .mat-form-field:hover .icon-copy{opacity:1}:host ::ng-deep .mat-form-field .icon-copy{cursor:pointer;fill:rgba(0,0,0,.5);height:.9em;opacity:0;transition:opacity .2s linear;width:.9em}.sd-view:not(.c-focused):not(.c-disabled):hover{background-color:#ebecf0}.sd-tooltip{display:inline-block;margin:auto;text-align:center;width:30px}:host{display:block;padding-top:5px}.sd-md:hover .btn-copy{visibility:visible}.btn-copy{background:#e9e9e9!important;font-size:12px;line-height:26px!important;margin-bottom:3px;visibility:hidden}"]
                },] }
    ];
    SdInputNumber.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.FORM_CONFIG,] }, { type: core.Optional }] }
    ]; };
    SdInputNumber.propDecorators = {
        name: [{ type: core.Input }],
        size: [{ type: core.Input }],
        form: [{ type: core.Input }],
        _label: [{ type: core.Input, args: ['label',] }],
        placeholder: [{ type: core.Input }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        _blurOnEnter: [{ type: core.Input, args: ['blurOnEnter',] }],
        model: [{ type: core.Input }],
        modelChange: [{ type: core.Output }],
        required: [{ type: core.Input }],
        type: [{ type: core.Input }],
        precision: [{ type: core.Input }],
        readonly: [{ type: core.Input }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        validator: [{ type: core.Input }],
        _inlineError: [{ type: core.Input, args: ['inlineError',] }],
        disabled: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        copyTooltip: [{ type: core.ViewChild, args: ['copyTooltip',] }],
        _copyable: [{ type: core.Input, args: ['copyable',] }],
        sdChange: [{ type: core.Output }],
        sdFocus: [{ type: core.Output }],
        sdBlur: [{ type: core.Output }],
        sdFocusForceBlur: [{ type: core.Output }],
        keyupEnter: [{ type: core.Output }],
        control: [{ type: core.ViewChild, args: ['control',] }],
        sdView: [{ type: core.ContentChild, args: [common.SdViewDefDirective,] }],
        sdSuffix: [{ type: core.ContentChild, args: [common.SdSuffixDirective,] }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }]
    };

    var SdInputNumberModule = /** @class */ (function () {
        function SdInputNumberModule() {
        }
        return SdInputNumberModule;
    }());
    SdInputNumberModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [SdInputNumber],
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        icon.MatIconModule,
                        tooltip.MatTooltipModule,
                        translate.SdTranslateModule,
                        common.SdCommonModule,
                        button.MatButtonModule,
                    ],
                    exports: [SdInputNumber],
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdInputNumber = SdInputNumber;
    exports.SdInputNumberModule = SdInputNumberModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-input-number.umd.js.map
