(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-device-detector'), require('@sd-angular/core/notify'), require('@sd-angular/core/translate'), require('@angular/material/icon'), require('uuid'), require('jquery'), require('rxjs'), require('rxjs/operators'), require('@angular/forms'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/material/chips')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/input-upload-file', ['exports', '@angular/core', '@angular/common', 'ngx-device-detector', '@sd-angular/core/notify', '@sd-angular/core/translate', '@angular/material/icon', 'uuid', 'jquery', 'rxjs', 'rxjs/operators', '@angular/forms', '@angular/material/form-field', '@angular/material/input', '@angular/material/chips'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['input-upload-file'] = {}), global.ng.core, global.ng.common, global.ngxDeviceDetector, global['sd-angular'].core.notify, global['sd-angular'].core.translate, global.ng.material.icon, global.uuid, global.$, global.rxjs, global.rxjs.operators, global.ng.forms, global.ng.material.formField, global.ng.material.input, global.ng.material.chips));
}(this, (function (exports, core, common, ngxDeviceDetector, notify, translate, icon, uuid, $, rxjs, operators, forms, formField, input, chips) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var $__default = /*#__PURE__*/_interopDefaultLegacy($);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _model, _subscription, _modelChanges, _updateValidator, _validate, _uploadFile, _validator;
    var SdInputUploadFiletStateMatcher = /** @class */ (function () {
        function SdInputUploadFiletStateMatcher(formControl) {
            this.formControl = formControl;
        }
        SdInputUploadFiletStateMatcher.prototype.isErrorState = function (control, form) {
            var _a, _b, _c;
            var isSubmitted = form && form.submitted;
            return !!(((_a = this.formControl) === null || _a === void 0 ? void 0 : _a.invalid) && (((_b = this.formControl) === null || _b === void 0 ? void 0 : _b.dirty) || ((_c = this.formControl) === null || _c === void 0 ? void 0 : _c.touched) || isSubmitted));
        };
        return SdInputUploadFiletStateMatcher;
    }());
    var SdInputUploadFile = /** @class */ (function () {
        function SdInputUploadFile(ref, notifyService, translateService) {
            var _this = this;
            this.ref = ref;
            this.notifyService = notifyService;
            this.translateService = translateService;
            this.id = "I" + uuid.v4();
            this.previewFiles = [];
            this.type = 'file';
            this.extensions = [];
            this.min = 0;
            this.max = 1;
            _model.set(this, void 0);
            this.disableErrorMessage = false;
            this.isRequired = false;
            this.modelChange = new core.EventEmitter();
            this.sdChange = new core.EventEmitter();
            this.inputControl = new forms.FormControl();
            this.formControl = new forms.FormControl();
            this.matcher = new SdInputUploadFiletStateMatcher(this.formControl);
            _subscription.set(this, new rxjs.Subscription());
            _modelChanges.set(this, new rxjs.Subject());
            _updateValidator.set(this, function () {
                _this.formControl.clearValidators();
                _this.formControl.clearAsyncValidators();
                var validators = [];
                var asyncValidators = [];
                if (_this.isRequired) {
                    validators.push(forms.Validators.required);
                }
                if (_this.inlineError) {
                    validators.push(_this.customInlineErrorValidator());
                }
                _this.formControl.setValidators(validators);
                _this.formControl.setAsyncValidators(asyncValidators);
                _this.formControl.updateValueAndValidity();
            }
            // Hàm tạo Validators tùy chỉnh cho inlineError
            );
            _validate.set(this, function (file) { return __awaiter(_this, void 0, void 0, function () {
                var _a, lastDot, extension_1, message;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (this.type === 'image') {
                                if (file.type.split('/')[0] !== 'image') {
                                    return [2 /*return*/, "[" + file.name + "] " + this.translateService.translate('Uploaded file is not an image')];
                                }
                            }
                            if ((_a = this.extensions) === null || _a === void 0 ? void 0 : _a.length) {
                                lastDot = file.name.lastIndexOf('.');
                                extension_1 = file.name.substring(lastDot + 1);
                                if (!this.extensions.some(function (e) { return e.toUpperCase() === extension_1.toUpperCase(); })) {
                                    return [2 /*return*/, "[" + file.name + "] " + this.translateService.translate('Uploaded file is not match extension') + " " + this.extensions.join(', ')];
                                }
                            }
                            if (this.maxSize) {
                                if (this.maxSize * 1024 * 1024 < file.size) {
                                    return [2 /*return*/, "[" + file.name + "] " + this.translateService.translate('Max file size') + " " + this.maxSize + " Mbs"];
                                }
                            }
                            if (!(this.type === 'image' && (this.maxWidth || this.maxHeight))) return [3 /*break*/, 2];
                            return [4 /*yield*/, new Promise(function (resolve) {
                                    var URL = window.URL || window.webkitURL;
                                    var img = new Image();
                                    img.onload = function () {
                                        if (_this.maxWidth && img.width > _this.maxWidth) {
                                            resolve("[" + file.name + "] " + _this.translateService.translate('Max image width') + " " + _this.maxWidth + "px");
                                        }
                                        if (_this.maxHeight && img.height > _this.maxHeight) {
                                            resolve("[" + file.name + "] " + _this.translateService.translate('Max image height') + " " + _this.maxHeight + "px");
                                        }
                                        resolve(null);
                                    };
                                    img.src = URL.createObjectURL(file);
                                })];
                        case 1:
                            message = _d.sent();
                            if (message) {
                                return [2 /*return*/, message];
                            }
                            _d.label = 2;
                        case 2: return [2 /*return*/, null];
                    }
                });
            }); });
            this.onUpload = function () {
                if ($__default['default']("#" + _this.id).length) {
                    $__default['default']('body').children("#" + _this.id).remove();
                }
                if (_this.max === 1) {
                    $__default['default']('body').append("<input id=\"" + _this.id + "\" style=\"display: none\" type=\"file\" />");
                }
                else {
                    $__default['default']('body').append("<input id=\"" + _this.id + "\" style=\"display: none\" type=\"file\" multiple />");
                }
                $__default['default']("#" + _this.id).on('change', function (evt) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_d) {
                        switch (_d.label) {
                            case 0: return [4 /*yield*/, __classPrivateFieldGet(this, _uploadFile).call(this, evt.target)];
                            case 1:
                                _d.sent();
                                $__default['default']('body').children("#" + this.id).remove();
                                return [2 /*return*/];
                        }
                    });
                }); });
                $__default['default']("#" + _this.id).trigger('click');
            };
            _uploadFile.set(this, function (target) { return __awaiter(_this, void 0, void 0, function () {
                var originFiles, files, i, file, message, files_1, files_1_1, file, lastDot, extension;
                var e_1, _d;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            if (!target.files.length) {
                                return [2 /*return*/];
                            }
                            originFiles = target.files;
                            files = [];
                            if (originFiles.length + this.previewFiles.length > this.max) {
                                this.notifyService.notify.warning(this.translateService.translate('Max number of files') + " " + this.max);
                                return [2 /*return*/];
                            }
                            i = 0;
                            _e.label = 1;
                        case 1:
                            if (!(i < originFiles.length)) return [3 /*break*/, 4];
                            file = originFiles.item(i);
                            return [4 /*yield*/, __classPrivateFieldGet(this, _validate).call(this, file)];
                        case 2:
                            message = _e.sent();
                            if (message) {
                                this.notifyService.notify.warning(message);
                                return [2 /*return*/];
                            }
                            files.push(file);
                            _e.label = 3;
                        case 3:
                            i++;
                            return [3 /*break*/, 1];
                        case 4:
                            try {
                                for (files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                                    file = files_1_1.value;
                                    lastDot = file.name.lastIndexOf('.');
                                    extension = file.name.substring(lastDot + 1);
                                    this.previewFiles.push({
                                        file: file,
                                        src: null,
                                        fileName: file.name,
                                        extension: extension
                                    });
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (files_1_1 && !files_1_1.done && (_d = files_1.return)) _d.call(files_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            this.formControl.setValue(this.previewFiles);
                            this.sdChange.emit(this.previewFiles);
                            this.ref.detectChanges();
                            return [2 /*return*/];
                    }
                });
            }); });
            this.onRemove = function (previewFile) {
                var idx = _this.previewFiles.indexOf(previewFile);
                _this.previewFiles.splice(idx, 1);
                _this.formControl.setValue(_this.previewFiles, {
                    emitEvent: false
                });
                _this.formControl.setValue(_this.previewFiles);
                _this.sdChange.emit(_this.previewFiles);
            };
            _validator.set(this, function (c) {
                var value = c.value || null;
                if (_this.min > 0) {
                    var previewFiles = _this.formControl.value || [];
                    if (previewFiles.length < _this.min) {
                        return {
                            min: _this.translateService.translate('Please select at least') + " " + _this.min
                        };
                    }
                }
                if (_this.max > 0) {
                    var previewFiles = _this.formControl.value || [];
                    if (previewFiles.length > _this.max) {
                        return {
                            max: _this.translateService.translate('Please select at most') + " " + _this.max
                        };
                    }
                }
                return null;
            });
        }
        Object.defineProperty(SdInputUploadFile.prototype, "disabled", {
            // Optional
            set: function (val) {
                val = (val === '') || val;
                if (val) {
                    this.formControl.disable();
                }
                else {
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputUploadFile.prototype, "model", {
            set: function (model) {
                if (this.previewFiles !== model && Array.isArray(model)) {
                    __classPrivateFieldSet(this, _model, model);
                    __classPrivateFieldGet(this, _modelChanges).next(__classPrivateFieldGet(this, _model));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputUploadFile.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputUploadFile.prototype, "_inlineError", {
            set: function (val) {
                this.inlineError = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInputUploadFile.prototype, "required", {
            set: function (val) {
                this.isRequired = (val === '') || val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        SdInputUploadFile.prototype.ngOnInit = function () {
            this.formControl.setValidators([__classPrivateFieldGet(this, _validator)]);
            this.inputControl.disable();
        };
        // Hàm tạo Validators tùy chỉnh cho inlineError
        SdInputUploadFile.prototype.customInlineErrorValidator = function () {
            return function (control) {
                return { inlineError: true };
            };
        };
        SdInputUploadFile.prototype.ngAfterViewInit = function () {
            var _this = this;
            __classPrivateFieldGet(this, _subscription).add(__classPrivateFieldGet(this, _modelChanges).pipe(operators.startWith(__classPrivateFieldGet(this, _model))).subscribe(function (previewFiles) {
                if (Array.isArray(previewFiles)) {
                    _this.previewFiles = [];
                    previewFiles.forEach(function (previewFile) {
                        if (typeof (previewFile) === 'string') {
                            _this.previewFiles.push({
                                file: null,
                                src: previewFile
                            });
                        }
                        else {
                            _this.previewFiles.push(previewFile);
                        }
                    });
                    _this.formControl.setValue(_this.previewFiles);
                    _this.modelChange.emit(_this.previewFiles);
                }
            }));
        };
        SdInputUploadFile.prototype.ngOnDestroy = function () {
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        return SdInputUploadFile;
    }());
    _model = new WeakMap(), _subscription = new WeakMap(), _modelChanges = new WeakMap(), _updateValidator = new WeakMap(), _validate = new WeakMap(), _uploadFile = new WeakMap(), _validator = new WeakMap();
    SdInputUploadFile.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-input-upload-file',
                    template: "<mat-form-field class=\"sd-md\" appearance=\"outline\">\r\n  <mat-label *ngIf=\"label\">{{label}}</mat-label>\r\n  <mat-chip-list [formControl]=\"formControl\" #chipList>\r\n    <ng-container *ngFor=\"let item of previewFiles\">\r\n      <mat-chip *ngIf=\"item\" [removable]=\"!formControl.disabled\" (removed)=\"onRemove(item)\"\r\n        [removable]=\"formControl.disabled\">\r\n        <span>{{item.fileName || item.src}}</span>\r\n        <mat-icon matChipRemove *ngIf=\"!formControl.disabled\">cancel</mat-icon>\r\n      </mat-chip>\r\n    </ng-container>\r\n    <input [formControl]=\"inputControl\" [placeholder]=\"placeholder || label\" [matChipInputFor]=\"chipList\"\r\n      autocomplete=\"off\" [errorStateMatcher]=\"matcher\" matInput>\r\n    <mat-icon class=\"pointer sd-suffix-icon\" (click)=\"onUpload()\" matSuffix>file_upload\r\n    </mat-icon>\r\n  </mat-chip-list>\r\n  <mat-error *ngIf=\"formControl.errors?.required\">\r\n    <ng-container *ngIf=\"!disableErrorMessage\">{{ \"This field is required\" | sdTranslate }}</ng-container>\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formControl?.errors?.min\">\r\n    {{formControl?.errors?.min}}\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formControl?.errors?.max\">\r\n    {{formControl?.errors?.max}}\r\n  </mat-error>\r\n  <mat-error *ngIf=\"formControl.errors?.inlineError\">\r\n    <ng-container *ngIf=\"!disableErrorMessage\">{{inlineError}}</ng-container>\r\n  </mat-error>\r\n</mat-form-field>",
                    styles: [":host{display:block;padding-top:5px}"]
                },] }
    ];
    SdInputUploadFile.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: notify.SdNotifyService },
        { type: translate.SdTranslateService }
    ]; };
    SdInputUploadFile.propDecorators = {
        label: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        type: [{ type: core.Input }],
        extensions: [{ type: core.Input }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        maxSize: [{ type: core.Input }],
        maxWidth: [{ type: core.Input }],
        maxHeight: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        model: [{ type: core.Input }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        _inlineError: [{ type: core.Input, args: ['inlineError',] }],
        required: [{ type: core.Input }],
        modelChange: [{ type: core.Output }],
        sdChange: [{ type: core.Output }]
    };

    var SdInputUploadFileModule = /** @class */ (function () {
        function SdInputUploadFileModule() {
        }
        return SdInputUploadFileModule;
    }());
    SdInputUploadFileModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        ngxDeviceDetector.DeviceDetectorModule.forRoot(),
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        chips.MatChipsModule,
                        icon.MatIconModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        notify.SdNotifyModule,
                        translate.SdTranslateModule
                    ],
                    declarations: [
                        SdInputUploadFile
                    ],
                    exports: [
                        SdInputUploadFile
                    ],
                    providers: []
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdInputUploadFile = SdInputUploadFile;
    exports.SdInputUploadFileModule = SdInputUploadFileModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-input-upload-file.umd.js.map
