(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/icon'), require('@angular/material/tooltip'), require('@angular/forms'), require('uuid'), require('object-hash'), require('rxjs'), require('@sd-angular/core/common'), require('@sd-angular/core/utility'), require('@angular/material/input'), require('@angular/material/form-field'), require('@sd-angular/core/translate'), require('@angular/material/button'), require('@sd-angular/core/popover')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/input', ['exports', '@angular/core', '@angular/common', '@angular/material/icon', '@angular/material/tooltip', '@angular/forms', 'uuid', 'object-hash', 'rxjs', '@sd-angular/core/common', '@sd-angular/core/utility', '@angular/material/input', '@angular/material/form-field', '@sd-angular/core/translate', '@angular/material/button', '@sd-angular/core/popover'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.input = {}), global.ng.core, global.ng.common, global.ng.material.icon, global.ng.material.tooltip, global.ng.forms, global.uuid, global.hash, global.rxjs, global['sd-angular'].core.common, global['sd-angular'].core.utility, global.ng.material.input, global.ng.material.formField, global['sd-angular'].core.translate, global.ng.material.button, global['sd-angular'].core.popover));
}(this, (function (exports, core, common$1, icon, tooltip, forms, uuid, hash, rxjs, common, utility, input, formField, translate, button, popover) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var SdInputSuffixDirective = /** @class */ (function () {
        function SdInputSuffixDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return SdInputSuffixDirective;
    }());
    SdInputSuffixDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[sdInputSuffix]'
                },] }
    ];
    SdInputSuffixDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var _name, _form, _blurOnEnter_1, _model, _pattern, _validator, _subscription, _updateValidator, _onChange, _customValidator;
    var SdInput = /** @class */ (function () {
        function SdInput(ref, formConfig, utilityService) {
            var _this = this;
            this.ref = ref;
            this.formConfig = formConfig;
            this.utilityService = utilityService;
            this.id = "I" + uuid.v4();
            _name.set(this, uuid.v4());
            _form.set(this, void 0);
            this.type = 'text';
            this.disableErrorMessage = false;
            _blurOnEnter_1.set(this, false);
            _model.set(this, void 0);
            this.modelChange = new core.EventEmitter();
            // Validator
            this.isRequired = false;
            this.isReadonly = false;
            _pattern.set(this, void 0);
            _validator.set(this, void 0);
            this.icon = 'search';
            this.hideIcon = false;
            this.sdClickIcon = new core.EventEmitter();
            this.sdChange = new core.EventEmitter();
            this.sdFocus = new core.EventEmitter();
            this.sdBlur = new core.EventEmitter();
            this.sdFocusForceBlur = new core.EventEmitter();
            this.keyupEnter = new core.EventEmitter();
            this.formControl = new common.SdFormControl();
            _subscription.set(this, new rxjs.Subscription());
            this.isFocused = false;
            this.copyable = false;
            this.copied = false;
            this.reValidate = function () {
                _this.formControl.updateValueAndValidity();
            };
            _updateValidator.set(this, function () {
                _this.formControl.clearValidators();
                _this.formControl.clearAsyncValidators();
                var validators = [];
                var asyncValidators = [];
                if (_this.isRequired) {
                    validators.push(forms.Validators.required);
                }
                if (_this.minlength > 0) {
                    validators.push(forms.Validators.minLength(_this.minlength));
                }
                if (_this.maxlength > 0) {
                    validators.push(forms.Validators.maxLength(_this.maxlength));
                }
                if (__classPrivateFieldGet(_this, _pattern)) {
                    validators.push(forms.Validators.pattern(__classPrivateFieldGet(_this, _pattern)));
                }
                if (_this.inlineError) {
                    validators.push(_this.customInlineErrorValidator());
                }
                if (__classPrivateFieldGet(_this, _validator)) {
                    asyncValidators.push(__classPrivateFieldGet(_this, _customValidator).call(_this, __classPrivateFieldGet(_this, _validator)));
                }
                _this.formControl.setValidators(validators);
                _this.formControl.setAsyncValidators(asyncValidators);
                _this.formControl.updateValueAndValidity();
            }
            // Hàm tạo Validators tùy chỉnh cho inlineError
            );
            _onChange.set(this, function (value) {
                _this.modelChange.emit(_this.formControl.value);
                _this.sdChange.emit(_this.formControl.value);
            });
            this.onKeyupEnter = function () {
                var _a;
                var val = ((_a = _this.formControl.value) !== null && _a !== void 0 ? _a : '').toString();
                if (val.length > val.trim().length) {
                    _this.formControl.setValue(val.trim());
                }
                _this.keyupEnter.emit(_this.formControl.value);
                if (__classPrivateFieldGet(_this, _blurOnEnter_1)) {
                    _this.blur();
                }
            };
            this.onClickIcon = function (event) {
                event === null || event === void 0 ? void 0 : event.preventDefault();
                event === null || event === void 0 ? void 0 : event.stopPropagation();
                _this.sdClickIcon.emit(_this.formControl.value);
            };
            this.onFocus = function () {
                var _a;
                _this.isFocused = true;
                _this.sdFocus.emit();
                if (((_a = _this.sdFocusForceBlur.observers) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                    _this.blur();
                    _this.sdFocusForceBlur.emit();
                }
            };
            this.onBlur = function () {
                var _a;
                _this.isFocused = false;
                var val = ((_a = _this.formControl.value) !== null && _a !== void 0 ? _a : '').toString();
                if (val.length > val.trim().length) {
                    _this.formControl.setValue(val.trim());
                }
                _this.sdBlur.emit(_this.formControl.value);
            };
            this.onClick = function () {
                var _a;
                if ((_a = _this.sdView) === null || _a === void 0 ? void 0 : _a.templateRef) {
                    if (!_this.formControl.disabled && !_this.isFocused) {
                        _this.focus();
                    }
                }
            };
            this.blur = function () {
                var _a, _b;
                _this.isFocused = false;
                (_b = (_a = _this.control) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.blur();
            };
            this.focus = function () {
                _this.isFocused = true;
                setTimeout(function () {
                    var _a, _b;
                    (_b = (_a = _this.control) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.focus();
                }, 100);
            };
            _customValidator.set(this, function (func) {
                return function (c) { return __awaiter(_this, void 0, void 0, function () {
                    var value, result, message;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                value = c.value || null;
                                if (!(func && typeof (func) === 'function')) return [3 /*break*/, 3];
                                result = func(value);
                                if (!(result instanceof Promise)) return [3 /*break*/, 2];
                                return [4 /*yield*/, result];
                            case 1:
                                message = _c.sent();
                                if (message) {
                                    return [2 /*return*/, {
                                            customValidator: message
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 2:
                                if (result) {
                                    return [2 /*return*/, {
                                            customValidator: result
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 3: return [2 /*return*/, null];
                        }
                    });
                }); };
            });
        }
        Object.defineProperty(SdInput.prototype, "name", {
            set: function (val) {
                if (val) {
                    __classPrivateFieldSet(this, _name, val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "form", {
            set: function (val) {
                if (val) {
                    if (val instanceof forms.NgForm) {
                        __classPrivateFieldSet(this, _form, val.form);
                    }
                    else {
                        __classPrivateFieldSet(this, _form, val);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "_label", {
            set: function (val) {
                this.label = val;
                this.qcId = hash__default['default']({
                    selector: 'sd-input',
                    label: val
                });
            },
            enumerable: false,
            configurable: true
        });
        ;
        Object.defineProperty(SdInput.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "_blurOnEnter", {
            set: function (val) {
                __classPrivateFieldSet(this, _blurOnEnter_1, (val === '') || val);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "model", {
            set: function (value) {
                if (__classPrivateFieldGet(this, _model) !== value) {
                    __classPrivateFieldSet(this, _model, value);
                    this.formControl.setValue(value, {
                        emitEvent: false
                    });
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "required", {
            set: function (val) {
                this.isRequired = (val === '') || val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "readonly", {
            set: function (val) {
                this.isReadonly = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "pMinlength", {
            set: function (val) {
                this.minlength = +val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "pMaxlength", {
            set: function (val) {
                this.maxlength = +val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "pattern", {
            set: function (val) {
                __classPrivateFieldSet(this, _pattern, val);
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "validator", {
            set: function (validator) {
                __classPrivateFieldSet(this, _validator, validator);
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "_inlineError", {
            set: function (val) {
                this.inlineError = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "disabled", {
            // Optional
            set: function (val) {
                val = (val === '') || val;
                if (val) {
                    this.formControl.disable();
                }
                else {
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "_hideIcon", {
            set: function (val) {
                this.hideIcon = (val === '') || val;
                val = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdInput.prototype, "_copyable", {
            set: function (val) {
                this.copyable = (val === '') || val;
            },
            enumerable: false,
            configurable: true
        });
        SdInput.prototype.ngOnInit = function () {
            var _this = this;
            var _a;
            this.appearance = this.appearance || ((_a = this.formConfig) === null || _a === void 0 ? void 0 : _a.appearance);
            __classPrivateFieldGet(this, _subscription).add(this.formControl.sdChanges.subscribe(function () {
                _this.ref.markForCheck();
            }));
        };
        SdInput.prototype.ngAfterViewInit = function () {
            var _a;
            __classPrivateFieldGet(this, _subscription).add(this.formControl.valueChanges.subscribe(__classPrivateFieldGet(this, _onChange)));
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.addControl(__classPrivateFieldGet(this, _name), this.formControl);
            this.ref.detectChanges();
        };
        SdInput.prototype.ngOnDestroy = function () {
            var _a;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.removeControl(__classPrivateFieldGet(this, _name));
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        // Hàm tạo Validators tùy chỉnh cho inlineError
        SdInput.prototype.customInlineErrorValidator = function () {
            return function (control) {
                return { inlineError: true };
            };
        };
        SdInput.prototype.onCopyText = function () {
            var _this = this;
            SdUtility.copyToClipboard(__classPrivateFieldGet(this, _model));
            this.copied = true;
            setTimeout(function () {
                _this.copied = false;
            }, 2000);
        };
        return SdInput;
    }());
    _name = new WeakMap(), _form = new WeakMap(), _blurOnEnter_1 = new WeakMap(), _model = new WeakMap(), _pattern = new WeakMap(), _validator = new WeakMap(), _subscription = new WeakMap(), _updateValidator = new WeakMap(), _onChange = new WeakMap(), _customValidator = new WeakMap();
    SdInput.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-input',
                    template: "<ng-container *ngIf=\"!appearance && sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\">\r\n  </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"!appearance && label && !sdLabelDef?.templateRef\" class=\"d-block mb-0 T14M\">{{label}} <span class=\"text-danger mb-2\"\r\n    *ngIf=\"isRequired\">*</span></label>\r\n<div class=\"d-flex align-items-center\" [class.sd-view]=\"sdView?.templateRef\" [class.c-focused]=\"isFocused\"\r\n  [class.c-disabled]=\"formControl.disabled\" (click)=\"onClick()\">\r\n  <ng-container *ngIf=\"sdView?.templateRef && !isFocused; else default\">\r\n    <ng-container *ngTemplateOutlet=\"sdView.templateRef;context: { value: formControl.value }\">\r\n    </ng-container>\r\n  </ng-container>\r\n  <ng-template #default>\r\n    <mat-form-field class=\"sd-md\"\r\n      [ngClass]=\"{'sd-form-tooltip':tooltip, 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage}\"\r\n      [appearance]=\"appearance || 'outline'\">\r\n      <mat-label *ngIf=\"appearance && label\">{{label}}</mat-label>\r\n      <input aria-hidden=\"true\" [id]=\"id\" [formControl]=\"formControl\" [type]=\"type\" #control matInput\r\n        [placeholder]=\"placeholder || (appearance ? label : '')\" (keyup.enter)=\"onKeyupEnter()\" (focus)=\"onFocus()\"\r\n        (blur)=\"onBlur()\" [required]=\"isRequired\" [readonly]=\"isReadonly\" [autocomplete]=\"id\" autocorrect=\"off\"\r\n        [step]=\"1\" [attr.data-qclabel]=\"label\" [attr.data-qcid]=\"qcId\" [sdPopoverTriggerFor]=\"null\"\r\n        [sdPopoverDisabled]=\"!disableErrorMessage || formControl.valid\">\r\n        <svg \r\n          #copyTooltip=\"matTooltip\" \r\n          *ngIf=\"copyable\" \r\n          matSuffix \r\n          [matTooltip]=\"copied ? 'Copied' : 'Copy'\" \r\n          class=\"icon-copy\" \r\n          focusable=\"false\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 448 512\" \r\n          (click)=\"onCopyText()\">\r\n          <path d=\"M433.941 65.941l-51.882-51.882A48 48 0 0 0 348.118 0H176c-26.51 0-48 21.49-48 48v48H48c-26.51 0-48 21.49-48 48v320c0 26.51 21.49 48 48 48h224c26.51 0 48-21.49 48-48v-48h80c26.51 0 48-21.49 48-48V99.882a48 48 0 0 0-14.059-33.941zM266 464H54a6 6 0 0 1-6-6V150a6 6 0 0 1 6-6h74v224c0 26.51 21.49 48 48 48h96v42a6 6 0 0 1-6 6zm128-96H182a6 6 0 0 1-6-6V54a6 6 0 0 1 6-6h106v88c0 13.255 10.745 24 24 24h88v202a6 6 0 0 1-6 6zm6-256h-64V48h9.632c1.591 0 3.117.632 4.243 1.757l48.368 48.368a6 6 0 0 1 1.757 4.243V112z\"></path>\r\n        </svg>\r\n      <span class=\"mr-1\" *ngIf=\"maxlength && !formControl.disabled\" matSuffix>{{formControl.value?.length || 0}}/{{maxlength}}</span>\r\n      <ng-container *ngIf=\"sdInputSuffix?.templateRef\" matSuffix>\r\n        <ng-container *ngTemplateOutlet=\"sdInputSuffix.templateRef\">\r\n        </ng-container>\r\n      </ng-container>\r\n      <ng-content select=\"[sdSuffixIcon]\" matSuffix></ng-content>\r\n      <mat-icon *ngIf=\"!hideIcon && sdClickIcon?.observers?.length\" (click)=\"onClickIcon($event)\"\r\n        class=\"pointer sd-suffix-icon\" matSuffix>\r\n        {{icon}}\r\n      </mat-icon>\r\n      <mat-error *ngIf=\"formControl.errors?.required\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ \"This field is required\" | sdTranslate }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\" formControl.errors?.maxlength\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{'Max length' | sdTranslate}} {{maxlength}}\r\n        </ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.pattern\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{'Pattern error' | sdTranslate}}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.customValidator\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{formControl.errors?.customValidator}}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.inlineError\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{inlineError}}</ng-container>\r\n      </mat-error>\r\n    </mat-form-field>\r\n\r\n    <div *ngIf=\"tooltip\" class=\"sd-tooltip\">\r\n      <mat-icon (click)=\"sdTooltip.toggle()\" [matTooltip]=\"formControl.value | sdInputTooltipPipe:tooltip\" matSuffix\r\n        #sdTooltip=\"matTooltip\">info</mat-icon>\r\n    </div>\r\n  </ng-template>\r\n</div>\r\n<!-- <sd-popover #error=\"sdPopover\" type=\"danger\" width=\"300px\">\r\n  <span *ngIf=\"formControl.errors?.required\">\r\n    {{ \"This field is required\" | sdTranslate }}\r\n  </span>\r\n  <span *ngIf=\"formControl.errors?.maxlength\">\r\n    {{'Max length' | sdTranslate}} <strong>{{maxlength}}</strong>\r\n  </span>\r\n  <span *ngIf=\"formControl.errors?.pattern\">\r\n    {{'Pattern error' | sdTranslate}}\r\n  </span>\r\n  <span *ngIf=\"formControl.errors?.customValidator\">\r\n    {{formControl.errors?.customValidator}}\r\n  </span>\r\n</sd-popover> -->",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host ::ng-deep .mat-form-field.sd-form-tooltip{width:calc(100% - 30px)}:host ::ng-deep .mat-form-field.no-padding-wrapper .mat-form-field-wrapper{padding-bottom:0}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{background:#f6f6f6;color:#e9e9e9}:host ::ng-deep .mat-form-field input.mat-input-element:disabled{color:#4d4d4d!important}:host ::ng-deep .mat-form-field .mat-placeholder-required{color:#f82c13}:host ::ng-deep .mat-form-field:hover .icon-copy{opacity:1}:host ::ng-deep .mat-form-field .icon-copy{cursor:pointer;fill:rgba(0,0,0,.5);height:.9em;opacity:0;transition:opacity .2s linear;width:.9em}.sd-view:not(.c-focused):not(.c-disabled):hover{background-color:#ebecf0}.sd-tooltip{display:inline-block;margin:auto;text-align:center;width:30px}:host{display:block;padding-top:5px}.sd-md:hover .btn-copy{visibility:visible}"]
                },] }
    ];
    SdInput.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.FORM_CONFIG,] }, { type: core.Optional }] },
        { type: utility.SdUtilityService }
    ]; };
    SdInput.propDecorators = {
        name: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        size: [{ type: core.Input }],
        form: [{ type: core.Input }],
        _label: [{ type: core.Input, args: ['label',] }],
        placeholder: [{ type: core.Input }],
        type: [{ type: core.Input }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        _blurOnEnter: [{ type: core.Input, args: ['blurOnEnter',] }],
        model: [{ type: core.Input }],
        modelChange: [{ type: core.Output }],
        required: [{ type: core.Input }],
        readonly: [{ type: core.Input }],
        pMinlength: [{ type: core.Input, args: ['minlength',] }],
        pMaxlength: [{ type: core.Input, args: ['maxlength',] }],
        pattern: [{ type: core.Input }],
        validator: [{ type: core.Input }],
        _inlineError: [{ type: core.Input, args: ['inlineError',] }],
        disabled: [{ type: core.Input }],
        icon: [{ type: core.Input }],
        _hideIcon: [{ type: core.Input, args: ['hideIcon',] }],
        sdClickIcon: [{ type: core.Output }],
        tooltip: [{ type: core.Input }],
        sdChange: [{ type: core.Output }],
        sdFocus: [{ type: core.Output }],
        sdBlur: [{ type: core.Output }],
        sdFocusForceBlur: [{ type: core.Output }],
        keyupEnter: [{ type: core.Output }],
        control: [{ type: core.ViewChild, args: ['control',] }],
        sdInputSuffix: [{ type: core.ContentChild, args: [SdInputSuffixDirective,] }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }],
        sdView: [{ type: core.ContentChild, args: [common.SdViewDefDirective,] }],
        copyTooltip: [{ type: core.ViewChild, args: ['copyTooltip',] }],
        _copyable: [{ type: core.Input, args: ['copyable',] }]
    };
    function backendErrorValidator(backendErrorMessage) {
        return function (control) {
            var value = control.value;
            if (value === backendErrorMessage) {
                return { backendError: true };
            }
            return null;
        };
    }

    var SdInputTooltipPipe = /** @class */ (function () {
        function SdInputTooltipPipe() {
        }
        SdInputTooltipPipe.prototype.transform = function (value, tooltip) {
            if (typeof (tooltip) === 'string') {
                return tooltip;
            }
            return tooltip(value);
        };
        return SdInputTooltipPipe;
    }());
    SdInputTooltipPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'sdInputTooltipPipe'
                },] }
    ];

    var TouchDirective = /** @class */ (function () {
        function TouchDirective() {
        }
        TouchDirective.prototype.ngOnChanges = function (changes) {
            if (changes.touch) {
                this.ref.markForCheck();
            }
        };
        return TouchDirective;
    }());
    TouchDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[touch]'
                },] }
    ];
    TouchDirective.propDecorators = {
        touch: [{ type: core.Input }],
        ref: [{ type: core.Input }]
    };

    var SdInputModule = /** @class */ (function () {
        function SdInputModule() {
        }
        return SdInputModule;
    }());
    SdInputModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        icon.MatIconModule,
                        tooltip.MatTooltipModule,
                        translate.SdTranslateModule,
                        common.SdCommonModule,
                        popover.SdPopoverModule,
                        button.MatButtonModule
                    ],
                    declarations: [
                        SdInput,
                        SdInputTooltipPipe,
                        SdInputSuffixDirective,
                        TouchDirective
                    ],
                    exports: [
                        SdInput,
                        SdInputTooltipPipe,
                        SdInputSuffixDirective,
                        common.SdCommonModule
                    ]
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdInput = SdInput;
    exports.SdInputModule = SdInputModule;
    exports.SdInputSuffixDirective = SdInputSuffixDirective;
    exports.SdInputTooltipPipe = SdInputTooltipPipe;
    exports.backendErrorValidator = backendErrorValidator;
    exports.ɵa = TouchDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-input.umd.js.map
