(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('uuid'), require('ngx-device-detector'), require('rxjs'), require('@angular/cdk/bidi'), require('@angular/cdk/overlay'), require('@angular/cdk/platform'), require('@angular/cdk/portal'), require('rxjs/operators'), require('@angular/cdk/a11y')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/popover', ['exports', '@angular/core', '@angular/common', 'uuid', 'ngx-device-detector', 'rxjs', '@angular/cdk/bidi', '@angular/cdk/overlay', '@angular/cdk/platform', '@angular/cdk/portal', 'rxjs/operators', '@angular/cdk/a11y'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.popover = {}), global.ng.core, global.ng.common, global.uuid, global.ngxDeviceDetector, global.rxjs, global.ng.cdk.bidi, global.ng.cdk.overlay, global.ng.cdk.platform, global.ng.cdk.portal, global.rxjs.operators, global.ng.cdk.a11y));
}(this, (function (exports, core, common, uuid, ngxDeviceDetector, rxjs, bidi, overlay, platform, portal, operators, a11y) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var PopoverContentDirective = /** @class */ (function () {
        function PopoverContentDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return PopoverContentDirective;
    }());
    PopoverContentDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[sdPopoverContent]'
                },] }
    ];
    PopoverContentDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var _previousPanelClass, _xPosition;
    var PopoverComponent = /** @class */ (function () {
        function PopoverComponent(cdRef, deviceService) {
            var _this = this;
            this.cdRef = cdRef;
            this.deviceService = deviceService;
            this.classList = {};
            this.panelId = "sd-popover-panel-" + uuid.v4();
            this.isMobileOrTablet = false;
            this.mouseState$ = new rxjs.BehaviorSubject(false);
            this.trigger = null;
            _previousPanelClass.set(this, void 0);
            this.width = 'sm';
            this.height = 'auto';
            this.type = 'normal';
            _xPosition.set(this, void 0);
            this.closed = new core.EventEmitter();
            this.opened = new core.EventEmitter();
            this.close = function () {
                _this.mouseState$.next(false);
                _this.closed.emit();
            };
            this.setPositionClasses = function (pos) {
                if (pos === void 0) { pos = _this.position; }
                var _a;
                var classes = _this.classList;
                classes['sd-popover-above'] = pos === 'above';
                classes['sd-popover-below'] = pos === 'below';
                (_a = _this.cdRef) === null || _a === void 0 ? void 0 : _a.markForCheck();
            };
            this.addArrowTranslateX = function (offset) {
                var arrowElement = document.querySelector("#" + _this.panelId + " .sd-popover-arrow");
                if (arrowElement && offset) {
                    try {
                        var style = window.getComputedStyle(arrowElement);
                        var matrix = new WebKitCSSMatrix(style.transform);
                        var translateX = matrix.m41 + offset;
                        var translateY = matrix.m42;
                        arrowElement.style.transform = "translateX(" + translateX + "px) translateY(" + translateY + "px)";
                    }
                    catch (error) { }
                }
            };
            this.setMouseState = function (visible) {
                if (!visible) {
                    // chỉ được tắt khi đang không focus element nào bên trong panel
                    // tránh lỗi có control mở overlay khiến cho mất mouseenter ở panel
                    var activeElement = document.activeElement;
                    var panelElement = _this.panel.nativeElement;
                    if (panelElement === null || panelElement === void 0 ? void 0 : panelElement.contains(activeElement)) {
                        return;
                    }
                }
                _this.mouseState$.next(visible);
            };
            this.isMobileOrTablet = !deviceService.isDesktop();
        }
        Object.defineProperty(PopoverComponent.prototype, "panelClass", {
            set: function (classes) {
                var _this = this;
                var previousPanelClass = __classPrivateFieldGet(this, _previousPanelClass);
                if (previousPanelClass && previousPanelClass.length) {
                    previousPanelClass.split(' ').forEach(function (className) {
                        _this.classList[className] = false;
                    });
                }
                __classPrivateFieldSet(this, _previousPanelClass, classes);
                if (classes && classes.length) {
                    classes.split(' ').forEach(function (className) {
                        _this.classList[className] = true;
                    });
                }
            },
            enumerable: false,
            configurable: true
        });
        ;
        Object.defineProperty(PopoverComponent.prototype, "position", {
            get: function () {
                return __classPrivateFieldGet(this, _xPosition);
            },
            set: function (value) {
                __classPrivateFieldSet(this, _xPosition, value);
                this.setPositionClasses();
            },
            enumerable: false,
            configurable: true
        });
        PopoverComponent.prototype._hostClick = function (targetElement) {
            var _a;
            if ((_a = this.panel) === null || _a === void 0 ? void 0 : _a.nativeElement) {
                var isInside = this.panel.nativeElement.contains(targetElement);
                if (!isInside) {
                    this.setMouseState(false);
                }
            }
        };
        PopoverComponent.prototype.ngOnChanges = function (changes) {
            if (changes.type) {
                var type = changes.type.currentValue;
                var preType = changes.type.previousValue;
                if (preType) {
                    this.classList["sd-popover--" + preType] = false;
                }
                if (type) {
                    this.classList["sd-popover--" + type] = true;
                }
            }
        };
        PopoverComponent.prototype.ngOnInit = function () {
            this.setPositionClasses();
            this.width = this.width || '80vw';
            if (!this.isMobileOrTablet) {
                switch (this.width) {
                    case 'lg':
                        this.width = '80vw';
                        break;
                    case 'md':
                        this.width = '60vw';
                        break;
                    case 'sm':
                        this.width = '40vw';
                        break;
                }
            }
        };
        PopoverComponent.prototype.ngOnDestroy = function () {
            this.closed.complete();
            this.opened.complete();
            this.mouseState$.complete();
        };
        return PopoverComponent;
    }());
    _previousPanelClass = new WeakMap(), _xPosition = new WeakMap();
    PopoverComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-popover',
                    template: "<ng-template let-data=\"data\">\r\n  <div\r\n    class=\"sd-popover-panel mat-elevation-z6\"\r\n    [id]=\"panelId\"\r\n    [ngClass]=\"classList\"\r\n    tabindex=\"-1\"\r\n    role=\"menu\"\r\n    (mouseenter)=\"setMouseState(true)\"\r\n    (mouseleave)=\"setMouseState(false)\"\r\n    cdkTrapFocus\r\n    #panel\r\n  >\r\n    <div class=\"sd-popover-content\">\r\n      <ng-container *ngIf=\"popoverContent?.templateRef\">\r\n        <ng-container *ngTemplateOutlet=\"popoverContent.templateRef; context:{data: data}\"></ng-container>\r\n      </ng-container>\r\n      <ng-content></ng-content>\r\n    </div>\r\n    <div class=\"sd-popover-arrow\"></div>\r\n  </div>\r\n</ng-template>",
                    encapsulation: core.ViewEncapsulation.None,
                    exportAs: 'sdPopover',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".text-black400{color:#757575}.sd-popover-panel{background:#fff;height:100%;position:relative;width:100%}.sd-popover-panel .sd-popover-arrow{clear:both;height:0;left:50%;position:absolute;width:0}.sd-popover-panel.sd-popover-above .sd-popover-arrow{border-color:#fff transparent transparent;border-style:solid;border-width:12px 12px 0;top:100%;transform:translateX(-6px) translateY(-1px)}.sd-popover-panel.sd-popover-above:after{content:\" \";display:block;height:16px;position:absolute;width:100%}.sd-popover-panel.sd-popover-below .sd-popover-arrow{border-color:transparent transparent #fff;border-style:solid;border-width:0 12px 12px;bottom:100%;transform:translateX(-6px) translateY(1px)}.sd-popover-panel.sd-popover-below:before{content:\" \";display:block;height:16px;position:absolute;width:100%}.sd-popover-panel .sd-popover-content{height:100%}.sd-popover--normal{background:#fff;color:#000}.sd-popover--normal.sd-popover-above .sd-popover-arrow{border-color:#fff transparent transparent;border-style:solid;border-width:12px 12px 0;top:100%}.sd-popover--normal.sd-popover-below .sd-popover-arrow{border-color:transparent transparent #fff;border-style:solid;border-width:0 12px 12px;bottom:100%}.sd-popover--primary{background:#e7e9ff;color:#2962ff}.sd-popover--primary.sd-popover-above .sd-popover-arrow{border-color:#e7e9ff transparent transparent;border-style:solid;border-width:12px 12px 0;top:100%}.sd-popover--primary.sd-popover-below .sd-popover-arrow{border-color:transparent transparent #e7e9ff;border-style:solid;border-width:0 12px 12px;bottom:100%}.sd-popover--info{background:#e7e9ff;color:#2962ff}.sd-popover--info.sd-popover-above .sd-popover-arrow{border-color:#e7e9ff transparent transparent;border-style:solid;border-width:12px 12px 0;top:100%}.sd-popover--info.sd-popover-below .sd-popover-arrow{border-color:transparent transparent #e7e9ff;border-style:solid;border-width:0 12px 12px;bottom:100%}.sd-popover--success{background:#dbefdc;color:#4caf50}.sd-popover--success.sd-popover-above .sd-popover-arrow{border-color:#dbefdc transparent transparent;border-style:solid;border-width:12px 12px 0;top:100%}.sd-popover--success.sd-popover-below .sd-popover-arrow{border-color:transparent transparent #dbefdc;border-style:solid;border-width:0 12px 12px;bottom:100%}.sd-popover--warning{background:#ffeacc;color:#ff9600}.sd-popover--warning.sd-popover-above .sd-popover-arrow{border-color:#ffeacc transparent transparent;border-style:solid;border-width:12px 12px 0;top:100%}.sd-popover--warning.sd-popover-below .sd-popover-arrow{border-color:transparent transparent #ffeacc;border-style:solid;border-width:0 12px 12px;bottom:100%}.sd-popover--danger{background:#fed5d0;color:#f82c13}.sd-popover--danger.sd-popover-above .sd-popover-arrow{border-color:#fed5d0 transparent transparent;border-style:solid;border-width:12px 12px 0;top:100%}.sd-popover--danger.sd-popover-below .sd-popover-arrow{border-color:transparent transparent #fed5d0;border-style:solid;border-width:0 12px 12px;bottom:100%}.sd-popover-content{padding:16px}"]
                },] }
    ];
    PopoverComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: ngxDeviceDetector.DeviceDetectorService }
    ]; };
    PopoverComponent.propDecorators = {
        templateRef: [{ type: core.ViewChild, args: [core.TemplateRef,] }],
        panel: [{ type: core.ViewChild, args: ['panel',] }],
        popoverContent: [{ type: core.ContentChild, args: [PopoverContentDirective,] }],
        panelClass: [{ type: core.Input, args: ['class',] }],
        width: [{ type: core.Input }],
        height: [{ type: core.Input }],
        type: [{ type: core.Input }],
        position: [{ type: core.Input }],
        closed: [{ type: core.Output }],
        opened: [{ type: core.Output }],
        _hostClick: [{ type: core.HostListener, args: ['document:click', ['$event.target'],] }]
    };

    var _overlayRef, _popoverClose$, _portal, _destroy$, _popover, _setIsPopoverOpen, _getPortal, _createOverlay, _setPosition, _getOverlayConfig, _subscribeToPositions, _destroyPopover;
    var PopoverTriggerDirective = /** @class */ (function () {
        function PopoverTriggerDirective(_overlay, _element, _ngZone, viewContainerRef, elementRef, platform, _dir) {
            var _this = this;
            this._overlay = _overlay;
            this._element = _element;
            this._ngZone = _ngZone;
            this.viewContainerRef = viewContainerRef;
            this.elementRef = elementRef;
            this.platform = platform;
            this._dir = _dir;
            _overlayRef.set(this, null);
            _popoverClose$.set(this, rxjs.Subscription.EMPTY);
            _portal.set(this, void 0);
            _destroy$.set(this, new rxjs.Subject());
            this.popoverOpen = false;
            _popover.set(this, void 0);
            this.disabled = false;
            this.popoverOpened = new core.EventEmitter();
            this.popoverClosed = new core.EventEmitter();
            this.openPopover = function () {
                if (_this.popoverOpen) {
                    return;
                }
                var overlayRef = __classPrivateFieldGet(_this, _createOverlay).call(_this);
                var overlayConfig = overlayRef.getConfig();
                var positionStrategy = overlayConfig.positionStrategy;
                __classPrivateFieldGet(_this, _setPosition).call(_this, positionStrategy);
                overlayConfig.hasBackdrop = false;
                overlayRef.attach(__classPrivateFieldGet(_this, _getPortal).call(_this));
                _this.popover.trigger = _this;
                __classPrivateFieldGet(_this, _setIsPopoverOpen).call(_this, true);
                _this.popover.opened.next(_this.popoverData);
            };
            this.closePopover = function () {
                _this.popover.closed.emit();
            };
            _setIsPopoverOpen.set(this, function (isOpen) {
                _this.popoverOpen = isOpen;
                _this.popoverOpen ? _this.popoverOpened.emit() : _this.popoverClosed.emit();
            });
            _getPortal.set(this, function () {
                var _a;
                if (!__classPrivateFieldGet(_this, _portal) ||
                    __classPrivateFieldGet(_this, _portal).templateRef !== _this.popover.templateRef ||
                    ((_a = __classPrivateFieldGet(_this, _portal).context) === null || _a === void 0 ? void 0 : _a.data) !== _this.popoverData) {
                    __classPrivateFieldSet(_this, _portal, new portal.TemplatePortal(_this.popover.templateRef, _this.viewContainerRef, {
                        data: _this.popoverData
                    }));
                }
                return __classPrivateFieldGet(_this, _portal);
            });
            _createOverlay.set(this, function () {
                if (!__classPrivateFieldGet(_this, _overlayRef)) {
                    var config = __classPrivateFieldGet(_this, _getOverlayConfig).call(_this);
                    __classPrivateFieldGet(_this, _subscribeToPositions).call(_this, config.positionStrategy);
                    __classPrivateFieldSet(_this, _overlayRef, _this._overlay.create(config));
                }
                return __classPrivateFieldGet(_this, _overlayRef);
            });
            _setPosition.set(this, function (positionStrategy) {
                var originX = "center";
                var originY = "top";
                var overlayX = "center";
                var overlayY = "bottom";
                var offsetX = 0;
                var offsetY = 16;
                switch (_this.popover.position) {
                    case "above":
                        originY = "top";
                        overlayY = "bottom";
                        break;
                    case "below":
                        originY = "bottom";
                        overlayY = "top";
                        break;
                }
                positionStrategy.withPositions([
                    // theo input
                    { originX: originX, originY: originY, overlayX: overlayX, overlayY: overlayY, offsetY: originY == "top" ? -offsetY : offsetY },
                    // giữa trên
                    {
                        originX: "center",
                        originY: "top",
                        overlayX: "center",
                        overlayY: "bottom",
                        offsetX: offsetX,
                        offsetY: -offsetY,
                    },
                    // giữa dưới
                    {
                        originX: "center",
                        originY: "bottom",
                        overlayX: "center",
                        overlayY: "top",
                        offsetX: offsetX,
                        offsetY: offsetY,
                    },
                ]);
            });
            _getOverlayConfig.set(this, function () {
                return new overlay.OverlayConfig({
                    positionStrategy: _this._overlay
                        .position()
                        .flexibleConnectedTo(_this._element)
                        .withLockedPosition()
                        .withGrowAfterOpen()
                        .withTransformOriginOn(".sd-popover-panel"),
                    backdropClass: "cdk-overlay-transparent-backdrop",
                    panelClass: _this.popover.panelClass,
                    direction: _this._dir,
                    width: _this.popover.width,
                    height: _this.popover.height,
                });
            });
            _subscribeToPositions.set(this, function (position) {
                if (_this.popover.setPositionClasses) {
                    position.positionChanges.subscribe(function (change) {
                        var _a;
                        var pos = change.connectionPair.overlayY === "top" ? "below" : "above";
                        if (_this._ngZone) {
                            _this._ngZone.run(function () { return _this.popover.setPositionClasses(pos); });
                        }
                        else {
                            _this.popover.setPositionClasses(pos);
                        }
                        var originElement = _this.elementRef.nativeElement;
                        var overlayElement = (_a = _this.viewContainerRef.get(0)) === null || _a === void 0 ? void 0 : _a.rootNodes[0];
                        if (originElement && overlayElement) {
                            var originRect = originElement.getBoundingClientRect();
                            var overlayRect = overlayElement.getBoundingClientRect();
                            var originLeft = originRect.left + originRect.width / 2;
                            var overlayLeft = overlayRect.left + overlayRect.width / 2;
                            var offset = originLeft - overlayLeft;
                            _this.popover.addArrowTranslateX(offset);
                        }
                    });
                }
            });
            _destroyPopover.set(this, function () {
                if (!__classPrivateFieldGet(_this, _overlayRef) || !_this.popoverOpen) {
                    return;
                }
                __classPrivateFieldGet(_this, _overlayRef).detach();
                __classPrivateFieldGet(_this, _setIsPopoverOpen).call(_this, false);
            });
        }
        Object.defineProperty(PopoverTriggerDirective.prototype, "popover", {
            get: function () {
                return __classPrivateFieldGet(this, _popover);
            },
            set: function (popover) {
                var _this = this;
                if (!popover || popover === __classPrivateFieldGet(this, _popover)) {
                    return;
                }
                __classPrivateFieldSet(this, _popover, popover);
                __classPrivateFieldGet(this, _popoverClose$).unsubscribe();
                if (popover) {
                    __classPrivateFieldSet(this, _popoverClose$, popover.closed.subscribe(function () {
                        __classPrivateFieldGet(_this, _destroyPopover).call(_this);
                    }));
                }
            },
            enumerable: false,
            configurable: true
        });
        PopoverTriggerDirective.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (this.popover) {
                var nativeElement = this.elementRef.nativeElement;
                var hostMouseState$ = rxjs.merge(rxjs.fromEvent(nativeElement, "mouseenter").pipe(operators.mapTo(true)), rxjs.fromEvent(nativeElement, "mouseleave").pipe(operators.mapTo(false)));
                var popoverMouseState$ = this.popover.mouseState$.pipe(
                // chỉ lấy luồng emit open bởi chính trigger (tránh lỗi nhiều trigger cho một popover)
                operators.filter(function (v) { return !_this.popover.trigger || _this.popover.trigger == _this; }));
                var mergedMouseState$ = rxjs.merge(popoverMouseState$, hostMouseState$);
                mergedMouseState$
                    .pipe(operators.debounceTime(100), operators.distinctUntilChanged(), operators.filter(function () { return _this.platform.isBrowser; }), operators.takeUntil(__classPrivateFieldGet(this, _destroy$)))
                    .subscribe(function (visible) {
                    if (visible && !_this.disabled) {
                        _this.openPopover();
                    }
                    else {
                        _this.closePopover();
                    }
                });
            }
        };
        PopoverTriggerDirective.prototype.ngOnDestroy = function () {
            __classPrivateFieldGet(this, _destroy$).next();
            __classPrivateFieldGet(this, _destroy$).complete();
            if (__classPrivateFieldGet(this, _overlayRef)) {
                __classPrivateFieldGet(this, _overlayRef).dispose();
                __classPrivateFieldSet(this, _overlayRef, null);
            }
        };
        return PopoverTriggerDirective;
    }());
    _overlayRef = new WeakMap(), _popoverClose$ = new WeakMap(), _portal = new WeakMap(), _destroy$ = new WeakMap(), _popover = new WeakMap(), _setIsPopoverOpen = new WeakMap(), _getPortal = new WeakMap(), _createOverlay = new WeakMap(), _setPosition = new WeakMap(), _getOverlayConfig = new WeakMap(), _subscribeToPositions = new WeakMap(), _destroyPopover = new WeakMap();
    PopoverTriggerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: "[sdPopoverTriggerFor]",
                    host: {
                        "aria-haspopup": "true",
                        class: "sd-popover-trigger",
                    },
                    exportAs: "sdPopoverTrigger",
                },] }
    ];
    PopoverTriggerDirective.ctorParameters = function () { return [
        { type: overlay.Overlay },
        { type: core.ElementRef },
        { type: core.NgZone },
        { type: core.ViewContainerRef },
        { type: core.ElementRef },
        { type: platform.Platform },
        { type: bidi.Directionality, decorators: [{ type: core.Optional }] }
    ]; };
    PopoverTriggerDirective.propDecorators = {
        popover: [{ type: core.Input, args: ["sdPopoverTriggerFor",] }],
        popoverData: [{ type: core.Input, args: ["sdPopoverData",] }],
        disabled: [{ type: core.Input, args: ["sdPopoverDisabled",] }],
        popoverOpened: [{ type: core.Output }],
        popoverClosed: [{ type: core.Output }]
    };

    var SdPopoverModule = /** @class */ (function () {
        function SdPopoverModule() {
        }
        return SdPopoverModule;
    }());
    SdPopoverModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        PopoverComponent,
                        PopoverTriggerDirective,
                        PopoverContentDirective
                    ],
                    imports: [
                        common.CommonModule,
                        a11y.A11yModule
                    ],
                    exports: [
                        PopoverComponent,
                        PopoverTriggerDirective,
                        PopoverContentDirective
                    ]
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.PopoverComponent = PopoverComponent;
    exports.PopoverContentDirective = PopoverContentDirective;
    exports.PopoverTriggerDirective = PopoverTriggerDirective;
    exports.SdPopoverModule = SdPopoverModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-popover.umd.js.map
