(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/quick-action', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core['quick-action'] = {}), global.ng.core, global.ng.common));
}(this, (function (exports, core, common) { 'use strict';

    var SdQuickAction = /** @class */ (function () {
        function SdQuickAction() {
            var _this = this;
            this.isOpened = false;
            this.open = function () {
                _this.isOpened = true;
            };
            this.close = function () {
                _this.isOpened = false;
            };
        }
        return SdQuickAction;
    }());
    SdQuickAction.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-quick-action',
                    template: "<div class=\"c-quick-action media align-items-center\" [ngClass]=\"{'active': isOpened}\">\r\n  <div class=\"media-body mr-16 text-grey\">\r\n    <ng-content select=\"[sdMessage]\"></ng-content>\r\n  </div>\r\n  <ng-content select=\"[sdAction]\"></ng-content>\r\n</div>",
                    styles: [".c-quick-action{background-color:#fff;border-radius:4px;bottom:90px;box-shadow:0 .4px .8px rgba(0,0,0,.1),0 3px 6px rgba(0,0,0,.2);left:0;margin:auto;min-width:400px;opacity:0;pointer-events:none;position:fixed;right:0;transform:translate3d(0,100%,0);transition:all .2s ease-in-out;visibility:hidden;width:-webkit-max-content;width:-moz-max-content;width:max-content;z-index:99}.c-quick-action.active{opacity:1;pointer-events:all;transform:translateZ(0);visibility:visible}"]
                },] }
    ];
    SdQuickAction.ctorParameters = function () { return []; };
    SdQuickAction.propDecorators = {
        isOpened: [{ type: core.Input }]
    };

    var SdQuickActionModule = /** @class */ (function () {
        function SdQuickActionModule() {
        }
        return SdQuickActionModule;
    }());
    SdQuickActionModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        SdQuickAction
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        SdQuickAction
                    ],
                    providers: [],
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdQuickAction = SdQuickAction;
    exports.SdQuickActionModule = SdQuickActionModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-quick-action.umd.js.map
