(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/material/icon'), require('@angular/material/tooltip'), require('@angular/material/progress-spinner'), require('@sd-angular/core/common'), require('object-hash'), require('rxjs'), require('rxjs/operators'), require('uuid'), require('@angular/material/select'), require('@sd-angular/core/translate'), require('@angular/material/checkbox'), require('@sd-angular/core/popover')) :
    typeof define === 'function' && define.amd ? define('@sd-angular/core/select', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@angular/material/form-field', '@angular/material/input', '@angular/material/icon', '@angular/material/tooltip', '@angular/material/progress-spinner', '@sd-angular/core/common', 'object-hash', 'rxjs', 'rxjs/operators', 'uuid', '@angular/material/select', '@sd-angular/core/translate', '@angular/material/checkbox', '@sd-angular/core/popover'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['sd-angular'] = global['sd-angular'] || {}, global['sd-angular'].core = global['sd-angular'].core || {}, global['sd-angular'].core.select = {}), global.ng.core, global.ng.common, global.ng.forms, global.ng.material.formField, global.ng.material.input, global.ng.material.icon, global.ng.material.tooltip, global.ng.material.progressSpinner, global['sd-angular'].core.common, global.hash, global.rxjs, global.rxjs.operators, global.uuid, global.ng.material.select, global['sd-angular'].core.translate, global.ng.material.checkbox, global['sd-angular'].core.popover));
}(this, (function (exports, core, common$1, forms, formField, input, icon, tooltip, progressSpinner, common, hash, rxjs, operators, uuid, select, translate, checkbox, popover) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var hash__default = /*#__PURE__*/_interopDefaultLegacy(hash);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var SdSelectDisplayDefDirective = /** @class */ (function () {
        function SdSelectDisplayDefDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return SdSelectDisplayDefDirective;
    }());
    SdSelectDisplayDefDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[sdSelectDisplayDef]'
                },] }
    ];
    SdSelectDisplayDefDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var _input, _name, _form, _itemsChanges, _delay, _validator, _subscription, _allItems, _allItem, _cache, _updateValidator, _loadSelectedItems, _loadItems, _onChange, _customValidator, _hashedValue, _getCopyText;
    var SdSelect = /** @class */ (function () {
        function SdSelect(ref, formConfig) {
            var _this = this;
            this.ref = ref;
            this.formConfig = formConfig;
            _input.set(this, void 0);
            _name.set(this, uuid.v4());
            this.disableErrorMessage = false;
            this.formControl = new common.SdFormControl();
            this.searchTerm$ = new rxjs.Subject();
            _form.set(this, void 0);
            // Items
            _itemsChanges.set(this, new rxjs.BehaviorSubject([]));
            // Server search
            this.loading = false;
            _delay.set(this, 200); // Sau khoảng thời gian delay nếu không có thay đổi thì thì mới bắt đầu thực hiện gọi hàm
            // Validator
            this.isRequired = false;
            _validator.set(this, void 0);
            this.multiple = false;
            this.limit = 100;
            this.filtered = false;
            this.selectAll = false;
            this.copyable = false;
            this.copied = false;
            this.modelChange = new core.EventEmitter();
            this.sdChange = new core.EventEmitter();
            this.sdSelection = new core.EventEmitter();
            _subscription.set(this, new rxjs.Subscription());
            _allItems.set(this, void 0);
            _allItem.set(this, {});
            this.allSelected = false;
            _cache.set(this, {});
            this.isFocused = false;
            _updateValidator.set(this, function () {
                _this.formControl.clearValidators();
                _this.formControl.clearAsyncValidators();
                var validators = [];
                var asyncValidators = [];
                if (_this.isRequired) {
                    validators.push(forms.Validators.required);
                }
                if (__classPrivateFieldGet(_this, _validator)) {
                    asyncValidators.push(__classPrivateFieldGet(_this, _customValidator).call(_this, __classPrivateFieldGet(_this, _validator)));
                }
                if (_this.inlineError) {
                    validators.push(_this.customInlineErrorValidator());
                }
                _this.formControl.setValidators(validators);
                _this.formControl.setAsyncValidators(asyncValidators);
                _this.formControl.updateValueAndValidity();
            });
            _loadSelectedItems.set(this, function (value, items) { return __awaiter(_this, void 0, void 0, function () {
                var values, results, objItem, objValue;
                var _this = this;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            if (!(value === null || value === void 0 ? void 0 : value.toString())) {
                                return [2 /*return*/, []];
                            }
                            values = Array.isArray(value) ? value : [value];
                            if (!this.valueField && !this.displayField) {
                                return [2 /*return*/, values];
                            }
                            this.loading = true;
                            if (!values.some(function (val) { return __classPrivateFieldGet(_this, _allItem)[val] === undefined; })) return [3 /*break*/, 2];
                            return [4 /*yield*/, items(value, true)
                                    .catch(function () { return []; })
                                    .finally(function () { return (_this.loading = false); })];
                        case 1:
                            results = _c.sent();
                            objItem = Array.toObject(results, this.valueField);
                            objValue = Array.toObject(values.map(function (val) {
                                var _c, _d;
                                return (_c = {}, _c[val === null || val === void 0 ? void 0 : val.toString()] = (_d = {}, _d[_this.valueField] = val, _d[_this.displayField] = val, _d), _c);
                            }), this.valueField);
                            __classPrivateFieldSet(this, _allItem, Object.assign(Object.assign(Object.assign({}, objValue), __classPrivateFieldGet(this, _allItem)), objItem));
                            _c.label = 2;
                        case 2: return [2 /*return*/, values.map(function (val) {
                                var _c;
                                var _a;
                                return (_a = __classPrivateFieldGet(_this, _allItem)[val === null || val === void 0 ? void 0 : val.toString()]) !== null && _a !== void 0 ? _a : (_c = {}, _c[_this.valueField] = val, _c[_this.displayField] = val, _c);
                            })];
                    }
                });
            }); });
            _loadItems.set(this, function (searchText, items) { return __awaiter(_this, void 0, void 0, function () {
                var key, results, objItem, selectedItems;
                var _this = this;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            searchText = (searchText === null || searchText === void 0 ? void 0 : searchText.toString()) || '';
                            key = hash__default['default']({
                                checksum: this.cacheChecksum || null,
                                searchText: searchText,
                            });
                            if (!(__classPrivateFieldGet(this, _cache)[key] === undefined && this.isFocused)) return [3 /*break*/, 2];
                            this.loading = true;
                            return [4 /*yield*/, items(searchText)
                                    .catch(function () { return []; })
                                    .finally(function () { return (_this.loading = false); })];
                        case 1:
                            results = _c.sent();
                            objItem = Array.toObject(results, this.valueField);
                            __classPrivateFieldSet(this, _allItem, Object.assign(Object.assign({}, __classPrivateFieldGet(this, _allItem)), objItem));
                            __classPrivateFieldGet(this, _cache)[key] = results.union(this.valueField);
                            _c.label = 2;
                        case 2: return [4 /*yield*/, __classPrivateFieldGet(this, _loadSelectedItems).call(this, this.formControl.value, items)];
                        case 3:
                            selectedItems = _c.sent();
                            // Đưa những selectedItems lên đầu nếu không mat-select-trigger sẽ không work
                            return [2 /*return*/, __spread(selectedItems, (__classPrivateFieldGet(this, _cache)[key] || [])).union(this.valueField)];
                    }
                });
            }); });
            this.onSelectionChange = function (change) {
                var _a;
                _this.allSelected = !_this.select.options.some(function (e) { return !e.selected; });
                var value = (_a = change === null || change === void 0 ? void 0 : change.value) !== null && _a !== void 0 ? _a : '';
                if (_this.multiple) {
                    _this.formControl.setValue(value || []);
                    __classPrivateFieldGet(_this, _onChange).call(_this, value || []);
                }
                else {
                    _this.searchTerm$.next('');
                    _this.formControl.setValue(value);
                    __classPrivateFieldGet(_this, _onChange).call(_this, value);
                }
            };
            this.reValidate = function () {
                _this.formControl.updateValueAndValidity({ emitEvent: true });
            };
            _onChange.set(this, function (value) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_c) {
                    if (Array.isArray(value)) {
                        this.modelChange.emit(value);
                        // this.sdChange.emit(value);
                        // this.sdSelection.emit({
                        //   value: value,
                        //   items: value.map(val => this.#allItem[val?.toString()]),
                        // });
                    }
                    else {
                        this.modelChange.emit(value);
                        // this.sdChange.emit(value);
                        this.sdSelection.emit({
                            value: value,
                            item: __classPrivateFieldGet(this, _allItem)[value === null || value === void 0 ? void 0 : value.toString()],
                        });
                    }
                    return [2 /*return*/];
                });
            }); });
            this.clear = function ($event) {
                $event === null || $event === void 0 ? void 0 : $event.stopPropagation();
                if (_this.multiple) {
                    _this.formControl.setValue([]);
                    _this.modelChange.emit([]);
                    _this.sdChange.emit([]);
                    _this.sdSelection.emit({
                        value: [],
                        items: [],
                    });
                }
                else {
                    _this.formControl.setValue(null);
                    _this.modelChange.emit(null);
                    _this.sdChange.emit(null);
                    _this.sdSelection.emit({
                        value: null,
                        item: null,
                    });
                }
            };
            this.onClick = function () {
                var _a;
                if ((_a = _this.sdView) === null || _a === void 0 ? void 0 : _a.templateRef) {
                    if (!_this.formControl.disabled && !_this.isFocused) {
                        _this.focus();
                    }
                }
            };
            this.focus = function () {
                _this.isFocused = true;
                setTimeout(function () {
                    var _a, _b;
                    (_a = _this.select) === null || _a === void 0 ? void 0 : _a.focus();
                    (_b = _this.select) === null || _b === void 0 ? void 0 : _b.open();
                }, 100);
            };
            _customValidator.set(this, function (func) {
                return function (c) { return __awaiter(_this, void 0, void 0, function () {
                    var value, result, message;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                value = c.value || null;
                                if (!(func && typeof func === 'function')) return [3 /*break*/, 3];
                                result = func(value);
                                if (!(result instanceof Promise)) return [3 /*break*/, 2];
                                return [4 /*yield*/, result];
                            case 1:
                                message = _c.sent();
                                if (message) {
                                    return [2 /*return*/, {
                                            customValidator: message,
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 2:
                                if (result) {
                                    return [2 /*return*/, {
                                            customValidator: result,
                                        }];
                                }
                                return [2 /*return*/, null];
                            case 3: return [2 /*return*/, null];
                        }
                    });
                }); };
            });
            _hashedValue.set(this, void 0);
            this.onOpenedChange = function (isOpened) {
                var _a, _b;
                if (isOpened) {
                    _this.isFocused = true;
                    if (__classPrivateFieldGet(_this, _input)) {
                        __classPrivateFieldGet(_this, _input).value = null;
                    }
                    __classPrivateFieldSet(_this, _hashedValue, hash__default['default']({
                        value: _this.formControl.value,
                    }));
                    _this.searchTerm$.next('');
                }
                else {
                    _this.isFocused = false;
                    var hashedValue = hash__default['default']({
                        value: _this.formControl.value,
                    });
                    // Khi panel close, bắn event sdChange, sdSelection nếu có thay đổi giá trị
                    if (__classPrivateFieldGet(_this, _hashedValue) !== hashedValue) {
                        _this.sdChange.emit(_this.formControl.value);
                        if (_this.multiple) {
                            _this.sdSelection.emit({
                                value: _this.formControl.value,
                                items: ((_a = _this.formControl.value) === null || _a === void 0 ? void 0 : _a.map(function (val) { return __classPrivateFieldGet(_this, _allItem)[val === null || val === void 0 ? void 0 : val.toString()]; })) || [],
                            });
                        }
                        else {
                            _this.sdSelection.emit({
                                value: _this.formControl.value,
                                item: __classPrivateFieldGet(_this, _allItem)[(_b = _this.formControl.value) === null || _b === void 0 ? void 0 : _b.toString()],
                            });
                        }
                    }
                    __classPrivateFieldSet(_this, _hashedValue, undefined);
                }
            };
            this.onOptionChange = function (tooltip) {
                tooltip === null || tooltip === void 0 ? void 0 : tooltip.hide();
            };
            this.trackByKey = function (index, item) {
                if (_this.valueField) {
                    return item === null || item === void 0 ? void 0 : item[_this.valueField];
                }
                return item;
            };
            this.onCopyText = function (event) {
                event === null || event === void 0 ? void 0 : event.stopPropagation();
                var text = __classPrivateFieldGet(_this, _getCopyText).call(_this);
                SdUtility.copyToClipboard(text);
                _this.copied = true;
                setTimeout(function () {
                    _this.copied = false;
                    _this.ref.markForCheck();
                }, 2000);
            };
            _getCopyText.set(this, function () {
                var _a;
                var value = _this.formControl.value;
                var text = (_a = value === null || value === void 0 ? void 0 : value.toString()) !== null && _a !== void 0 ? _a : '';
                if (typeof _this.copyText === 'function') {
                    if (Array.isArray(value)) {
                        text = _this.copyText(value, value.map(function (val) { return __classPrivateFieldGet(_this, _allItem)[val === null || val === void 0 ? void 0 : val.toString()]; }));
                    }
                    else {
                        text = _this.copyText(value, __classPrivateFieldGet(_this, _allItem)[value === null || value === void 0 ? void 0 : value.toString()]);
                    }
                }
                else if (_this.copyText) {
                    text = _this.copyText;
                }
                return text;
            });
        }
        Object.defineProperty(SdSelect.prototype, "input", {
            set: function (input) {
                if (__classPrivateFieldGet(this, _input) !== input) {
                    __classPrivateFieldSet(this, _input, input);
                    __classPrivateFieldGet(this, _input).value = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "name", {
            set: function (val) {
                if (val) {
                    __classPrivateFieldSet(this, _name, val);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "_disableErrorMessage", {
            set: function (val) {
                this.disableErrorMessage = val === '' || val;
                val = val === '' || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "form", {
            set: function (val) {
                if (val) {
                    if (val instanceof forms.NgForm) {
                        __classPrivateFieldSet(this, _form, val.form);
                    }
                    else {
                        __classPrivateFieldSet(this, _form, val);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "_label", {
            set: function (val) {
                this.label = val;
                this.qcId = hash__default['default']({
                    selector: 'sd-select',
                    label: val,
                });
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "model", {
            set: function (value) {
                // if (this.formControl.value !== value) {
                //   this.formControl.setValue(value);
                // }
                // if(this.formControl.disabled) {
                //   this.formControl.enable({
                //     emitEvent: false
                //   });
                //   this.formControl.setValue(value);
                //   this.formControl.disable({
                //     emitEvent: false
                //   });
                // } else {
                //   this.formControl.setValue(value);
                // }
                // this.formControl.setValue(value);
                if (this.formControl.value !== value) {
                    this.formControl.setValue(value);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "items", {
            set: function (items) {
                __classPrivateFieldSet(this, _delay, 0);
                if (!items) {
                    __classPrivateFieldGet(this, _itemsChanges).next([]);
                }
                else if (Array.isArray(items)) {
                    __classPrivateFieldGet(this, _itemsChanges).next(items.filter(function (e) { return e !== null && e !== undefined; }));
                }
                else {
                    __classPrivateFieldSet(this, _delay, 500);
                    __classPrivateFieldGet(this, _itemsChanges).next(items);
                }
                this.searchTerm$.next('');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "required", {
            set: function (val) {
                this.isRequired = val === '' || val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "validator", {
            set: function (validator) {
                __classPrivateFieldSet(this, _validator, validator);
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "_inlineError", {
            set: function (val) {
                this.inlineError = val;
                __classPrivateFieldGet(this, _updateValidator).call(this);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "disabled", {
            // Optional
            set: function (val) {
                val = val === '' || val;
                if (val) {
                    this.formControl.disable();
                }
                else {
                    this.formControl.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "_multiple", {
            set: function (val) {
                this.multiple = val === '' || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "_filtered", {
            set: function (val) {
                this.filtered = val === '' || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "_selectAll", {
            set: function (val) {
                this.selectAll = val === '' || val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SdSelect.prototype, "_copyable", {
            set: function (val) {
                this.copyable = val === '' || val;
            },
            enumerable: false,
            configurable: true
        });
        SdSelect.prototype.ngOnInit = function () {
            var _this = this;
            var _a;
            this.appearance = this.appearance || ((_a = this.formConfig) === null || _a === void 0 ? void 0 : _a.appearance);
            __classPrivateFieldGet(this, _subscription).add(this.formControl.sdChanges.subscribe(function () {
                _this.ref.markForCheck();
            }));
            __classPrivateFieldSet(this, _allItems, rxjs.combineLatest([
                __classPrivateFieldGet(this, _itemsChanges).asObservable(),
                this.searchTerm$.asObservable().pipe(operators.startWith(''), operators.debounceTime(__classPrivateFieldGet(this, _delay))),
                this.formControl.valueChanges.pipe(operators.startWith(this.formControl.value)),
            ]).pipe(operators.switchMap(function (_c) {
                var _d = __read(_c, 3), items = _d[0], val = _d[1], formValue = _d[2];
                return __awaiter(_this, void 0, void 0, function () {
                    var isArray, hasFields, filteredItems;
                    var _this = this;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                formValue = this.formControl.value;
                                if (!(typeof items === 'function')) return [3 /*break*/, 2];
                                return [4 /*yield*/, __classPrivateFieldGet(this, _loadItems).call(this, val, items)];
                            case 1: return [2 /*return*/, _c.sent()];
                            case 2:
                                __classPrivateFieldSet(this, _allItem, items.toObject(this.valueField));
                                isArray = Array.isArray(formValue);
                                hasFields = !!this.valueField && !!this.displayField;
                                filteredItems = items.filter(function (item) {
                                    var value = hasFields ? item[_this.valueField] : item;
                                    var display = hasFields ? item[_this.displayField] : item;
                                    if (String.aliasIncludes(value, val) || String.aliasIncludes(display, val)) {
                                        return true;
                                    }
                                    if (isArray) {
                                        return formValue.some(function (e) { return e === value; });
                                    }
                                    return formValue === value;
                                });
                                if (items.length <= this.limit) {
                                    return [2 /*return*/, filteredItems];
                                }
                                // Đưa những selectedItems lên đầu nếu không mat-select-trigger sẽ không work
                                return [2 /*return*/, filteredItems.sort(function (current, next) {
                                        var value1 = hasFields ? current[_this.valueField] : current;
                                        var value2 = hasFields ? next[_this.valueField] : next;
                                        var flag1 = 0;
                                        var flag2 = 0;
                                        if (isArray) {
                                            flag1 = formValue.some(function (e) { return e === value1; }) ? 1 : 0;
                                            flag2 = formValue.some(function (e) { return e === value2; }) ? 1 : 0;
                                            return flag2 - flag1;
                                        }
                                        flag1 = formValue === value1 ? 1 : 0;
                                        flag2 = formValue === value2 ? 1 : 0;
                                        return flag2 - flag1;
                                    })];
                        }
                    });
                });
            })));
            this.selectedItems = rxjs.combineLatest([
                __classPrivateFieldGet(this, _itemsChanges).asObservable(),
                this.formControl.valueChanges.pipe(operators.startWith(this.formControl.value)),
            ]).pipe(operators.switchMap(function (_c) {
                var _d = __read(_c, 2), items = _d[0], val = _d[1];
                return __awaiter(_this, void 0, void 0, function () {
                    var values;
                    var _this = this;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                // Vì một số lý do chưa xác định mà khi sử dụng sdViewDef thì khi chuyển sang dạng view sẽ trigger val = null
                                // Nhưng formControl.value vẫn có giá trị đúng nên thực hiện gán val = this.formControl.value;
                                val = this.formControl.value;
                                if (!(val === null || val === void 0 ? void 0 : val.toString())) {
                                    return [2 /*return*/, []];
                                }
                                values = Array.isArray(val) ? val : [val];
                                if (!this.valueField) {
                                    return [2 /*return*/, values];
                                }
                                if (!(typeof items === 'function')) return [3 /*break*/, 2];
                                return [4 /*yield*/, __classPrivateFieldGet(this, _loadSelectedItems).call(this, val, items)];
                            case 1: return [2 /*return*/, _c.sent()];
                            case 2: return [2 /*return*/, values.map(function (value) {
                                    var _c;
                                    return ((items === null || items === void 0 ? void 0 : items.find(function (item) { return item[_this.valueField] === value; })) || (_c = {},
                                        _c[_this.valueField] = value,
                                        _c[_this.displayField] = value,
                                        _c));
                                })];
                        }
                    });
                });
            }));
            this.filteredItems = __classPrivateFieldGet(this, _allItems).pipe(operators.map(function (allItems) { return allItems.paging(_this.limit); }));
            this.display = this.selectedItems.pipe(operators.map(function (selectedItems) { var _a; return (_a = selectedItems === null || selectedItems === void 0 ? void 0 : selectedItems.map(function (item) { return (_this.displayField ? item[_this.displayField] : item); })) === null || _a === void 0 ? void 0 : _a.join(', '); }));
            // Lấy dữ liệu cho tooltip
            __classPrivateFieldGet(this, _subscription).add(this.selectedItems.subscribe(function (selectedItems) {
                var _a;
                return (_this.tooltip = (_a = selectedItems === null || selectedItems === void 0 ? void 0 : selectedItems.map(function (item) { return (_this.valueField ? "\u2022 " + item[_this.valueField] + " - " + item[_this.displayField] : "\u2022 " + item); })) === null || _a === void 0 ? void 0 : _a.join('\n'));
            }));
        };
        SdSelect.prototype.ngAfterViewInit = function () {
            var _a;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.addControl(__classPrivateFieldGet(this, _name), this.formControl);
        };
        SdSelect.prototype.ngOnDestroy = function () {
            var _a;
            (_a = __classPrivateFieldGet(this, _form)) === null || _a === void 0 ? void 0 : _a.removeControl(__classPrivateFieldGet(this, _name));
            __classPrivateFieldGet(this, _subscription).unsubscribe();
        };
        // Hàm tạo Validators tùy chỉnh cho inlineError
        SdSelect.prototype.customInlineErrorValidator = function () {
            return function (control) {
                return { inlineError: true };
            };
        };
        SdSelect.prototype.onSelectAll = function () {
            if (this.allSelected) {
                this.formControl.setValue(this.select.options.map(function (e) { return e.value; }));
            }
            else {
                this.formControl.setValue([]);
            }
            __classPrivateFieldGet(this, _onChange).call(this, this.formControl.value);
        };
        return SdSelect;
    }());
    _input = new WeakMap(), _name = new WeakMap(), _form = new WeakMap(), _itemsChanges = new WeakMap(), _delay = new WeakMap(), _validator = new WeakMap(), _subscription = new WeakMap(), _allItems = new WeakMap(), _allItem = new WeakMap(), _cache = new WeakMap(), _updateValidator = new WeakMap(), _loadSelectedItems = new WeakMap(), _loadItems = new WeakMap(), _onChange = new WeakMap(), _customValidator = new WeakMap(), _hashedValue = new WeakMap(), _getCopyText = new WeakMap();
    SdSelect.decorators = [
        { type: core.Component, args: [{
                    selector: 'sd-select',
                    template: "<ng-container *ngIf=\"!appearance && sdLabelDef?.templateRef\">\r\n  <ng-container *ngTemplateOutlet=\"sdLabelDef.templateRef\"> </ng-container>\r\n</ng-container>\r\n<label *ngIf=\"!appearance && label && !sdLabelDef?.templateRef\" class=\"d-block mb-0 T14M\"\r\n  >{{ label }} <span class=\"text-danger mb-2\" *ngIf=\"isRequired\">*</span></label\r\n>\r\n<div\r\n  class=\"d-flex align-items-center\"\r\n  [class.sd-view]=\"sdView?.templateRef\"\r\n  [class.c-focused]=\"isFocused\"\r\n  [class.c-disabled]=\"formControl.disabled\"\r\n  (click)=\"onClick()\">\r\n  <ng-container *ngIf=\"sdView?.templateRef && !isFocused; else default\">\r\n    <ng-container *ngTemplateOutlet=\"sdView.templateRef; context: { value: formControl.value, selectedItems: selectedItems | async }\">\r\n    </ng-container>\r\n  </ng-container>\r\n  <ng-template #default>\r\n    <mat-form-field\r\n      class=\"sd-md\"\r\n      [ngClass]=\"{ 'sd-sm': size === 'sm', 'no-padding-wrapper': disableErrorMessage }\"\r\n      [appearance]=\"appearance || 'outline'\">\r\n      <mat-label *ngIf=\"appearance && label\">{{ label }}</mat-label>\r\n      <mat-select\r\n        *ngIf=\"multiple\"\r\n        #select\r\n        [formControl]=\"formControl\"\r\n        [placeholder]=\"placeholder || (appearance ? label : '')\"\r\n        multiple\r\n        (selectionChange)=\"onSelectionChange($event)\"\r\n        disableOptionCentering=\"true\"\r\n        panelClass=\"sd-select-panel\"\r\n        [class.sd-selected]=\"!isRequired && formControl?.value?.length\"\r\n        [required]=\"isRequired\"\r\n        (openedChange)=\"onOpenedChange($event)\"\r\n        [attr.data-qclabel]=\"label\"\r\n        [attr.data-qcid]=\"qcId\"\r\n        matTooltipClass=\"sd-multiline-tooltip\"\r\n        [matTooltipDisabled]=\"!formControl.disabled || !formControl?.value?.length\"\r\n        [matTooltip]=\"tooltip\">\r\n        <mat-select-trigger>\r\n          {{ display | async }}\r\n        </mat-select-trigger>\r\n        <mat-option *ngIf=\"filtered\" class=\"sd-filtered-input\" (keyup.Space)=\"$event.stopPropagation()\" disabled=\"true\">\r\n          <mat-form-field class=\"sd-md\" appearance=\"outline\">\r\n            <mat-icon matPrefix>search</mat-icon>\r\n            <input\r\n              aria-hidden=\"true\"\r\n              #input\r\n              placeholder=\"{{ 'Search' | sdTranslate }}\"\r\n              matInput\r\n              autocomplete=\"off\"\r\n              (keydown)=\"$event.stopPropagation()\"\r\n              (keyup)=\"searchTerm$.next($event.target.value)\" />\r\n          </mat-form-field>\r\n        </mat-option>\r\n        <ng-container *ngIf=\"multiple && selectAll\">\r\n          <mat-checkbox class=\"mat-option\" [(ngModel)]=\"allSelected\" [ngModelOptions]=\"{ standalone: true }\" (change)=\"onSelectAll()\">\r\n            T\u1EA5t c\u1EA3</mat-checkbox\r\n          >\r\n        </ng-container>\r\n        <ng-container *ngIf=\"valueField && displayField\">\r\n          <mat-option *ngFor=\"let item of filteredItems | async; trackBy: trackByKey\" [value]=\"item[valueField]\">\r\n            <div matTooltipPosition=\"above\" [matTooltip]=\"item[displayField]\">\r\n              <ng-container *ngIf=\"selectDisplayDef?.templateRef\">\r\n                <ng-container *ngTemplateOutlet=\"selectDisplayDef.templateRef; context: { item: item }\"> </ng-container>\r\n              </ng-container>\r\n              <ng-container *ngIf=\"!selectDisplayDef?.templateRef\">\r\n                {{ item[displayField] }}\r\n              </ng-container>\r\n            </div>\r\n          </mat-option>\r\n        </ng-container>\r\n        <ng-container *ngIf=\"!valueField && !displayField\">\r\n          <mat-option *ngFor=\"let item of filteredItems | async; trackBy: trackByKey\" [value]=\"item\">\r\n            <div matTooltipPosition=\"above\" [matTooltip]=\"item\">\r\n              <ng-container *ngIf=\"selectDisplayDef?.templateRef\">\r\n                <ng-container *ngTemplateOutlet=\"selectDisplayDef.templateRef; context: { item: item }\"> </ng-container>\r\n              </ng-container>\r\n              <ng-container *ngIf=\"!selectDisplayDef?.templateRef\">\r\n                {{ item }}\r\n              </ng-container>\r\n            </div>\r\n          </mat-option>\r\n        </ng-container>\r\n      </mat-select>\r\n      <mat-select\r\n        *ngIf=\"!multiple\"\r\n        #select\r\n        [formControl]=\"formControl\"\r\n        [placeholder]=\"placeholder || (appearance ? label : '')\"\r\n        (selectionChange)=\"onSelectionChange($event)\"\r\n        disableOptionCentering=\"true\"\r\n        panelClass=\"sd-select-panel\"\r\n        [class.sd-selected]=\"!isRequired && formControl?.value != null\"\r\n        [required]=\"isRequired\"\r\n        (openedChange)=\"onOpenedChange($event)\"\r\n        [attr.data-qclabel]=\"label\"\r\n        [attr.data-qcid]=\"qcId\">\r\n        <mat-select-trigger>\r\n          {{ display | async }}\r\n        </mat-select-trigger>\r\n        <mat-option *ngIf=\"filtered\" class=\"sd-filtered-input\" (keyup.Space)=\"$event.stopPropagation()\" disabled=\"true\">\r\n          <mat-form-field class=\"sd-md\" appearance=\"outline\">\r\n            <mat-icon matPrefix>search</mat-icon>\r\n            <input\r\n              aria-hidden=\"true\"\r\n              #input\r\n              placeholder=\"{{ 'Search' | sdTranslate }}\"\r\n              matInput\r\n              autocomplete=\"off\"\r\n              (keydown)=\"$event.stopPropagation()\"\r\n              (keyup)=\"searchTerm$.next($event.target.value)\" />\r\n          </mat-form-field>\r\n        </mat-option>\r\n        <ng-container *ngIf=\"valueField && displayField\">\r\n          <mat-option *ngFor=\"let item of filteredItems | async; trackBy: trackByKey\" [value]=\"item[valueField]\">\r\n            <div matTooltipPosition=\"above\" [matTooltip]=\"item[displayField]\">\r\n              <ng-container *ngIf=\"selectDisplayDef?.templateRef\">\r\n                <ng-container *ngTemplateOutlet=\"selectDisplayDef.templateRef; context: { item: item }\"> </ng-container>\r\n              </ng-container>\r\n              <ng-container *ngIf=\"!selectDisplayDef?.templateRef\">\r\n                {{ item[displayField] }}\r\n              </ng-container>\r\n            </div>\r\n          </mat-option>\r\n        </ng-container>\r\n        <ng-container *ngIf=\"!valueField && !displayField\">\r\n          <mat-option *ngFor=\"let item of filteredItems | async; trackBy: trackByKey\" [value]=\"item\">\r\n            <div matTooltipPosition=\"above\" [matTooltip]=\"item\">\r\n              <ng-container *ngIf=\"selectDisplayDef?.templateRef\">\r\n                <ng-container *ngTemplateOutlet=\"selectDisplayDef.templateRef; context: { item: item }\"> </ng-container>\r\n              </ng-container>\r\n              <ng-container *ngIf=\"!selectDisplayDef?.templateRef\">\r\n                {{ item }}\r\n              </ng-container>\r\n            </div>\r\n          </mat-option>\r\n        </ng-container>\r\n      </mat-select>\r\n      <ng-content select=\"[sdSuffixIcon]\" matSuffix></ng-content>\r\n      <svg\r\n        #copyTooltip=\"matTooltip\"\r\n        *ngIf=\"(multiple ? formControl?.value?.length : formControl?.value != null) && copyable\"\r\n        matSuffix\r\n        [matTooltip]=\"copied ? 'Copied' : 'Copy'\"\r\n        class=\"icon-copy\"\r\n        focusable=\"false\"\r\n        xmlns=\"http://www.w3.org/2000/svg\"\r\n        viewBox=\"0 0 448 512\"\r\n        (click)=\"onCopyText($event)\">\r\n        <path\r\n          d=\"M433.941 65.941l-51.882-51.882A48 48 0 0 0 348.118 0H176c-26.51 0-48 21.49-48 48v48H48c-26.51 0-48 21.49-48 48v320c0 26.51 21.49 48 48 48h224c26.51 0 48-21.49 48-48v-48h80c26.51 0 48-21.49 48-48V99.882a48 48 0 0 0-14.059-33.941zM266 464H54a6 6 0 0 1-6-6V150a6 6 0 0 1 6-6h74v224c0 26.51 21.49 48 48 48h96v42a6 6 0 0 1-6 6zm128-96H182a6 6 0 0 1-6-6V54a6 6 0 0 1 6-6h106v88c0 13.255 10.745 24 24 24h88v202a6 6 0 0 1-6 6zm6-256h-64V48h9.632c1.591 0 3.117.632 4.243 1.757l48.368 48.368a6 6 0 0 1 1.757 4.243V112z\"></path>\r\n      </svg>\r\n      \r\n      <mat-icon\r\n        *ngIf=\"(multiple ? formControl?.value?.length : formControl?.value != null) && !isRequired && !formControl.disabled\"\r\n        class=\"pointer sd-suffix-icon\"\r\n        (click)=\"clear($event)\"\r\n        matSuffix\r\n        >cancel\r\n      </mat-icon>\r\n      <mat-error *ngIf=\"formControl.errors?.required\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ 'This field is required' | sdTranslate }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl?.errors?.customValidator\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ formControl?.errors?.customValidator }}</ng-container>\r\n      </mat-error>\r\n      <mat-error *ngIf=\"formControl.errors?.inlineError\">\r\n        <ng-container *ngIf=\"!disableErrorMessage\">{{ inlineError }}</ng-container>\r\n      </mat-error>\r\n    </mat-form-field>\r\n  </ng-template>\r\n</div>\r\n<!-- <sd-popover #popoverValues=\"sdPopover\" width=\"auto\">\r\n  <ng-container *ngIf=\"formControl?.value?.length\">\r\n    <ng-container *sdLet=\"selectedItems | async as items\">\r\n      <div *ngFor=\"let item of items\">\r\n        <strong>{{ item[valueField] }}</strong> - {{ item[displayField] }}\r\n      </div>\r\n    </ng-container>\r\n  </ng-container>\r\n</sd-popover> -->\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host{display:block;padding-top:5px}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline .mat-select-arrow-wrapper{transform:none}:host ::ng-deep .sd-selected .mat-select-arrow{border:none}:host ::ng-deep .mat-form-field.no-padding-wrapper .mat-form-field-wrapper{padding-bottom:0}:host ::ng-deep .mat-form-field.mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{background:#f6f6f6;color:#e9e9e9}:host ::ng-deep .mat-form-field mat-select.mat-select-disabled .mat-select-value{color:#4d4d4d!important}:host ::ng-deep .mat-form-field .mat-placeholder-required{color:#f82c13}:host ::ng-deep .mat-form-field:hover .icon-copy{opacity:1}:host ::ng-deep .mat-form-field .icon-copy{cursor:pointer;fill:rgba(0,0,0,.5);height:.9em;opacity:0;transition:opacity .2s linear;width:.9em}.sd-view:not(.c-focused):not(.c-disabled):hover{background-color:#ebecf0}::ng-deep .sd-select-panel .mat-option.sd-filtered-input{background-color:#fff;position:-webkit-sticky;position:sticky;top:0;z-index:10}::ng-deep .sd-select-panel .mat-option.sd-filtered-input .mat-form-field.mat-form-field-appearance-outline{width:100%}::ng-deep .sd-select-panel .mat-option.sd-filtered-input mat-pseudo-checkbox{display:none}::ng-deep .mat-select-panel .mat-option.sd-filtered-input{height:auto}::ng-deep .sd-select-panel .mat-option.sd-filtered-input input{color:#000}::ng-deep .sd-select-panel .mat-option.sd-filtered-input .mat-form-field-prefix .mat-icon{margin-right:0}::ng-deep .sd-select-panel .mat-option.sd-filtered-input .mat-form-field.mat-form-field-appearance-outline .mat-form-field-wrapper{padding:10px 0}::ng-deep .sd-select-panel .mat-option.sd-filtered-input .mat-form-field.mat-form-field-appearance-outline .mat-form-field-wrapper .mat-form-field-outline{background-color:rgba(0,0,0,.04)}::ng-deep .sd-multiline-tooltip{white-space:pre-line}::ng-deep .mat-select-panel{overflow:auto!important}"]
                },] }
    ];
    SdSelect.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.FORM_CONFIG,] }, { type: core.Optional }] }
    ]; };
    SdSelect.propDecorators = {
        input: [{ type: core.ViewChild, args: [input.MatInput,] }],
        select: [{ type: core.ViewChild, args: ['select',] }],
        name: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        _disableErrorMessage: [{ type: core.Input, args: ['disableErrorMessage',] }],
        size: [{ type: core.Input }],
        form: [{ type: core.Input }],
        _label: [{ type: core.Input, args: ['label',] }],
        placeholder: [{ type: core.Input }],
        model: [{ type: core.Input }],
        items: [{ type: core.Input }],
        valueField: [{ type: core.Input }],
        displayField: [{ type: core.Input }],
        cacheChecksum: [{ type: core.Input }],
        required: [{ type: core.Input }],
        validator: [{ type: core.Input }],
        _inlineError: [{ type: core.Input, args: ['inlineError',] }],
        disabled: [{ type: core.Input }],
        _multiple: [{ type: core.Input, args: ['multiple',] }],
        limit: [{ type: core.Input }],
        _filtered: [{ type: core.Input, args: ['filtered',] }],
        selectDisplayDef: [{ type: core.ContentChild, args: [SdSelectDisplayDefDirective,] }],
        _selectAll: [{ type: core.Input, args: ['selectAll',] }],
        copyTooltip: [{ type: core.ViewChild, args: ['copyTooltip',] }],
        _copyable: [{ type: core.Input, args: ['copyable',] }],
        copyText: [{ type: core.Input }],
        modelChange: [{ type: core.Output }],
        sdChange: [{ type: core.Output }],
        sdSelection: [{ type: core.Output }],
        sdLabelDef: [{ type: core.ContentChild, args: [common.SdLabelDefDirective,] }],
        sdView: [{ type: core.ContentChild, args: [common.SdViewDefDirective,] }]
    };

    var SdSelectModule = /** @class */ (function () {
        function SdSelectModule() {
        }
        return SdSelectModule;
    }());
    SdSelectModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common$1.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        input.MatInputModule,
                        tooltip.MatTooltipModule,
                        formField.MatFormFieldModule,
                        icon.MatIconModule,
                        select.MatSelectModule,
                        progressSpinner.MatProgressSpinnerModule,
                        checkbox.MatCheckboxModule,
                        translate.SdTranslateModule,
                        common.SdCommonModule,
                        popover.SdPopoverModule
                    ],
                    declarations: [
                        SdSelect,
                        SdSelectDisplayDefDirective
                    ],
                    exports: [
                        SdSelect,
                        SdSelectDisplayDefDirective,
                        common.SdCommonModule
                    ],
                    providers: []
                },] }
    ];

    /*
     * Public API Surface of superdev-angular-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SdSelect = SdSelect;
    exports.SdSelectDisplayDefDirective = SdSelectDisplayDefDirective;
    exports.SdSelectModule = SdSelectModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sd-angular-core-select.umd.js.map
