import { OnInit, AfterViewInit, ElementRef, ChangeDetectorRef } from '@angular/core';
import * as Chart from 'chart.js';
import { SdChartOption, IChartConfiguration } from './chart.model';
export declare class SdChart implements OnInit, AfterViewInit {
    #private;
    private ref;
    private chartConfiguration;
    private initialized;
    private pChartOption;
    isLoading: boolean;
    set chartOption(chartOption: SdChartOption);
    chartRef: ElementRef;
    chartWrapperRef: ElementRef;
    chartAxisRef: ElementRef;
    chartAreaWrapperExtendRef: ElementRef;
    chart: Chart;
    visible: boolean;
    height: string;
    private ctx;
    constructor(ref: ChangeDetectorRef, chartConfiguration: IChartConfiguration);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private renderChart;
    private renderPieChart;
    private renderDoughnutChart;
    private renderBarChart;
    private renderHorizontalBarChart;
    private renderLineChart;
    private renderStackAreaChart;
    private renderBarLineChart;
    loadingStart: () => void;
    private get dynamicColor();
}
