export {};
interface SdUtilityContructor {
    upload: (option?: {
        extensions?: string[];
        maxSizeInMb?: number;
        validator?: (fileName: string) => string;
    }) => Promise<File | null>;
    download: (filePath: string, fileName?: string) => void;
    downloadBlob: (blob: Blob, fileName?: string) => void;
    changeAliasLowerCase: (alias: string) => string;
    copyToClipboard: (text: string) => void;
    allWithPaging: <T = any>(func: (pageSize: number, pageNumber: number) => Promise<{
        items: T[];
        total: number;
    }>, defaultPageSize?: number) => Promise<T[]>;
    isPrivateMode: () => Promise<boolean>;
}
declare global {
    var SdUtility: SdUtilityContructor;
}
