import { SdCommonModule } from '@sd-angular/core/common';
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { SdAutocompleteModule } from '@sd-angular/core/autocomplete';
import { SdBadgeModule } from '@sd-angular/core/badge';
import { SdButtonModule } from '@sd-angular/core/button';
import { SdCheckboxModule } from '@sd-angular/core/checkbox';
import { SdChipModule } from '@sd-angular/core/chip';
import { SdDateModule } from '@sd-angular/core/date';
import { SdDateFullModule } from '@sd-angular/core/date-full';
import { SdDateRangeModule } from '@sd-angular/core/date-range';
import { SdDateTimeModule } from '@sd-angular/core/date-time';
import { SdEditorModule } from '@sd-angular/core/editor';
import { SdInputModule } from '@sd-angular/core/input';
import { SdInputCurrencyModule } from '@sd-angular/core/input-currency';
import { SdInputNumberModule } from '@sd-angular/core/input-number';
import { SdLabelModule } from '@sd-angular/core/label';
import { SdModalModule } from '@sd-angular/core/modal';
import { SdModalResizableModule } from '@sd-angular/core/modal-resizable';
import { SdMonthModule } from '@sd-angular/core/month';
import { SdQuickActionModule } from '@sd-angular/core/quick-action';
import { SdRadioModule } from '@sd-angular/core/radio';
import { SdSelectModule } from '@sd-angular/core/select';
import { SdSelectEditorModule } from '@sd-angular/core/select-editor';
import { SdSideDrawerModule } from '@sd-angular/core/side-drawer';
import { SdSwitchModule } from '@sd-angular/core/switch';
import { SdTextareaModule } from '@sd-angular/core/textarea';
import { SdTimeModule } from '@sd-angular/core/time';
import { SdTimelineModule } from '@sd-angular/core/timeline';
import { SdUploadFileModule } from '@sd-angular/core/upload-file';
import { SdUtilityModule } from '@sd-angular/core/utility';

class SdFormModule {
}
SdFormModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    FormsModule,
                    ReactiveFormsModule,
                    SdCommonModule,
                    SdModalModule,
                    SdSideDrawerModule,
                    SdLabelModule,
                    SdUploadFileModule,
                    SdDateModule,
                    SdMonthModule,
                    SdDateFullModule,
                    SdDateRangeModule,
                    SdDateTimeModule,
                    SdTimeModule,
                    SdButtonModule,
                    SdAutocompleteModule,
                    SdInputModule,
                    SdInputCurrencyModule,
                    SdInputNumberModule,
                    SdSelectModule,
                    SdSelectEditorModule,
                    SdEditorModule,
                    SdSwitchModule,
                    SdRadioModule,
                    SdChipModule,
                    SdTextareaModule,
                    SdCheckboxModule,
                    SdUtilityModule,
                    SdQuickActionModule,
                    SdBadgeModule,
                    SdTimelineModule,
                    SdModalResizableModule
                ],
                declarations: [],
                providers: [],
                exports: [
                    FormsModule,
                    ReactiveFormsModule,
                    SdCommonModule,
                    SdModalModule,
                    SdSideDrawerModule,
                    SdLabelModule,
                    SdUploadFileModule,
                    SdDateRangeModule,
                    SdDateModule,
                    SdMonthModule,
                    SdDateFullModule,
                    SdDateTimeModule,
                    SdTimeModule,
                    SdButtonModule,
                    SdAutocompleteModule,
                    SdInputModule,
                    SdInputCurrencyModule,
                    SdInputNumberModule,
                    SdSelectModule,
                    SdSelectEditorModule,
                    SdEditorModule,
                    SdSwitchModule,
                    SdRadioModule,
                    SdChipModule,
                    SdTextareaModule,
                    SdCheckboxModule,
                    SdUtilityModule,
                    SdQuickActionModule,
                    SdBadgeModule,
                    SdTimelineModule,
                    SdModalResizableModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { SdFormModule };
//# sourceMappingURL=sd-angular-core-query-builder.js.map
