import { ChangeDetectorRef, EventEmitter, OnInit } from '@angular/core';
import { SdFilterOperator, SdGridMaterialColumn } from '../../models/grid-column.model';
export declare class SdColumnInlineFilter implements OnInit {
    #private;
    private ref;
    value: any;
    _value(value: any): void;
    inlineSymbol: string;
    set _inlineOperator(inlineOperator: SdFilterOperator);
    inlineOperatorChange: EventEmitter<SdFilterOperator>;
    operatorChange: EventEmitter<SdFilterOperator>;
    columnFilter: Record<string, any>;
    set _columnFilter(columnFilter: Record<string, any>);
    operators: {
        value: SdFilterOperator;
        symbol?: string;
        display: string;
    }[];
    column: SdGridMaterialColumn;
    set _column(column: SdGridMaterialColumn);
    filterChange: EventEmitter<any>;
    constructor(ref: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onFilterChange: () => void;
    onChangeOperator: (operator: {
        value: SdFilterOperator;
        symbol?: string;
        display: string;
    }) => void;
}
