import { ChangeDetectorRef } from '@angular/core';
import { SdModal } from '@sd-angular/core/modal';
import { SdGridMaterialColumn } from '../../models/grid-column.model';
import { SdGridMaterialExternalFilter, SdGridMaterialFilterRegister } from '../../services/grid-filter/grid-filter.model';
import { SdMaterialFilterDefDirective } from '../../directives/sd-material-filter-def.directive';
export declare class SdPopupFilter {
    #private;
    private cdRef;
    modal: SdModal;
    set filterRegister(value: SdGridMaterialFilterRegister);
    externalFilters: SdGridMaterialExternalFilter[];
    externalFilter: Record<string, any>;
    inlineExternal: Record<string, boolean>;
    columns: SdGridMaterialColumn[];
    columnFilter: Record<string, any>;
    inlineColumn: Record<string, boolean>;
    filterDefs: SdMaterialFilterDefDirective[];
    filterDef: Record<string, any>;
    inlineFilterDef: Record<string, boolean>;
    constructor(cdRef: ChangeDetectorRef);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    open: () => void;
    close: () => void;
    onApply: () => void;
    onClear(): void;
}
