import { SdSettingService } from '@sd-angular/core/setting';
import { SdGridMaterialOption } from '../models/grid-option.model';
import { SdGridConfiguration, SdGridConfigurationCache, SdGridConfigurationResult } from '../models/grid-config.model';
import { SdMaterialSubInformationDefDirective } from '../directives/sd-material-sub-information-def.directive';
import { ISdGridMaterialConfiguration } from '../models/grid-configuration.model';
export declare class SdGridConfigurationService {
    #private;
    private settingService;
    gridMaterialConfiguration: ISdGridMaterialConfiguration;
    constructor(settingService: SdSettingService, gridMaterialConfiguration: ISdGridMaterialConfiguration);
    init: (key: string, gridOption: SdGridMaterialOption) => SdGridConfigurationCache;
    generateConfigurationResult: (configuration: SdGridConfiguration, gridOption: SdGridMaterialOption, sdSubInformation: SdMaterialSubInformationDefDirective) => SdGridConfigurationResult;
}
