import { SdSettingService } from '@sd-angular/core/setting';
import { SdGridMaterialExternalFilter, SdGridMaterialFilterOption, SdGridMaterialFilterRegister } from './grid-filter.model';
import { SdGridMaterialColumn } from '../../models/grid-column.model';
import { SdMaterialFilterDefDirective } from '../../directives/sd-material-filter-def.directive';
export declare class SdGridFilterService {
    #private;
    private settingService;
    constructor(settingService: SdSettingService);
    register: (filter: SdGridMaterialFilterOption, args: {
        id: string;
        columns: SdGridMaterialColumn[];
        externalFilters: SdGridMaterialExternalFilter[];
        filterDefs: SdMaterialFilterDefDirective[];
    }) => SdGridMaterialFilterRegister;
}
