import { OnInit, EventEmitter } from '@angular/core';
import { SdModal } from '@sd-angular/core/modal';
import { SdGridOption, SdGridColumn, GridItem } from '../../grid.model';
export declare class SdGridPopupEditor implements OnInit {
    modal: SdModal;
    save: EventEmitter<GridItem>;
    columns: SdGridColumn[];
    gridOption: SdGridOption;
    item: GridItem;
    isModified: boolean;
    constructor();
    ngOnInit(): void;
    open: (item: GridItem, columns: SdGridColumn[], isModified?: boolean) => void;
    onCancel: () => void;
    onSave: () => void;
}
