import { OnInit } from '@angular/core';
import { MatDialogRef } from '@angular/material/dialog';
import { ImagePreview } from '../models/image-preview.model';
import { SdModal } from '@sd-angular/core/modal';
export interface Data {
    currentImage: Partial<ImagePreview> | string;
    images: Array<Partial<ImagePreview>>;
}
export declare class ImagePreviewSdmodalComponent implements OnInit {
    #private;
    dialogRef: MatDialogRef<ImagePreviewSdmodalComponent>;
    data: Data;
    popup: SdModal;
    imageList: any[];
    imageOrgWidthList: any[];
    imageListTotal: number;
    imageCurrent: string;
    imageCurrentIndex: number;
    imageCurrentPercent: number;
    imageCurrentWidth: number;
    constructor(dialogRef: MatDialogRef<ImagePreviewSdmodalComponent>, data: Data);
    ngOnInit(): void;
    imageGalleryBoxPrev: () => void;
    imageGalleryBoxNext: () => void;
    imageGalleryBoxZoomIn: () => void;
    imageGalleryBoxZoomOut: () => void;
    imageGalleryBoxCalculateWidth: () => void;
}
