import { ComponentFactoryResolver, ApplicationRef, Injector, AfterViewInit, OnDestroy, EventEmitter, ChangeDetectorRef } from '@angular/core';
import { CdkPortal } from '@angular/cdk/portal';
import { SdLoadingService } from '@sd-angular/core/loading';
export declare class SdModalResizable implements AfterViewInit, OnDestroy {
    #private;
    private cfr;
    private ar;
    private injector;
    private ref;
    private loadingService;
    id: string;
    portal: CdkPortal;
    editable: boolean;
    width: string;
    editingChanged: EventEmitter<boolean>;
    isEditing: boolean;
    isOpened: boolean;
    isHover: boolean;
    isLoading: boolean;
    isMinium: boolean;
    isFullscreen: boolean;
    constructor(cfr: ComponentFactoryResolver, ar: ApplicationRef, injector: Injector, ref: ChangeDetectorRef, loadingService: SdLoadingService);
    ngAfterViewInit(): void;
    open: () => void;
    close: () => void;
    minium: () => void;
    maxium: () => void;
    changeFullScreen: () => void;
    startLoading: () => void;
    stopLoading: () => void;
    ngOnDestroy(): void;
    toggleEditable(): void;
}
