export declare class SdPdfService {
    #private;
    constructor();
    merge: (urls: string[], option?: PDFMergeOption) => Promise<Blob>;
}
export interface IExportInfo {
    data: any[];
    sheetName?: string;
    fileName?: string;
}
export interface PDFMergeOption {
    download?: boolean;
    isInsertFooter?: boolean;
    footerOption?: FooterOption;
}
export interface FooterOption {
    offsetX?: number;
    offsetY?: number;
    size?: number;
    font?: string;
}
