import { ComponentFactoryResolver, ApplicationRef, Injector, AfterViewInit, OnDestroy, EventEmitter, ChangeDetectorRef } from "@angular/core";
import { CdkPortal } from "@angular/cdk/portal";
import { SdLoadingService } from "@sd-angular/core/loading";
export declare class SdSideDrawer implements AfterViewInit, OnDestroy {
    #private;
    private cfr;
    private ar;
    private injector;
    private ref;
    private loadingService;
    id: string;
    portal: CdkPortal;
    title: string;
    editable: boolean;
    width: string;
    noCloseButton: boolean;
    set _noCloseButton(val: boolean | '');
    noCloseClickOutSide: boolean;
    set _noCloseClickOutSide(val: boolean | '');
    alwaysDisplayBackDrop: boolean;
    set _alwaysDisplayBackDrop(val: boolean | '');
    editingChanged: EventEmitter<boolean>;
    sdClosed: EventEmitter<any>;
    isEditing: boolean;
    isOpened: boolean;
    alreadyOpen: boolean;
    isHover: boolean;
    isLoading: boolean;
    constructor(cfr: ComponentFactoryResolver, ar: ApplicationRef, injector: Injector, ref: ChangeDetectorRef, loadingService: SdLoadingService);
    ngAfterViewInit(): void;
    open: () => void;
    close: () => void;
    startLoading: () => void;
    stopLoading: () => void;
    ngOnDestroy(): void;
    toggleEditable(): void;
}
