import { ChangeDetectorRef, Compiler, Injector, OnDestroy } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { SdNotifyService } from '@sd-angular/core/notify';
import { SdTab } from '../../models/tab-router.model';
import { SdTabRouterService } from '../../services/tab-router.service';
import { SdTabRouterNavComponent } from '../tab-router-nav/tab-router-nav.component';
import { SdTabDecoratorService } from '../../services/tab-decorator.service';
export declare class SdTabRouterOutletComponent implements OnDestroy {
    #private;
    private router;
    private activatedRoute;
    private cd;
    private injector;
    private compiler;
    private tabDecoratorService;
    private tabRouterService;
    private sdNotifyService;
    tabRouterNav: SdTabRouterNavComponent;
    tabs: SdTab[];
    constructor(router: Router, activatedRoute: ActivatedRoute, cd: ChangeDetectorRef, injector: Injector, compiler: Compiler, tabDecoratorService: SdTabDecoratorService, // KHÔNG XÓA
    tabRouterService: SdTabRouterService, sdNotifyService: SdNotifyService);
    ngOnDestroy(): void;
    tabTrackBy: (index: number, tab: SdTab) => string;
}
