import { Type } from '@angular/core';
export interface SdTabInfo {
    name: string;
    initialName?: string;
    tooltip?: string;
    color?: string;
}
export interface SdTab {
    component: Type<any>;
    injector?: any;
    key: string;
    isActive: boolean;
    url: string;
    params?: {
        [key: string]: string | number;
    };
    queryParams?: {
        [key: string]: string | number;
    };
    data?: Record<string, any>;
    overrideTabInfo?: SdTabInfo;
    tabInfo?: SdTabInfo;
}
