import { ChangeDetectorRef } from '@angular/core';
import { SdModal } from '@sd-angular/core/modal';
import { SdTableColumn } from '../../models/table-column.model';
import { SdTableExternalFilter, SdTableFilterRegister } from '../../services/table-filter/table-filter.model';
import { SdTableFilterDefDirective } from '../../directives/sd-table-filter-def.directive';
export declare class SdPopupFilter {
    #private;
    private cdRef;
    modal: SdModal;
    set filterRegister(value: SdTableFilterRegister);
    externalFilters: SdTableExternalFilter[];
    externalFilter: Record<string, any>;
    inlineExternal: Record<string, boolean>;
    columns: SdTableColumn[];
    columnFilter: Record<string, any>;
    inlineColumn: Record<string, boolean>;
    filterDefs: SdTableFilterDefDirective[];
    filterDef: Record<string, any>;
    inlineFilterDef: Record<string, boolean>;
    constructor(cdRef: ChangeDetectorRef);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    open: () => void;
    close: () => void;
    onApply: () => void;
    onClear(): void;
}
