import { InjectionToken } from '@angular/core';
import { SdFilterOperator, SdTableColumn } from './table-column.model';
export interface ISdTableConfiguration {
    filter?: {
        quickFilter?: boolean;
        operator?: {
            defaultListString?: SdFilterOperator[];
            defaultListNumber?: SdFilterOperator[];
            defaultListDate?: SdFilterOperator[];
            defaultListValues?: SdFilterOperator[];
            defaultOperator?: {
                [key in SdTableColumn['type']]?: SdFilterOperator;
            };
        };
    };
    paginate?: {
        pageSize?: number;
        pages?: number[];
    };
    translate?: boolean;
}
export declare const DEFAULT_TABLE_CONFIG: ISdTableConfiguration;
export declare const TABLE_CONFIG: InjectionToken<ISdTableConfiguration>;
