import { SdSetting, SdSettingService } from '@sd-angular/core/setting';
import { SdTableOption } from '../models/table-option.model';
import { SdTableConfiguration, SdTableConfigurationResult } from '../models/table-option-config.model';
import { ISdTableConfiguration } from '../models/table-configuration.model';
export declare class SdTableConfigurationService {
    #private;
    private settingService;
    gridMaterialConfiguration: ISdTableConfiguration;
    constructor(settingService: SdSettingService, gridMaterialConfiguration: ISdTableConfiguration);
    loadConfiguration: (option: SdTableOption) => SdTableConfiguration;
    loadConfigurationResult: (option: SdTableOption, configuration: SdTableConfiguration) => SdTableConfigurationResult;
    init: (gridOption: SdTableOption) => SdSetting<SdTableConfiguration>;
}
