import { SdSettingService } from '@sd-angular/core/setting';
import { SdTableExternalFilter, SdTableOptionFilter, SdTableFilterRegister } from './table-filter.model';
import { SdFilterOperator, SdTableColumn } from '../../models/table-column.model';
import { SdTableFilterDefDirective } from '../../directives/sd-table-filter-def.directive';
export declare class SdTableFilterService {
    #private;
    private settingService;
    constructor(settingService: SdSettingService);
    register: (filter: SdTableOptionFilter, args: {
        id: string;
        columns: SdTableColumn[];
        externalFilters: SdTableExternalFilter[];
        filterDefs: SdTableFilterDefDirective[];
        columnOperator?: Record<string, SdFilterOperator>;
    }) => SdTableFilterRegister;
}
